/****************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* 5724-Q87 
*
* (C) Copyright IBM Corp. 2008
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
********************************************************** {COPYRIGHT-END} **/

dojo.provide("ibm.psw.wcl.dijit.WDNestedMenu");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");
dojo.require("dijit.MenuItem");
dojo.require("dijit.PopupMenuItem");
dojo.require("dijit.MenuBar");
dojo.require("dijit.MenuBarItem");
dojo.require("dijit.PopupMenuBarItem");
dojo.require("dijit.MenuSeparator"); 
dojo.require("dijit.Toolbar");
dojo.require("dijit.ToolbarSeparator");
dojo.require("dijit.form.DropDownButton");
// NLS
dojo.requireLocalization("ibm.psw.wcl.dijit", "resources", null, "ROOT,cs,de,en,en-us,es,fr,hu,it,ja,ko,pl,pt-br,ru,zh-cn,zh-tw");

/******************************************************************************
* Nested DropDown Menu.
******************************************************************************/
dojo.declare("ibm.psw.wcl.dijit.WDNestedMenu", 
		[dijit._Widget, dijit._Templated],{
		menuItems : [],
		subMenus : [],
		dropDownList: "",
		templateString: 
			"<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">"+
				"<tr>"+
					"<td>"+
						"<div dojoAttachPoint=\"menuContainer\" style=\"height:35px; width:135px; overflow:hidden;\">"+
						"</div>"+
					"</td>"+
					"<td>"+
						"<div dojoAttachPoint=\"attachButton\" class=\"goButton\">"+
						"</div>"+
					"</td>"+
				"</tr>"+
			"</table>",
		comboButton:null,
		rootMenu:null,
		button:null,
		createButton: false,
		goButton: null,
		itemClicked: null,
		messageItem: null,
			
		constructor: function () {
			this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");	
		},
	  
		postCreate: function()
		{   
			this.inherited( arguments );
			this.rootMenu = new dijit.Menu({
				style: "display: none;"
			});
			this.button =  new dijit.form.DropDownButton({
				label: this.resources_.SELECT_ACTION,
				dropDown: this.rootMenu
			});
			dojo.connect(this.button, 'onClick', dojo.hitch(this.button, '_onArrowClick'));
			dojo.connect(this.button, 'onKeypress', dojo.hitch(this.button, '_onArrowClick'));
			if(this.createButton === true){
				this.goButton = new dijit.form.Button({
					label: this.resources_.GO_LABEL, 
					name: this.resources_.GO_BUTTON,
					title: this.resources_.GO_BUTTON
				}, this.attachButton);
				dojo.connect(this.goButton, 'onClick', dojo.hitch(this, this.onButtonClick));
			}
			this.menuContainer.appendChild(this.button.domNode);
			this.populateMenu(this.rootMenu);
			//Fix for Uniformity of Select Action over Different Browsers and Platforms
			if(dojo.isIE){
				dojo.style(this.menuContainer,"width","150px");
				if(this.isPortlet){
					dojo.addClass(this.menuContainer.childNodes[0].childNodes[0].childNodes[0].childNodes[0],"dijitButtonNode");
					dojo.style(this.menuContainer.childNodes[0].childNodes[0].childNodes[0],"border","0px solid #ffffff");
				}
				dojo.removeClass(this.menuContainer.childNodes[0].childNodes[0],"dijitRight");
			} else {
				dojo.style(this.menuContainer,"width","135px");
			}
			dojo.removeClass(this.menuContainer.childNodes[0],"dijit dijitReset dijitLeft");
			dojo.removeClass(this.menuContainer.childNodes[0].childNodes[0],"dijitReset dijitRight dijitInline");
			dojo.removeClass(this.menuContainer.childNodes[0].childNodes[0].childNodes[0],"dijitReset dijitButtonNode");
			dojo.removeClass(this.menuContainer.childNodes[0].childNodes[0].childNodes[0].childNodes[0],"dijitReset dijitStretch dijitButtonContents");
			dojo.removeClass(this.menuContainer.childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[1],"dijitReset dijitInline");
			dojo.style(this.menuContainer.childNodes[0],"paddingTop","8px");
			dojo.style(this.menuContainer.parentNode.parentNode.childNodes[1].childNodes[0],"paddingTop","1px");
			dojo.style(this.menuContainer.childNodes[0].childNodes[0].childNodes[0].childNodes[0],"backgroundColor","#ffffff");
			dojo.style(this.menuContainer.childNodes[0].childNodes[0].childNodes[0].childNodes[0],"border","1px solid #000000");
		},
		
		populateMenu: function(menu)
		{		 
			var  model = this.dropDownList;
			if ( model !== undefined && model !== null )
			{
				this.addItemsToMenu( menu, model );
				menu.startup();
			}               
		},
		
		addItemsToMenu:function( parent, items )
		{
			var params;
			var subMenuIndex;
			var menuItemIndex;		  
			for ( var i in items )
			{
				if ( items[i].submenu_items ){
					subMenuIndex = this.subMenus.length;
					this.subMenus[ subMenuIndex ] = new dijit.Menu();
					params = 
					{
						popup: this.subMenus[ subMenuIndex ]
					};
					dojo.mixin( params, items[i] );
					parent.addChild( new dijit.PopupMenuItem( params ) );
					parent.startup();
					this.addItemsToMenu( this.subMenus[ subMenuIndex ], items[i].submenu_items );          
				} else {
					if (items[i].id && items[i].id.substring(0,9) === "Separator"){
						items[i].actionID = "_separator_";
					} else if (items[i].id && !items[i].actionID){
						items[i].actionID = items[i].id;
					}
					if ( items[i].actionID === "_separator_" ){
						menuItemIndex = this.menuItems.length;
						this.menuItems[ menuItemIndex ]  = new dijit.MenuSeparator();
						parent.addChild( this.menuItems[ menuItemIndex ] );
					} else {
						params = {
							adapter: this,
							onClick: function() { 
								this.adapter.onMenuItemClick( this ); 
							}
						};
						dojo.mixin( params, items[i] );
						menuItemIndex = this.menuItems.length;
						this.menuItems[ menuItemIndex ] = new dijit.MenuItem( params );
						parent.addChild( this.menuItems[ menuItemIndex ] );
						parent.startup();
					}
				}         
			}
		},
		
		onMenuItemClick: function( menuItem ){ 
			this.itemClicked = menuItem.name;
			var messageItem = dojox.json.query("=$.[?id='"+ menuItem.id +"']", this.dropDownList);
			this.messageItem = dojox.json.query("[0].message", messageItem);
			this.button.setAttribute("label", menuItem.label);
		},
		
		onItemClick: function(){
			return this.itemClicked;
		},
		
		onButtonClick: function(){
			return this.itemClicked;
		},
		
		message: function(){
			return this.messageItem;
		},
		
		reset: function(){
			this.itemClicked = null;
			this.messageItem = null;
			this.button.setAttribute("label", this.resources_.SELECT_ACTION);
		},
		
		destroy: function(){
			// destroy all children
			var widgetArr = this.rootMenu.getChildren();
			dojo.forEach(widgetArr, function(child){
				child.destroyRecursive();
			});
			this.inherited("destroy", arguments);
		}	
	}
); 


