/****************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* 5724-Q87 
*
* (C) Copyright IBM Corp. 2008
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
********************************************************** {COPYRIGHT-END} **/

dojo.provide("ibm.psw.wcl.dijit.WDProgressBar" );

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.ProgressBar"); 
dojo.require("dojo.dnd.Moveable"); 
dojo.require("dijit.form.Button");
dojo.require("dojox.json.query");

//dojo.requireLocalization("ibm.psw.wcl.dijit", "resources");


/******************************************************************************
* Busy Pane that blocks all user input and shows progress message.
******************************************************************************/
dojo.declare("ibm.psw.wcl.dijit.WDProgressBar", [dijit._Widget, dijit._Templated],
{
  processingImageSrc: dojo.moduleUrl("ibm.psw.wcl.dijit","themes/images/progress22.gif"),
  global: null,
  requestTimeout: 30000,
  progressBar: null,  
  cancelButton:null,
  cancellable:false,
  progressCancelled:false,
  progressIndicatorType : 0,
  maximumValue : 100,
  progress  : 0,
  width : "150px",
  height : "50px",
  msgWidth:"",
  lastRequestStatusOk:false,
  templatePath: dojo.moduleUrl("ibm.psw.wcl.dijit", "templates/WDProgressBar.html"),
  lastQueryResult:"",
  
  preamble: function(){  //Called before Constructor
			if(arguments[0].cancellable !==null && arguments[0].cancellable== true)
				this.cancelButton=true;
			else
				this.cancelButton=false;	
			
	},
  
  constructor: function () {
	 
  },
  
  postCreate: function()
  {
   
    this.inherited( arguments );
	if(this.progressIndicatorType==1) { // 1: Determinate, 0: Undeterminate
	  //console.info("Progress is Determinate");
	  this.progressBar = new dijit.ProgressBar({width:'100%',height:'5px', 	
		  report:function(percent){	
		  return '';
		}},this.progressBarNode);
	  
      if(this.cancelButton ==true) {	  
	    this.cancelButton =new dijit.form.Button({label: "cancel",name: "cancel"},this.progressBarCancel);
	     dojo.connect(this.cancelButton, 'onClick',dojo.hitch(this, this.onCancelClick) );
	 }
	}
	this.calculateMsgWidth();
	//dojo.query(".dijitProgressBarTile", this.progressBar).addClass("anim");
	this.hide();
  },
  calculateMsgWidth :function() {
		var strWidth = this.width.substring(0,this.width.length-2); // get numeric width 
		var totalWidth = parseInt(strWidth);
		var animwidth = .1 * totalWidth;
		var animwidth =animwidth+5;
		var	msgWidthtemp = totalWidth-(animwidth+20);
		this.msgWidth=msgWidthtemp+"px";
		 
  },
   doProgress : function() {   // Trigger for start displaying the progress
      console.info("doProgress");
      this.show();
	  //if(this.progressIndicatorType==1) 
	   this.getProgress(); 
	   var progressfunc =dojo.hitch(this,this.checkProgress1);
      // setTimeout(progressfunc,1000);
  },
  checkProgress1:function () {
    var progressfunc =dojo.hitch(this,this.checkProgress2);
    if(this.progress < 100)
    setTimeout(progressfunc,1000);
  },
  checkProgress2:function () {
    var progressfunc =dojo.hitch(this,this.checkProgress1);
    if(this.progress < 100){
      if(this.lastRequestStatusOk==false)
        this.getProgress();
      setTimeout(progressfunc,1000);
    }
    
  },	  
  getProgress :function () {
	console.info("getProgress");
	 var kw = {
             content:   {
                           command: "getProgress"
                           
                        },
             timeout:   this.requestTimeout,
             onResponse:{
                           callback: dojo.hitch(this, this.progressCallBack)
                        }
       };
     this.lastRequestStatusOk=false;  
     var server =  ibm.psw.wcl.dojo.Server.getSingleton();
	 server.get( kw );
	 
	},
	
 progressCallBack : function  (data){
		console.info("progressCallBack data");
		
		this.lastRequestStatusOk=true;
		 if( this.progress < 100 ) {  //  Progress% is less than 100 and progress is not cancelled
		  
			 var progressStr = dojox.json.query("=$..progress",data);
		     var progressMsg = dojox.json.query("=$..message",data);
		     var cancelSupported = dojox.json.query("=$..CancelSupported",data);
			 console.info(">>> "+progressStr[0]+"%");  
			 /*if(cancelSupported[0] !== 'true')
				 this.cancelButton.attr("enabled",false); */
			var y = parseInt(progressStr[0]);
		   	if (!isNaN(y)) {
		   		this.progress = y;
		   		if(this.progressIndicatorType==1) {
		   		this.progressBar.update({ maximum:this.maximumValue, progress: this.progress });  //Update the progressbar
		   		this.messageArea.innerHTML=progressMsg[0];
		   		}
		   	}
		    if(	this.progressCancelled==false) {
		    	var progressfunc =dojo.hitch(this,this.getProgress);
		    	setTimeout(progressfunc,100);
		    }
		    // Repeat the loop untill 100% is done
		    this.lastQueryResult =data;
		 }
		 else if(this.progress>=100) {   // Progress Process is completed
		  this.afterCompletion();
		 } 
		
 },
 
 afterCompletion : function () {
		
		//Reset Progress Data
	    this.progressCancelled=false;
	    this.progress=0;
	   if(this.progressIndicatorType==1) 
	    this.progressBar.update({ maximum:this.maximumValue, progress: this.progress });
	    this.messageArea.innerHTML='';
	    this.hide();
  },
 	  
  updateProgress : function(progressParam)
  {
    if(this.progressIndicatorType==1) { //Updates Progress Only If type is Determinate otherwise ignore
		this.progress=progressParam;
		this.progressBar.update({ maximum:this.maximumValue, progress: this.progress });
	}
  },
  onCancelClick: function(/* Event */e){
	console.info("onCancelClick");   
	
	  var kw = {
             content:   {
                           command: "cancel"
                          
                        },
             timeout:   this.requestTimeout,
             onResponse:{
                           callback: dojo.hitch(this, this.cancelCallBack)
                        }
       };
		
     
     var cancelSupported = dojox.json.query("=$..CancelSupported",this.lastQueryResult);
      if(cancelSupported[0]=='true') {
           this.progressCancelled=true;
	    	ibm.psw.wcl.dojo.Server.getSingleton().get( kw );
	    	
	    }	
	    else {	//Cancel Operation is not supported by Server
	        
	    	this.progressCancelled=false;
	    	alert("Current Operation Cannot be cancelled!");
	    }
	
  },
  cancelCallBack : function(data) {
        console.info("cancelCallBack");
	   console.dir(data);  
	    var cancelSupported = dojox.json.query("=$..CancelSupported",data);
	    var progressMsg = dojox.json.query("=$..message",data);
	   
	   if(cancelSupported[0]=='true') {
	    	this.hide();
	    	 var callback = dojo.hitch(this, this.afterCompletion);
		    setTimeout("alert('"+progressMsg[0] +"')",500);
		   	setTimeout(callback,1000);
	    	
	    }	
	    else {	//Cancel Operation is not supported by Server
	    	this.progressCancelled=false;
	    	alert(progressMsg[0]);
	    }
  },
  
   setMessage:function(msg){
  
	  this.messageArea.innerHTML=msg;
  },	  
  getProgressIndicatorType : function()
  {
    return this.progressIndicatorType;
  },
 /*  setProgressIndicatorType : function(type)
  {
    this.progressIndicatorType=type;
  },*/
  getWidth : function()
  {
    return this.width;
  },
   setWidth : function(widthParam)
  {
    this.width=widthParam;
	this.stylePage();
  },
  getHeight  : function()
  {
    return this.height;
  },
   setHeight : function(heightParam)
  {
    this.height=heightParam;
	this.stylePage();
  },
  stylePage: function () {
	     //console.log ("in BusyPane.show.  covering whole page/frame.");
	    dojo.style (this.domNode, "top", "0");
	    dojo.style (this.domNode, "align", "center");
	    //dojo.style (this.progressBarTable, "width", this.width);
		dojo.style (this.progressBarTable, "height", this.height);  
		dojo.style (this.rootDiv, "width", this.width);
		var msgWidth = this.calculateMsgWidth();
		dojo.style (this.msgareaDiv, "width", this.msgWidth); 
			
 },
  show: function(  )
  {
	this.stylePage();
	this.domNode.style.display="";
  },
 	  
  hide: function() {
    this.domNode.style.display="none";
  }
}); 


