dojo.require("dijit.Dialog");
dojo.require("ibm.psw.wcl.dojo.Server");

dojo.provide("ibm.psw.wcl.dijit.WDSecondaryWindow");

dojo.declare("ibm.psw.wcl.dijit.WDSecondaryWindow",
			 dijit.Dialog,
			 {
			 	global:null,
			 	dialogID:null,
			 	model: null,
			 	isModel: true,
			 	width: "400px",
			 	height: "300px",
			 	requestTimeout: 30000,
			 	
			 		postCreate: function (){
				 	//call super
				 	//console.debug("postCreate");
				 	//console.debug(arguments);
					
				 	this.initSecondaryWindowParams();
				 	this.inherited(arguments);
				 	//console.debug("parent node: "+this.domNode.parentNode);
				 	var parent = this.domNode.parentNode;
				 	parent.appendChild(this.domNode);
				 	this.closeButtonNode.style.display = "none";		
				 					 					      				
				 },
			 
			 	initSecondaryWindowParams: function() {
			 		if((this.width != undefined) && (this.height != undefined)){
			 		
			 			
						var viewport = dijit.getViewport();
						//console.debug("viewport width: "+ viewport.w+ " viewport height: "+viewport.h);
						if(this.width >= viewport.w || this.height >= viewport.h){
							dojo.style(this.domNode, {
								width: Math.min(this.width, Math.floor(viewport.w * 0.75))+"px",
								height: Math.min(this.height, Math.floor(viewport.h * 0.75))+"px",
								overflow: "auto",
								position: "relative"	// workaround IE bug moving scrollbar or dragging dialog
							});
						}else{
							//console.debug("here in else");
							dojo.style(this.domNode, {
							width: this.width,
							height: this.height,
							overflow: "auto",
							position: "relative"
							});
							var mb = dojo.marginBox(this.domNode);
							//console.debug("width: "+mb.w +" height: "+ mb.h);
						}
			 		}else{
			 			var mb = dojo.marginBox(this.domNode);
						var viewport = dijit.getViewport();
						
						if(mb.w >= viewport.w || mb.h >= viewport.h){
							dojo.style(this.domNode, {
								width: Math.min(mb.w, Math.floor(viewport.w * 0.75))+"px",
								height: Math.min(mb.h, Math.floor(viewport.h * 0.75))+"px",
								overflow: "auto",
								position: "relative"	// workaround IE bug moving scrollbar or dragging dialog
							});
						}
						
			 		}
			 	
			 	},
			 	startup: function() {
					//console.info ("enter startup");
					this.makeSecondaryWindow();
						
					//console.info ("exit startup");
					this.inherited(arguments);
				},
				
			 	makeSecondaryWindow: function() {
			 		this.getContent();
			 		
			 	},
			 	getContent: function(){
			 		//console.debug("getContent not yet implemented!!!");
			 	},
			 	execute: function( arguments){
			 		//console.debug("on submit");
			 		var dialogFields = this.getDialogJSONObj(arguments);
			 		this.updateParent(dialogFields);
			 	},
			 	
			 	updateParent: function( dialogFields){
			 		//console.debug("inside updateParent  server side update");
			 		//var portletNamespace = this.global.namespace;
				 	 var kw = {
                    			content:   {
                                  command: "updateParent",
                                  model: "WSecondaryWindow",
                                  arg_dialogFields: dialogFields
                                 
						
                                 },
                    			timeout:   this.requestTimeout,
                   			    onResponse:{
                                  callback: dojo.hitch(this, this.updateParentCallback)
                               	}
                 			  };
				 	 
				 	ibm.psw.wcl.dojo.Server.getSingleton().get( kw );
				 	
				 },
				 
				 
				 getDialogJSONObj: function(arguments){
				 	var JSONDialogFields = null
				 	
				 	if(arguments != null){
				 		//console.debug("JSON obj: "+ dojo.toJson(arguments, true));
				 		JSONDialogFields = dojo.toJson(arguments, true);
				 		
				 	}
				 	
				 	return JSONDialogFields;
				 },
				 
				 updateParentCallback: function(response,ioArgs){
				 	console.debug("updateStatusCallBack: update successfull...."+ response);
				 	
				 	updateParent(response);
				 }
			 
			 
			 
			 
			 
			 }
			 
			 
			 );
