dojo.provide("ibm.psw.wcl.dijit.WDSortOptions");
dojo.require("dijit.form.ComboBox");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

// NLS
dojo.requireLocalization("ibm.psw.wcl.dijit", "resources", null, "ROOT,cs,de,en,en-us,es,fr,hu,it,ja,ko,pl,pt-br,ru,zh-cn,zh-tw");

dojo.declare (
	"ibm.psw.wcl.dijit.WDSortOptions", 
    [ dijit._Widget, dijit._Templated ],
{
	table: null,
	isSelect: null,
	widgetsInTemplate: true,
	templateString:
					"<table width=\"20%\" align=\"right\">"+
						"<tr>"+
							"<td>"+
								"<select dojoAttachPoint=\"sortColumnName\" class=\"sort\" name=\"sortColumnName\" value=\"\" style=\"font-size:x-small; font:verdana\" dojoAttachEvent=\"onchange:_onChange,onKeypress:_onKeyPress\">"+
								"</select>"+
							"</td>"+
							"<td width=\"5\">"+
							"</td>"+
							"<td>"+
								"<select dojoAttachPoint=\"sortType\" class=\"sort\" name=\"sortType\" value=\"\" style=\"font-size:x-small; font:verdana\" dojoAttachEvent=\"onchange:_onChange,onKeypress:_onKeyPress\">"+								   
								   "<option value=\"0\"> ${resources_.ASCENDING}</option>"+
								   "<option value=\"1\"> ${resources_.DESCENDING} </option>"+
								"</select>"+
							"</td>"+
						"</tr>"+
					"</table>",
	
	constructor: function () {
		this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");
		
	},
	postCreate: function () {
		this.inherited ("postCreate", arguments);
		this.isSelect = this.table.grid.selectCol;
		this.addSortColumnName(this.table.grid.layout.cells);
	},
	
	addSortColumnName: function(columns){
		
		var column = null;	

        optionElement = document.createElement('option');
		optionElement.value = "-1";
		optionElement.innerHTML = "";
		this.sortColumnName.appendChild(optionElement);		
        
		
		for (var j in columns) {
			if (j) {
				column = columns[j];
				
				if(column.name === 'Select')
				continue;
				if (!column.hidden) {
					optionElement = document.createElement('option');
					optionElement.value = column.field;
					optionElement.innerHTML = column.name;
					this.sortColumnName.appendChild(optionElement);
					
				} else{
					
				}
			}
		}
		
	},
	
	getSortColumnId: function(){
	   
		return this.sortColumnName.value;
	},
	
	getSortType: function(){
		return this.sortType.value;
	},
	
	_onClick: function(){
		//console.debug("onClick");
	},
				
	_onChange: function(){
		//console.debug("onChange");
	},
				
	_onKeyPress: function(){
		//console.debug("onKeydown");
	},
	
	destroy: function () {
		this.inherited (arguments);
	}
	
});