/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.psw.wcl.dijit.WDTable"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.psw.wcl.dijit.WDTable"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2007, 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dojox.data.ClientFilter");
dojo.require("dojox.data.QueryReadStore");
dojo.require("dojox.json.query");
dojo.require("dojo.parser");
dojo.require("ibm.psw.wcl.dijit.WDQueryReadStore");
dojo.require("ibm.psw.wcl.dijit.WDServiceStore");
dojo.require("ibm.psw.wcl.dijit.WDJsonRestStore");
dojo.require("ibm.psw.wcl.dijit.WDJsonQueryRestStore");
dojo.require("ibm.psw.wcl.dijit.WDataGrid");

dojo.require("dijit.layout.LayoutContainer");
dojo.require("dijit.layout.ContentPane" );

dojo.require("ibm.psw.wcl.dojo.Global");
dojo.require("ibm.psw.wcl.dojo.Server");
//dojo.require("ibm.psw.wcl.dijit.WTableTitleBar");
dojo.require("ibm.psw.wcl.dijit.WDTableToolbar");
dojo.require("ibm.psw.wcl.dijit.WDTableFooter");
dojo.require("ibm.psw.wcl.dijit.WDTableRefreshButton");
dojo.require("ibm.psw.wcl.dijit.WDButton");
dojo.require("ibm.psw.wcl.dijit.WDTableSearchField");
dojo.require("ibm.psw.wcl.dijit.WDContextMenu");
dojo.require("ibm.psw.wcl.dijit.WDTableOptionsDialog");
dojo.require("ibm.psw.wcl.dijit.WDTableFilterDialog");
dojo.require("ibm.psw.wcl.dijit.WDTableSortDialog");
dojo.require("ibm.psw.wcl.dijit.WDTablePageRowSpinner");
dojo.require("ibm.psw.wcl.dijit.WDNestedMenu");
dojo.require("dojox.grid.cells.dijit");
dojo.require("dojo.date.locale");

// NLS
dojo.requireLocalization("ibm.psw.wcl.dijit", "resources", null, "ROOT,en,en-us,es,fr,hu,it,ja,ko,pl,pt-br,ru,zh-cn,zh-tw");

dojo.provide("ibm.psw.wcl.dijit.WDTable");

/******************************************************************************
* This container places the search bar and toolbar around a given 
* dojox.grid.Grid 
*
* Authors: Joseph Firebaugh, Joshua Allen, Ken Parzygnat
******************************************************************************/
dojo.declare("ibm.psw.wcl.dijit.WDTable",
			 dijit.layout.LayoutContainer,
{
	grid: null,
	gridParms: null,
	global: null,
	requestTimeout: 30000,
	defaultRowsPerPage: 5,
	_currentPage: 0,
	pagingFeature: true,
	rowsPerView: 5,
	tableID: null,
	registerTableID: null,
	autoSavePreferences : false,
	formID:null,
	gridID:null,
	width: 700,
	tableAction:null,
	sortColumnLimit: 3,
	data1: null,
	data2: null,
	/* Do you want the default buttons added to the toolbar? */
	makeDefaultButtons: true,
	
	/* Table Options is the ability to hide/show columns.  
	   Preferences are handled via the infrastructure, however
	   they must persisted by the implementing application. 
	   Hence, the table options are disabled by default.  */
	tableOptionsEnabled: false,	
	multiSelect: false,
	rowDblClick: null,
	isSelectAll: false,
	isDeselectAll: false,
	serverSideSelect: false,
	columnCount: 0,
	defaultmaxpagecache: 10,
	fixedColSpan: 0,
	selectRowIndices: null,
	selectColWidth: 43,
	selectColStyle: null,
	selectRowCount: 0,
	/*Table Actions Features Enabled/Disabled*/
	showActionListFeature: false,
	/*Go Button Features Enabled/Disabled*/
	showGoButtonActionListFeature: false,
	
	prefetchingFeature: false,
		
	/*Default Table Actions Features Enabled/Disabled*/
	exportDataFeature: false,
	toggleFilterRowFeature: true,
	editSortFeature: false,
	restoreDefaultFeature: false,
	exportDataServletPath: "",
	
	allFeatures: false,
	noFeatures: false,
	userActions: "",
	actionName: "",
	anchorValue: "",
	// open: Boolean
	//    Whether toolbar is opened or closed on first render.
	open: false,

	// duration: Integer
	//    Time in milliseconds to wipe in/wipe out toolbar
	duration: 300,
	
	_contextMenu: null,
   	_onRowContextMenuListener: null,
   	_contextMenuAdapter : null,
	cmProvider: null,
	clientRfcItems : null,      // Provide if you are providing above view structure.
	view: null,
	viewData: null,
	widgetID: null,
	renderOnce: false,
	exportDataIconClicked: false,
	isToolbarVisible: true,
	isFooterVisible: true,
	context: null,

	constructor: function () {
		this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");	
		this.lastPreferences = null;
		this.viewLoaded = false;
		this.tooltips = [];
		this.connections = [];
		this.topics = [];
		this.tableOptionsDialog = null;
		this.filterDialog = null;
		this.tableSortDialog = null;
		this.originalStructure = null;
		this.toolbar = null;
		this.footerToolbar = null;
		this.filterBar = null;
		this.footerAttach = null;
		this.pageRowControl = null;
		this.tableDropDown = null;
		this.totalRowCount = 0;
		this.filteredRows = 0;
		this.startValue = 0;
		this.countValue = this.defaultRowsPerPage;
		this.rowsPerPage = this.defaultRowsPerPage;
		this.pageSize = this.defaultRowsPerPage;
		this.query = null;
		this.dropDownMenu = null;
	},
	
	/**************************************************************************
	* Called after template has been processed.
	*
	* Lets check to see if a dojox.grid.Grid was passed in on params.  If so,
	* add it to the DOM tree and setup.
	**************************************************************************/
	postCreate: function ()	{
		//call super
		this.inherited( "postCreate", arguments );

		//
		this.gridParms = this.initializeGridParameters();
		
		//var viewport = dijit.getViewport();
		//this.width = (this.width/100) * viewport.w;
		this.domNode.style.width = this.width + "px";
		if(this.isToolbarVisible == true){
			this.cPane1 = new dijit.layout.ContentPane( { layoutAlign: "top" } );
			this.addChild( this.cPane1 );
				  
			var div = dojo.doc.createElement( 'div' );
			this.cPane1.setContent( div );
			//-----------------------------
			// Add Toolbar and filter area
			//-----------------------------
			this.filterBar = new ibm.psw.wcl.dijit.WDTableToolbar( {}, div );

			this.toolbar = this.filterBar.toolbar;

			//initialize the toolbar
			if ( this.makeDefaultButtons === true ) 
			{ 
				this.initializeToolbar(); 
			}
			if(this.showActionListFeature){
				this.toolbar.addChild (new dijit.ToolbarSeparator());
				this.dropDownMenu = this.filterBar.tableDropDown;
				this.nestedMenu();
			}
			this.searchField = this.filterBar.searchField;
			this.topics.push (dojo.subscribe (this.searchField.id + "searchInvoked", this, "onSearch"));
		}
		
		//-----------------------------
      	// Create Grid Pane            
      	//-----------------------------    
		this.gridPane = new dijit.layout.ContentPane( { layoutAlign: "client" } );
		this.gridPane.style.margin="0px";
     	this.addChild( this.gridPane );
      
      	this.gridDiv = dojo.doc.createElement( 'div' );
		dojo.addClass (this.gridDiv, "grid");
      	this.gridPane.setContent( this.gridDiv );      
		//if grid passed on params then set it
		if ( this.grid !== null )
		{
			this.setGrid( this.grid );
		}
		
		//-----------------------------
		// Create and add footer            
		//-----------------------------    
	    if(this.isFooterVisible == true){
			this.cPane2 = new dijit.layout.ContentPane( { layoutAlign: "bottom" } );
			this.addChild( this.cPane2 );
			
			div   = dojo.doc.createElement( 'div' );
			this.cPane2.setContent( div );			
			this.footerToolbar = new ibm.psw.wcl.dijit.WDTableFooter( {}, div );
			this.topics.push (dojo.subscribe ("/ibm.wcl/WDQueryReadStore#rowCountUpdated", this, "updateFooter"));//in order to synch these 2 events searching n updating footer
		}	
	},
	initializeGridParameters: function () {
		if (this.gridParms === null) {
			this.gridParms = {};
		}
		if (this.gridParms.id === undefined){
			this.gridParms.id = this.gridID;
		}
		
		
		if (this.gridParms.queryOptions === undefined){
			this.gridParms.queryOptions = {cache:true} ;
		}
		
		if (this.editSortFeature){
			this.gridParms.canSort = function(){return true};
		}else{
			this.gridParms.canSort = function(){return false};
		}
		
		if (this.gridParms.store === undefined) {
			/*this.gridParms.store = new ibm.psw.wcl.dijit.WQueryReadStore (
				{ global: this.global, tableID: this.tableID,formID: this.formID, jsId: "jsonStore", doClientPaging:false, 
				  url:this.global.controllerURL,
				  requestTimeout: this.requestTimeout 
				});*/
				
				var tableid =  this.tableID;
				var portletNamespace = this.global.namespace;
				var timeOut = this.requestTimeout;
			  
			var grService = function(query, queryOptions){
				/*console.debug("here in grService: "+ actionString);
				 console.debug("here in grService: "+ psessionkey);
				 console.debug("here in grService: "+ namespace);
				 console.debug("here in grService: "+ form.wh.value);
				 console.debug("here in grService: "+ tableid);
				 console.debug("here in grService: "+ portletNamespace);
				 console.debug("here in grService: "+ timeOut);
				 console.debug("here in grService: query:"+ query);
				 console.debug("here in grService: queryOptions:"+ queryOptions);
				 console.debug("queryOptions:is Render "+ queryOptions.isRender);*/
				queryOptions.isRender = true;
				queryOptions.cache = true;
				var jsonQuery = dojox.json.ref.toJson(query);
				var jsonQueryOptions = dojox.json.ref.toJson(queryOptions);
				var commandName = "getTableRows";
				if (queryOptions.sort != null) {
					commandName = "sortListener";
				}
				
				//console.debug("here in grService: jsonQuery:"+ jsonQuery);
				//console.debug("here in grService: jsonQueryOptions:"+ jsonQueryOptions);
				jsonQueryOptions.isRender = true;
				var kw = {
					handleAs:'json', 
					content: {
						command: commandName,
						arg_fqTableId: tableid,
						arg_portletNamespace: portletNamespace,
						query: jsonQuery,
						queryOptions: jsonQueryOptions
					},
					timeout: timeOut
				};
				
				return ibm.psw.wcl.dojo.Server.getSingleton().post(kw);
			}
				
			grService.put = function(id, value) {
				return grService.post(id, value);
			}
			grService.post = function(id, value) {
			return ibm.psw.wcl.dojo.Server.getSingleton().post(
							{
							 handleAs:'json', 
							 content:{
										command:"updateCell",
										arg_fqTableId: tableid,
										arg_portletNamespace: portletNamespace,
										id:id, 
										value:value
									},
							timeout:   this.requestTimeout
							});
			}
			grService['delete'] = function(id) {
			return ibm.psw.wcl.dojo.Server.getSingleton().get(
								{
								 url:"actionUrl.php", 
								 handleAs:'json', 
								 content:{
											command:"delete", 
											arg_fqTableId: tableid,
											arg_portletNamespace: portletNamespace,
											id:id
										},
								timeout:   this.requestTimeout
								});
			}
			
			this.gridParms.store = new ibm.psw.wcl.dijit.WDJsonQueryRestStore(
				{target:"gr", service:grService, onSet:function(item,attribute,old,value){this.save();}});
		} else {
		}
		
		this.gridParms.noDataMessage="None";
		this.gridParms.width = this.width + "px";
			
		if(this.gridParms.fastScroll === undefined)
		    this.gridParms.fastScroll = false;
			
		if(this.gridParms.selectCol === undefined)
		    this.gridParms.selectCol = true;
			
		if (this.gridParms.selectionMode === undefined) {
			this.gridParms.selectionMode = "single";
		}
		if (this.gridParms.selectionMode === "multi") {
			this.multiSelect = true;
		}
		
//		this.gridParms.query="{ name: '*' }";
		if (this.gridParms.rowsPerPage === undefined) {
			this.gridParms.rowsPerPage=this.defaultRowsPerPage;
		}
		
		this.gridParms.selectColWidth = this.selectColWidth;
		this.gridParms.selectColStyle = this.selectColStyle;
		//Uncomment it once the dojo duplicate id problem gets fixed.
		/*if (this.gridParms.rowSelector === undefined) {
			this.gridParms.rowSelector = "2px";
		}*/
		
		//change value of this.gridParms.columnReordering to true on 2009/07/09 for column reordering
		if (this.gridParms.columnReordering === undefined) {
			this.gridParms.columnReordering = true;
		}
		
		var cb = dojo.hitch(this,function(){  
			
			dojo.publish (this.id + "#LoadComplete", [ "LoadComplete" ]);
        });
        this.gridParms.loadCompleteCallback = cb;
		
		//this.gridParms.autoHeight = this.rowsPerView;

		return (this.gridParms);
	},
	startup: function() {
		if (!this.grid) {
			this.makeGrid();
		}
		//this.grid.store = new ibm.psw.wcl.dijit._ForcedPageStore(this.grid.store, this);
		if (this.autoSavePreferences) {
			this.connections.push (dojo.connect (this.grid, "_resize", this, "onResize"));
			//
		}
		
		/* Commented in order to make WCL editable table work */
		this.connections.push (dojo.connect (this.grid, "onRowClick", this, "_onRowClick"));
		this.connections.push (dojo.connect (this.grid, "onMoveColumn", this, "_onMoveColumn"));
        this.connections.push (dojo.connect (this.grid, "onCellMouseOver", this, "_onCellMouseOver"));
		
	},
	refreshTable: function() {
		this.resetGridparams();
		//this.updateFormatter();
		this.getView();
	
	},
	
	resetGridparams: function() {
		this.gridParms = this.initializeGridParameters();
		
		this.grid.columnReordering = this.gridParms.columnReordering;
		this.grid.fastScroll = this.gridParms.fastScroll;
		this.grid.selectCol = this.gridParms.selectCol;
		this.grid.selectionMode = this.gridParms.selectionMode;
		this.grid.rowsPerPage = this.gridParms.rowsPerPage;
	},
	
	makeGrid: function () {
		
		var grid = new ibm.psw.wcl.dijit.WDataGrid (this.gridParms, this.gridDiv);
		this.setGrid( grid , true );
		grid.startup();

		if (this.widgetID !== null) {
			this.query = {};
			this.query.widgetID = this.widgetID;
			this.grid.setQuery (this.query);
		}
		
		if ((this.view === undefined) || (this.view === null)) {
			
			this.getView();
		} else {
			
			this.originalStructure = this.viewData;
			
			this.setupView(this.view, this.viewData);
		}
		
		this.topics.push (dojo.subscribe (this.grid.rowSelectionChangedTopic, this, "updateFooterSelected"));
		if (this.serverSideSelect) {
			this.topics.push(dojo.subscribe(this.grid.rowSelectionChangedTopic, this, "updateServer"));
		}
		
	},
	
	setGrid: function( grid ) {
		this.grid = grid;
		if(this.isToolbarVisible == true){
			this.searchField.setTable( grid );
		}
	},
	getView: function () {
		
		var kw = {
                    content:   {
                                  command: "getTableColumns",
                                  arg_fqTableId: this.tableID,
                                  arg_portletNamespace: this.global.namespace
                               },
                    timeout:   this.requestTimeout,
                    onResponse:{
                                  callback: dojo.hitch(this, this.getViewCallback)
                               },
                    error: this.handleError
                 };
	  	
	  	if (this.tableArgs) {
	  		for (var key in this.tableArgs) {
	  			if (key) {
		            kw.content[key] = this.tableArgs[key];
	  			}	
	  		}
	  	}
	  	
        ibm.psw.wcl.dojo.Server.getSingleton().get( kw );
		
	},
	
	
	getViewCallback: function (data, ioArgs) {
		var cell = null;
		var cells = [];
		var defaultColWidth = null;
		if(this.fixedColSpan === 0){
			var data1 = data[0];
			this.totalRowCount = data1.totalRowCount;
			this.columnCount = data1.columnCount;
			this.filteredRows = data1.filteredRows;
			if(data1.selectColWidth != null || data1.selectColWidth != undefined)
				this.selectColWidth = data1.selectColWidth;
			this.selectColStyle = data1.selectColStyle;
			this.selectRowIndices = data1.selectRowIndices;
		}else{
			var data1 =data[0]; 
			var data2 = data[1];
			this.data1 = data1;
			this.data2 = data2;
			this.totalRowCount = data1.totalRowCount;
			this.columnCount = data1.columnCount;
			this.filteredRows = data1.filteredRows;
			if(data1.selectColWidth != null || data1.selectColWidth != undefined)
				this.selectColWidth = data1.selectColWidth;
			this.selectColStyle = data1.selectColStyle;
			this.selectRowIndices = data1.selectRowIndices;
		}
		
		
		var list = dojox.json.query("=$.[?index='*']", this.selectRowIndices);
		if(list !== null)
		    this.selectRowCount = list.length;
		defaultColWidth = Math.round(this.width/this.columnCount);
		
		for (var i in data1.cells) {
		
				if (i) {
					/*console.debug("data.cells[i]"+ data1.cells[i].editable);
					console.debug("data.cells[i]"+ data1.cells[i].field);
					console.debug("data.cells[i]"+ data1.cells[i].name);
					console.debug("data.cells[i]"+ data1.cells[i].isNamingAttribute);
					console.debug("data.cells[i]"+ data1.cells[i].isSearchable);
					console.debug("data.cells[i]"+ data1.cells[i].hidden);
					console.debug("data.cells[i]"+ data1.cells[i].noresize);
					console.debug("data.cells[i]"+ data1.cells[i].dojoClass);*/
					
					if(data1.cells[i].dojoClass != undefined){
						//console.debug("dojoClass: "+data1.cells[i].dojoClass );
						this.setEditableCellType(data1.cells[i].dojoClass, data1.cells[i]);
					
					}
					if(data1.cells[i].options != undefined){
						this.setOptionsForComboBox(data1.cells[i].options, data1.cells[i]);
						this.setValuesForComboBox(data1.cells[i].values, data1.cells[i]);
						
					}
					if (data1.cells[i].width == undefined) {
						data1.cells[i].width = defaultColWidth + "px";
					}
					
				}
		
		}
		if (data2) {
		
			for (var i in data2.cells) {
			
				if (i) {
					/*console.debug("data.cells[i]"+ data2.cells[i].editable);
			 console.debug("data.cells[i]"+ data2.cells[i].field);
			 console.debug("data.cells[i]"+ data2.cells[i].name);
			 console.debug("data.cells[i]"+ data2.cells[i].isNamingAttribute);
			 console.debug("data.cells[i]"+ data2.cells[i].isSearchable);
			 console.debug("data.cells[i]"+ data2.cells[i].hidden);
			 console.debug("data.cells[i]"+ data2.cells[i].noresize);
			 console.debug("data.cells[i]"+ data2.cells[i].dojoClass);*/
					if (data2.cells[i].dojoClass != undefined) {
						this.setEditableCellType(data2.cells[i].dojoClass, data2.cells[i]);
					}
					if (data2.cells[i].options != undefined) {
						this.setOptionsForComboBox(data2.cells[i].options, data2.cells[i]);
						this.setValuesForComboBox(data2.cells[i].values, data2.cells[i]);
					}
					if (data2.cells[i].width == undefined) {
						data2.cells[i].width = defaultColWidth + "px";
					}
					
				}
				
			}
		}
		
		this.originalStructure = data;
		if(this.renderOnce == false)
			this.rowsPerPage = this.defaultRowsPerPage;
		if(this.filteredRows <= this.rowsPerPage) {
			this.pageSize = this.filteredRows;
		} else {
			this.pageSize = this.rowsPerPage;
		}
		if(this.filteredRows == 0)
		{
			console.debug("filter rows are zero");
			this.grid._refresh(true);
		}
		this.gridParms.store._fetchCache = [];
		//this.grid.store._fetchCache = [];			
		this.grid.queryOptions = {cache:true};
		//reset sort info since grid somehow retains old sort info....
		this.grid.sortInfo = 0;
		if (this.fixedColSpan === 0) {
			var view1 = {
				cells: [data1.cells]
			};
			// a grid layout is an array of views.
			var layout = [view1];
			this.data1 = data1;
			this.setupView(layout, data1);
		}
		else {
			var view1 = {
				cells: [data1.cells],
				noscroll: true
			};
			var view2 = {
				cells: [data2.cells]
			};
			//a grid layout is an array of views.
			var layout = [view1, view2];
			this.data1 = data1;
			this.data2 = data2;
			this.setupView(layout, data1);
		}
		
	},
	setEditableCellType: function(dojoCellType, cell ){
		if(dojoCellType == 'dojox.grid.cells.ComboBox'){
			cell.type = dojox.grid.cells.ComboBox;
		}else if(dojoCellType == 'dojox.grid.cells.DateTextBox'){
			cell.type = dojox.grid.cells.DateTextBox;
		}else if(dojoCellType == 'dojox.grid.cells._Widget'){
			cell.type = dojox.grid.cells._Widget;
		}
		else if(dojoCellType == 'dojox.grid.cells.CheckBox'){
			cell.type = dojox.grid.cells.CheckBox;
		}
		else if(dojoCellType == 'dojox.grid.cells.Editor'){
			cell.type = dojox.grid.cells.Editor;
		}else if(dojoCellType == 'dojox.grid.cells.Select'){
			cell.type = dojox.grid.cells.Select;
		}	
				
	},
	setOptionsForComboBox: function(optionsStr, cell){
		cell.options = optionsStr.split(",");
	},
	setValuesForComboBox: function(valuesStr, cell){
		cell.values = valuesStr.split(",");
	},
	handleError: function (error, ioArgs) {
		console.debug("handleError:"+error);
	},
	setupView: function (structure, data) {
		
//		this.grid.attr('structure', structure);
		this.grid.setStructure( structure );
		var cell = null;
		for (var i in this.grid.layout.cells) {
			if (i) {
				cell = this.grid.layout.cells[i];
				if (cell.hidden) {
					this.grid.layout.setColumnVisibility(i, false);
				}				
				if(cell.name === 'Select' && dojo.isIE){
					cell.width = this.selectColWidth + "px";
				} else if(cell.name === 'Select' && dojo.isFF){
					cell.width = this.selectColWidth + "px";
				}
				if(cell.name === 'Select')
				  cell.styles = this.selectColStyle;
			}
		}

        this.originalStructure=this.grid.layout;  
		if(this.isToolbarVisible == true){
			this.searchField.setTable( this.grid );
		}
		
 	    this.afterViewLoad(data.rcfItems);
		this.refreshSelection();
	},
	afterViewLoad: function (rcfItems) {
		if (this.cmProvider) {
			this.configureContextMenu(rcfItems);  			
	  	}
	  		  	
	  	this.viewLoaded = true;
	},
	configureContextMenu: function (rcfItems) {
		if ((this.cmProvider.parentid === null) || (this.cmProvider.parentid === "")) {
			this.cmProvider.setParentId (this.id);
		}
		if ((this.cmProvider.rcfItems === null) && (rcfItems)) {
			this.cmProvider.rcfItems = rcfItems;
		}

      this._onRowContextMenuListener = dojo.connect( this.grid, "onRowContextMenu", this, "_onRowContextMenu" );
      	 //FIXES CONTEXT MENU BUG with selected table rows IN DOJO 1.0.2
		 this.grid.focus.styleRow = function(inRow){};
      
	},
    getContextMenuAdapter: function()
    {
      if (this._contextMenuAdapter === null) {
         // Create the contextMenuAdapter.
		 if(this.cmProvider!==null) {
		    //this.cmProvider.url=actionString;
			this.cmProvider.tableDetails={arg_fqTableId: this.tableID};
		 }	
         this._contextMenuAdapter = new ibm.psw.wcl.dijit.WDContextMenu({cmProvider: this.cmProvider});
      }
      return this._contextMenuAdapter;
    },
    /************************************************************************
    * This method is called each time a context menu is requred on a row
    ************************************************************************/
    _onRowContextMenu: function( e )
    { 
      var row = e.grid.getItem( e.rowIndex );
      //console.warn("_onRowContextMenu"+this._contextMenu);	
      if ( row )
      {
        //select the row that the context menu was initiated on
        e.grid.selection.deselectAll( e.rowIndex );
        e.grid.selection.setSelected( e.rowIndex, true );
		this.grid.indirectSelector.preSelection(this.rowsPerPage);	
		if (this.serverSideSelect) {
			this.updateServerOnRowClick();
		}
                
        //tell the context menu adapter to show the menu
        // no context is provided because we overload the _loadMenuItems method
        this.getContextMenuAdapter().contextMenuOpen( e, {selectedData: this.getSelectionData()} );
      }
    },
	getSelectedRows: function () {
		return this.grid.selection.getSelected();
	},
	getAllColumnIndexes: function () {
//		
//		var count = this.grid.attr ('structure')[0].cells.length;
//		var count = this.grid.structure[0].cells.length;
		var count = this.originalStructure.cells.length;
		var columnIDs = [];
		for (var i=0; i<count; i++) {
			columnIDs.push (i);
		}
		
		return (columnIDs);
	},
	getValueAt: function (rowIndex, columnIndex) {
		//Following approach doesn't work
		//var row = rowIndex.i;
		//var value = row[columnIndex];
		
		var value = rowIndex[columnIndex];
		
		return (value); 
	},
	getModelData: function () {
		var selectedRows = this.getSelectedRows ();
		var row = selectedRows[0];
		var columnIDs = this.getAllColumnIndexes();

		for (var column in columnIDs) {
			if (column) {
				var data = this.getValueAt (row, column);
				//
			}
		}
	},
	getIdentifier: function () {
		return (this.originalStructure.cells.length);
	},
	getSelectionData: function () {
		//this.getModelData();
		var selectedRows = this.getSelectedRows ();
//		

		var rowData = null;
		var columnIDs = this.getAllColumnIndexes();
		var identifier = this.getIdentifier();
		var rowJSON = {};
		
		dojo.forEach (selectedRows,
			function (row) {
				var firstTime = true;
				rowJSON.id = this.getValueAt (row, identifier);
			
				for (var column in columnIDs) {
					if (column) {
//						
						var cellValue = this.getValueAt (row, column);
						rowJSON[column] = cellValue;
					}
				}
			}, this);

		
		var columnsArray = [];
		var columnJSON = {};
		var firstLoop = true;
		for (var c in columnIDs) {
			if (c) {
				columnJSON = {};
				columnJSON.field = c;
				columnJSON.isNamingAttribute = this.isNamingAttribute(c);
				columnsArray.push (columnJSON);
			}
		}
		
		var result = { columns: columnsArray, rows: rowJSON }; 
		
//		

		
//		var sample = { 
//		columns: [{ field: "srcToken", hidden: true },
//				  { field: "ManagedSystemName", label: "Managed System Name" },
//				  { field: "column_2", label: "baz" }],
//		
//		 rows: { srcToken: "1234", ManagedSystemName: "bar", column_2: "bang" }
//		 		};
		
		return (result);
	},
	isNamingAttribute: function (field) {
//		
//		var columns = this.grid.attr('structure')[0].cells[0];
//	  	var columns = this.grid.structure[0].cells[0];
		var columns = this.originalStructure.cells;
	  	if (columns[field]) {
		  	return columns[field].isNamingAttribute;
		} else {
			return (false);
		}
	},
	resize: function (size) {
//		
		  
	  	if ((size) && (this.grid)) {
		  // remove height of footer
		  if (this.footerToolbar) {
		  	var coords = dojo.coords (this.footerToolbar.domNode);
		  	size.h = size.h - coords.h;
		  }
		  // remove height of toolbar
		  if (this.filterBar) {
			coords = dojo.coords (this.filterBar.domNode);
			size.h = size.h - coords.h;
		  }
		  
		  this.grid.autoHeight = false;
		  this.grid.autoWidth = false;
		  var	w = Number(size.w);
		  var h = Number(size.h);
			
		  dojo.contentBox(this.grid.domNode, {w: w, h: h});
		  this.grid.update();
		  //add on 2009/07/09 for reorder columns because autosave is  true, don't need to make ajax request to server ,if auto save is false can try the following method
//		  if(this.gridParms.columnReordering == true){			   
//			  if(this.grid.layout!==null&&this.grid.structure!==null)
//			   { 
//			     pref=this.getPreferences();
//			    this.originalStructure=this.grid.layout; 
//				  if(pref!==null&&pref!==this.getPreferences()){
//			      this.savePreferences();
//	 			
//			   }  
//			  }
//			}
		  if(this.gridParms.columnReordering === true){			
			   
			  if(this.grid.layout!==null&&this.grid.structure!==null)
			   { 
			    this.originalStructure=this.grid.layout;  
			    
			  }
			}

		  
	  	}
    },
	onResize: function () {
//		
		//var preferences = this.getPreferences();
		if (this.autoSavePreferences && this.viewLoaded) {
			this.resizePreferences();
		} else {
//			
		}
	},
	resizePreferences: function () {
    	this.gridParms.store._fetchCache = [];
		// make sure that the grid has structure already.
		var preferences = this.getPreferences();
		if ((preferences !== null) && (preferences !== this.lastPreferences)) {
			var kw = {
				content: {
					command: "saveTablePreferences",
					arg_fqTableId: this.tableID,
					arg_portletNamespace: this.global.namespace,
					arg_preferences: preferences
				},
				timeout: this.requestTimeout,
				onResponse: {
					callback: dojo.hitch(this, this.handleResizeCallback)
				},
				error: this.handleError
			};
			
			ibm.psw.wcl.dojo.Server.getSingleton().get(kw);
			this.lastPreferences = preferences;
		}
       
//       
	},
	handleResizeCallback: function(data){
		if(this.isToolbarVisible == true){
			this.searchField.setTable( this.grid );
		}
		var size = 0;
		var columns = this.grid.layout.cells;
		for (var j in columns) {
			if (j) {
				column = columns[j];				
				if (!column.hidden) {
				    var width = 0;
					var unitWidth = column.unitWidth;
					if(unitWidth.indexOf("px") !== -1)
					{
					   width = parseInt(unitWidth.substring(0, unitWidth.indexOf("px")));
					}
					size = size + width;
					
				} 
			}
		}
		
		if (size > this.width) {
			dojo.style(this.domNode, {
				width: size + "px"
			});
		}
	},
	savePreferences: function () {
    	this.gridParms.store._fetchCache = [];
		// make sure that the grid has structure already.
		var preferences = this.getPreferences();
		
		if ((preferences !== null) && (preferences !== this.lastPreferences)) {
			var kw = {
				content: {
					command: "saveTablePreferences",
					arg_fqTableId: this.tableID,
					arg_portletNamespace: this.global.namespace,
					arg_preferences: preferences
				},
				timeout: this.requestTimeout,
				onResponse: {
					callback: dojo.hitch(this, this.getViewCallback)
				},
				error: this.handleError
			};
			
			ibm.psw.wcl.dojo.Server.getSingleton().get(kw);
			this.lastPreferences = preferences;
		}
	},
	getPreferences: function () {
//		
		var preferences = null;
		
		if (this.originalStructure) {
			//var ids = this.getViewColumnsIDs();
		  	var columns = this.originalStructure.cells;
			preferences = '{ "columns" : [ ';
		
			for (var x in columns) {
				if (x) {
					var visible = columns[x].hidden === undefined ? false : !columns[x].hidden;
					if (this.tableOptionsEnabled && this.tableOptionsDialog) {
						visible = this.tableOptionsDialog.getTableOptions().isColumnVisible(columns[x].field);
					}
					
					if (visible) {
						visible = "t";
					} else {
						visible = "f";
					}
					
					var viewIndex = this.getViewColumnIndex (columns[x].field);
					var width = columns[x].width;
					if (viewIndex !== null) {
						if ((this.grid) && (this.grid.getCell(viewIndex))) {
							width = this.grid.getCell(viewIndex).unitWidth;
						}
					} else {
						
					}
						
					preferences += ' {"id": "' + columns[x].field + '", "width":"' + width + '", "v":"' + visible + '"} ';
					
					if (x < columns.length - 1) {
						preferences += ", ";
					}
				}
			}
			preferences += " ] }";
//			
//			
		} else {
			
		}
				
		return (preferences);
	},
	getViewColumnIDs: function () {
//		
//		
		//var columns = this.grid.attr('structure')[0].cells[0];
//	  	var columns = this.grid.structure[0].cells[0];
		var columns = this.originalStructure.cells;
	  	var columnIDs = [];
	  	for ( var i in columns ) {
	  		if (i) {
				columnIDs.push (columns[i].field);
			}
		}
		
		return (columnIDs);
	},
	getViewColumnIndex: function (id) {
		var viewColumnIDs = this.getViewColumnIDs();
		for (var i in viewColumnIDs) {
			if (i) {
				if (id == viewColumnIDs[i]) {
					return (i);
				}
			}
		}
		
		return (null);
	},
	/**************************************************************************
	* Initialize the toolbar with default buttons (like refresh)
	**************************************************************************/
	initializeToolbar: function() 
	{
		if(this.allFeatures){
			this.showActionListFeature = true;
			this.showGoButtonActionListFeature = true;
			this.restoreDefaultFeature = true;
			this.exportDataFeature = true;
			this.tableOptionsEnabled = true;			
			this.toggleFilterRowFeature = true;
			this.cleanFiltersFeature = true;
			this.editSortFeature = true;
			this.clearSortsFeature = true;
			this.prefetchingFeature = true;
		}
		
		if(this.noFeatures){
			this.showActionListFeature = false;
			this.showGoButtonActionListFeature = false;
			this.restoreDefaultFeature = false;
			this.exportDataFeature = false;
			this.tableOptionsEnabled = false;			
			this.toggleFilterRowFeature = false;
			this.cleanFiltersFeature = false;
			this.editSortFeature = false;
			this.clearSortsFeature = false;
			this.prefetchingFeature = false;
		}
		
		var button = new ibm.psw.wcl.dijit.WDButton(
			{	label: this.resources_.REFRESH,
				alt: this.resources_.REFRESH,
				id: this.id + this.resources_.REFRESH,
				showLabel: false, 
				iconClass: "refreshIcon",
			 	onClick: dojo.hitch (this, this.onRefresh) 
			});
		this.toolbar.addChild(button);

		this.toolbar.addChild (new dijit.ToolbarSeparator());		

		if (this.multiSelect) {	
			button = new ibm.psw.wcl.dijit.WDButton(
				{	label: this.resources_.SELECT_ALL,
					alt: this.resources_.SELECT_ALL,
					id: this.id + this.resources_.SELECT_ALL,					
					showLabel: false, 
					iconClass: "selectAllIcon",
				 	onClick: dojo.hitch (this, this.selectAll) 
				});
			this.toolbar.addChild(button);
			
			button = new ibm.psw.wcl.dijit.WDButton(
				{	label: this.resources_.DESELECT_ALL,
					alt: this.resources_.DESELECT_ALL,
					id: this.id + this.resources_.DESELECT_ALL,
					showLabel: false, 
					iconClass: "deselectAllIcon",
				 	onClick: dojo.hitch (this, this.deselectAll) 
				});
			this.toolbar.addChild(button);
		}
		
		if (this.exportDataFeature) {
			button = new ibm.psw.wcl.dijit.WDButton({
				label: this.resources_.EXPORT_DATA,
				alt: this.resources_.EXPORT_DATA,
				id: this.id + this.resources_.EXPORT_DATA,
				showLabel: false,
				iconClass: "exportDataIcon",
				onClick: dojo.hitch(this, this.exportData)
			});
			this.toolbar.addChild(button);			
		}
		
		if(this.toggleFilterRowFeature){					
			button = new ibm.psw.wcl.dijit.WDButton(
				{	label: this.resources_.SHOW_FILTER_LABEL, 
					alt: this.resources_.SHOW_FILTER_LABEL,
					id: this.id + this.resources_.SHOW_FILTER_LABEL,
					showLabel: false, 
					iconClass: "showFilterIcon",
				 	onClick: dojo.hitch (this, this.showFilter) 
				});
			this.toolbar.addChild(button);			
			button = new ibm.psw.wcl.dijit.WDButton(
				{	label: this.resources_.CLEAR_ALL_FILTERS_LABEL, 
					alt: this.resources_.CLEAR_ALL_FILTERS_LABEL,
					id: this.id + this.resources_.CLEAR_ALL_FILTERS_LABEL,
					showLabel: false, 
					iconClass: "clearFilterIcon",
				 	onClick: dojo.hitch (this, this.clearFilters) 
				});
			this.toolbar.addChild(button);			
		}		
			
		if (this.editSortFeature) {
			//Edit Sort
			button = new ibm.psw.wcl.dijit.WDButton(
				{	label: this.resources_.EDIT_SORT, 
					alt: this.resources_.EDIT_SORT,
					id: this.id + this.resources_.EDIT_SORT,
					showLabel: false, 
					iconClass: "editSortIcon",
				 	onClick: dojo.hitch (this, this.editSort) 
				});
			this.toolbar.addChild(button);			
			//Clear Sort
			button = new ibm.psw.wcl.dijit.WDButton(
				{	label: this.resources_.CLEAR_SORT, 
					alt: this.resources_.CLEAR_SORT,
					id: this.id + this.resources_.CLEAR_SORT,
					showLabel: false, 
					iconClass: "clearSortIcon",
				 	onClick: dojo.hitch (this, this.clearSorts) 
				});
			this.toolbar.addChild(button);
		}
		
		if (this.tableOptionsEnabled) {	
			button = new ibm.psw.wcl.dijit.WDButton(
				{	label: this.resources_.TABLE_PREFERENCES,
					alt: this.resources_.TABLE_PREFERENCES,
					id: this.id + this.resources_.TABLE_PREFERENCES,
					showLabel: false, 
					iconClass: "tableOptionsIcon",
				 	onClick: dojo.hitch (this, this.showTableOptions) 
				});
			this.toolbar.addChild(button);
		}
	},
	
	nestedMenu: function(){
		divTableDropDown = dojo.doc.createElement( 'div' );
		var jsonData = [{id: "Separator" + this.id}];
		var defaultActions = [{id: "Separator" + this.id},
				{id: "TableActions" + this.id, name: "TableActions", label: this.resources_.TABLE_ACTIONS},
				{id: "Separator" + this.id},
				{id: "select(all)" + this.id, name: "select(all)", label: this.resources_.SELECT_ALL, use_ajax: true, iconClass: "selectAllIcon"},
				{id: "select(none)" + this.id, name: "select(none)", label: this.resources_.DESELECT_ALL, use_ajax: true, iconClass: "deselectAllIcon"},
				{id: "export" + this.id, name: this.exportDataServletPath, label: this.resources_.EXPORT_DATA, use_ajax: true, iconClass: "exportDataIcon"},
				{id: "toggleFilterRow" + this.id, name:"toggleFilterRow", label: this.resources_.SHOW_FILTER_ROW, use_ajax: true, iconClass: "showFilterIcon"},
				{id: "clearFilters" + this.id, name:"clearFilters", label: this.resources_.CLEAN_FILTER_ROW, use_ajax: true, iconClass: "clearFilterIcon"},
				{id: "editSort" + this.id, name:"editSort", label: this.resources_.EDIT_SORT, use_ajax: true, iconClass: "editSortIcon"},
				{id: "clearSorts" + this.id, name:"clearSorts", label: this.resources_.CLEAN_ALL_SORTS, use_ajax: true, iconClass: "clearSortIcon"},
				{id: "configureColumns" + this.id, name:"configureColumns", label: this.resources_.TABLE_PREFERENCES, use_ajax: true, iconClass: "tableOptionsIcon"},
				{id: "restoreDefault" + this.id, name:"restoreDefault", label: this.resources_.RESTORE_DEFAULTS, use_ajax: true}];
		if(this.userActions !== "" ){
			var list = dojox.json.query("=$.[?parentAction=null]", this.userActions);
			for(i=0; i < list.length; i++){
				var action = {id: dojox.json.query("[" + i + "].id", this.userActions), name: dojox.json.query("[" + i + "].name", this.userActions), label: dojox.json.query("[" + i + "].label", this.userActions), message: dojox.json.query("[" + i + "].message", this.userActions), use_ajax: dojox.json.query("[" + i + "].use_ajax", this.userActions), disabled: dojox.json.query("[" + i + "].disabled", this.userActions), submenu_items: dojox.json.query("[" + i + "].submenu_items", this.userActions)};
				jsonData.push(action);
			}
		}
		var list = dojox.json.query("=$.[?id='*']", defaultActions);
		for(i=0; i < list.length; i++){
			if((dojox.json.query("[" + i + "].name", defaultActions) === "select(all)" || dojox.json.query("[" + i + "].name", defaultActions) === "select(none)") && this.multiSelect){
				var action = {id: dojox.json.query("[" + i + "].id", defaultActions), name: dojox.json.query("[" + i + "].name", defaultActions), label: dojox.json.query("[" + i + "].label", defaultActions), message: dojox.json.query("[" + i + "].message", defaultActions), use_ajax: dojox.json.query("[" + i + "].use_ajax", defaultActions), disabled: dojox.json.query("[" + i + "].disabled", defaultActions), iconClass: dojox.json.query("[" + i + "].iconClass", defaultActions)};
				jsonData.push(action);
			} else if((dojox.json.query("[" + i + "].name", defaultActions) === "toggleFilterRow" || dojox.json.query("[" + i + "].name", defaultActions) === "clearFilters") && this.toggleFilterRowFeature){
				var action = {id: dojox.json.query("[" + i + "].id", defaultActions), name: dojox.json.query("[" + i + "].name", defaultActions), label: dojox.json.query("[" + i + "].label", defaultActions), message: dojox.json.query("[" + i + "].message", defaultActions), use_ajax: dojox.json.query("[" + i + "].use_ajax", defaultActions), disabled: dojox.json.query("[" + i + "].disabled", defaultActions), iconClass: dojox.json.query("[" + i + "].iconClass", defaultActions)};
				jsonData.push(action);
			} else if((dojox.json.query("[" + i + "].name", defaultActions) === "editSort" || dojox.json.query("[" + i + "].name", defaultActions) === "clearSorts") && this.editSortFeature){
				var action = {id: dojox.json.query("[" + i + "].id", defaultActions), name: dojox.json.query("[" + i + "].name", defaultActions), label: dojox.json.query("[" + i + "].label", defaultActions), message: dojox.json.query("[" + i + "].message", defaultActions), use_ajax: dojox.json.query("[" + i + "].use_ajax", defaultActions), disabled: dojox.json.query("[" + i + "].disabled", defaultActions), iconClass: dojox.json.query("[" + i + "].iconClass", defaultActions)};
				jsonData.push(action);
			} else if((dojox.json.query("[" + i + "].name", defaultActions) === "configureColumns") && this.tableOptionsEnabled){
				var action = {id: dojox.json.query("[" + i + "].id", defaultActions), name: dojox.json.query("[" + i + "].name", defaultActions), label: dojox.json.query("[" + i + "].label", defaultActions), message: dojox.json.query("[" + i + "].message", defaultActions), use_ajax: dojox.json.query("[" + i + "].use_ajax", defaultActions), disabled: dojox.json.query("[" + i + "].disabled", defaultActions), iconClass: dojox.json.query("[" + i + "].iconClass", defaultActions)};
				jsonData.push(action);
			} else if((dojox.json.query("[" + i + "].name", defaultActions) === this.exportDataServletPath) && this.exportDataFeature){
				var action = {id: dojox.json.query("[" + i + "].id", defaultActions), name: dojox.json.query("[" + i + "].name", defaultActions), label: dojox.json.query("[" + i + "].label", defaultActions), message: dojox.json.query("[" + i + "].message", defaultActions), use_ajax: dojox.json.query("[" + i + "].use_ajax", defaultActions), disabled: dojox.json.query("[" + i + "].disabled", defaultActions), iconClass: dojox.json.query("[" + i + "].iconClass", defaultActions)};
				jsonData.push(action);
			} else if((dojox.json.query("[" + i + "].name", defaultActions) === "restoreDefault") && this.restoreDefaultFeature){
				var action = {id: dojox.json.query("[" + i + "].id", defaultActions), name: dojox.json.query("[" + i + "].name", defaultActions), label: dojox.json.query("[" + i + "].label", defaultActions), message: dojox.json.query("[" + i + "].message", defaultActions), use_ajax: dojox.json.query("[" + i + "].use_ajax", defaultActions), disabled: dojox.json.query("[" + i + "].disabled", defaultActions), iconClass: dojox.json.query("[" + i + "].iconClass", defaultActions)};
				jsonData.push(action);
			} else if(dojox.json.query("[" + i + "].id", defaultActions).substring(0,9) === "Separator" || dojox.json.query("[" + i + "].name", defaultActions) === "TableActions"){
				var action = {id: dojox.json.query("[" + i + "].id", defaultActions), name: dojox.json.query("[" + i + "].name", defaultActions), label: dojox.json.query("[" + i + "].label", defaultActions)};
				jsonData.push(action);
			}
		}
		this.tableDropDown = new ibm.psw.wcl.dijit.WDNestedMenu({
			dropDownList: jsonData,
			createButton: this.showGoButtonActionListFeature
		}, divTableDropDown );
		this.dropDownMenu.addChild(this.tableDropDown);
		if(this.showGoButtonActionListFeature){
			this.connections.push ( dojo.connect(this.tableDropDown.goButton, 'onClick', dojo.hitch(this, this.onButtonClick)));
		} else {
			this.connections.push (dojo.connect (this.tableDropDown, 'onMenuItemClick', dojo.hitch(this, this.onDropDownChange)));
		}
	},
		
	onButtonClick: function(evt){
		/*Default Actions*/
		if( this.tableDropDown.onButtonClick() === "select(all)" ){
			this.selectAll();
		} else if ( this.tableDropDown.onButtonClick() === "select(none)" ){
			this.deselectAll();
		} else if ( this.tableDropDown.onButtonClick() === this.exportDataServletPath ){
			//this.doUserActionAjax(this.formID, this.actionName, this.anchorValue, "wh", "wa", "");
			this.exportData();
		} else if ( this.tableDropDown.onButtonClick() === "toggleFilterRow" ){
			this.showFilter();
		} else if ( this.tableDropDown.onButtonClick() === "clearFilters" ){
			this.clearFilters();
		} else if ( this.tableDropDown.onButtonClick() === "editSort" ){
			this.editSort();
		} else if ( this.tableDropDown.onButtonClick() === "clearSorts" ){
			this.clearSorts();
		} else if ( this.tableDropDown.onButtonClick() === "configureColumns" ){
			this.showTableOptions();
		} else if ( this.tableDropDown.onButtonClick() === "restoreDefault" ){
			this.doUserActionAjax(this.formID, this.actionName, this.anchorValue, "wh", "wa", "");
			if(this.pagingFeature == true){
				this.countValue = this.defaultRowsPerPage;
				this.rowsPerPage = this.defaultRowsPerPage;
				//this.pageRowControl.setRowsPerPage(this.defaultRowsPerPage);
				//this.pageRowControl.setRowMax(this.totalRowCount);
				//this.pageRowControl.setPageMax(Math.ceil(this.totalRowCount/this.countValue));
				//this.pageRowControl.setCurrentPage(1);
				//this._currentPage = this.pageRowControl.getCurrentPage() - 1;
				//this.pageSize = this.pageRowControl.rowsPerPage;
			}
			this.grid.autoHeight = false;
			this.clearFilters();
			this.clearSorts();
		}
		/*User Defined Actions*/
		var list = dojox.json.query("=$.[?parentAction=null]", this.userActions);
		for(var i=0; i < list.length; i++){
			if ( this.tableDropDown.onButtonClick() === dojox.json.query("[" + i + "].name", this.userActions) ){
				this.doUserActionAjax(this.formID, this.actionName, this.anchorValue, "wh", "wa", "");
			}
		}
		var subList = dojox.json.query("=$.[?parentAction!=null]", this.userActions);
		for(var i=0; i < subList.length; i++){
			if ( this.tableDropDown.onButtonClick() === dojox.json.query("[" + i + "].name", subList) ){
				this.doUserActionAjax(this.formID, this.actionName, this.anchorValue, "wh", "wa", "");
			}
		}
		this.tableDropDown.reset();
	},
	
	onDropDownChange: function(){
		/*Default Actions*/
		if( this.tableDropDown.onItemClick() === "select(all)" ){
			this.selectAll();
		} else if ( this.tableDropDown.onItemClick() === "select(none)" ){
			this.deselectAll();
		} else if ( this.tableDropDown.onItemClick() === this.exportDataServletPath ){
			//this.doUserActionAjax(this.formID, this.actionName, this.anchorValue, "wh", "wa", "");
			this.exportData();
		} else if ( this.tableDropDown.onItemClick() === "toggleFilterRow" ){
			this.showFilter();
		} else if ( this.tableDropDown.onItemClick() === "clearFilters" ){
			this.clearFilters();
		} else if ( this.tableDropDown.onItemClick() === "editSort" ){
			this.editSort();
		} else if ( this.tableDropDown.onItemClick() === "clearSorts" ){
			this.clearSorts();
		} else if ( this.tableDropDown.onItemClick() === "configureColumns" ){
			this.showTableOptions();
		} else if ( this.tableDropDown.onItemClick() === "restoreDefault" ){
			this.doUserActionAjax(this.formID, this.actionName, this.anchorValue, "wh", "wa", "");
			if(this.pagingFeature == true){
				this.countValue = this.defaultRowsPerPage;
				this.rowsPerPage = this.defaultRowsPerPage;
				//this.pageRowControl.setRowsPerPage(this.defaultRowsPerPage);
				//this.pageRowControl.setRowMax(this.totalRowCount);
				//this.pageRowControl.setPageMax(Math.ceil(this.totalRowCount/this.countValue));
				//this.pageRowControl.setCurrentPage(1);
				//this._currentPage = this.pageRowControl.getCurrentPage() - 1;
				//this.pageSize = this.pageRowControl.rowsPerPage;
			}
			this.grid.autoHeight = false;
			this.clearFilters();
			this.clearSorts();
		}
		/*User Defined Actions*/
		var list = dojox.json.query("=$.[?parentAction=null]", this.userActions);
		for(var i=0; i < list.length; i++){
			if ( this.tableDropDown.onItemClick() === dojox.json.query("[" + i + "].name", this.userActions) ){
				this.doUserActionAjax(this.formID, this.actionName, this.anchorValue, "wh", "wa", "");
			}
		}
		var subList = dojox.json.query("=$.[?parentAction!=null]", this.userActions);
		for(var i=0; i < list.length; i++){
			if ( this.tableDropDown.onItemClick() === dojox.json.query("[" + i + "].name", subList) ){
				this.doUserActionAjax(this.formID, this.actionName, this.anchorValue, "wh", "wa", "");
			}
		}
		this.tableDropDown.reset();
	},
	
	selectAll: function () 
	{
		this.isSelectAll = true;
		this.isDeselectAll = false;
		this.grid.rowSelectCell.toggleAllSelection(true);
		this.updateFooter (this.gridParms.store.id);
	},
	deselectAll: function () 
	{
		this.isSelectAll = false;
		this.isDeselectAll = true;
		this.grid.rowSelectCell.toggleAllSelection(false);
		this.updateFooter (this.gridParms.store.id);
	},
	
	exportData: function ()
	{
		this.grid.rowSelectCell.toggleAllSelection(true);
		var items = this.getSelectedRows();
		var columnIDs = this.getAllColumnIndexes();
		var csvResults = [];
		dojo.forEach(items, function(item){
			var result = [];
			for (var column in columnIDs) {
				if (column) {
					result.push(item[column]);
				}
			}
			csvResults += result.join(',') + "\n";
		});
		this.grid.rowSelectCell.toggleAllSelection(false);
		console.info("csvResults\n" + csvResults);
		//this.exportDataIconClicked = true;
		//this.doUserActionAjax(this.formID, this.actionName, this.anchorValue, "wh", "wa", "");
		//this.exportDataIconClicked = false;
	},
	
	showFilter: function(){
		if(this.filterDialog){
			this.filterDialog.show();
		}else{
			this.filterDialog = new ibm.psw.wcl.dijit.WDTableFilterDialog ( 
				{ 
				  table: this, 
				  formID: this.formID,
				  tableID: this.tableID	} 
			);
		
			this.filterDialog.show();
		}
		if(this.pagingFeature == true){
			//this.pageRowControl.setCurrentPage(1);
			//this._currentPage = this.pageRowControl.getCurrentPage() - 1;
		}
	},
	
	clearFilters: function(){
		if(this.pagingFeature == true){
			this.countValue = this.defaultRowsPerPage;
			this.rowsPerPage = this.defaultRowsPerPage;
			//this.pageRowControl.setRowsPerPage(this.defaultRowsPerPage);
			//this.pageRowControl.setRowMax(this.totalRowCount);
			//this.pageRowControl.setPageMax(Math.ceil(this.totalRowCount/this.countValue));
			//this.pageRowControl.setCurrentPage(1);
			//this._currentPage = this.pageRowControl.getCurrentPage() - 1;
			this.pageSize = this.defaultRowsPerPage;
		}
		this.gridParms.store._fetchCache = [];
 		var columns = this.grid.layout.cells;
		
 		var columnsVisible = new Array();
		
		for (var i in columns) {
			if (i) {
				var column = columns[i];
				
					var isVisible = column.visible===undefined?!column.hidden:column.visible;
					if(isVisible)
						columnsVisible[i]= i;
			}
		}
		
		if (columnsVisible.length > 0) {
			var kw = {
				content: {
					command: "clearAllFilters",
					arg_fqTableId: this.tableID,
					arg_portletNamespace: this.global.namespace
				},
				timeout: this.requestTimeout,
				onResponse: {
					callback: dojo.hitch(this, this.getViewCallback)
				},
				error: this.handleError
			};
			
			this.grid._refresh(true);
			ibm.psw.wcl.dojo.Server.getSingleton().get(kw);
			this.grid._refresh(true);
		}
		
		
	},
	
	onRefresh: function() {
        // What is going on here?
        // Previously, the preceding three lines were used in this function to refresh
        // the table.  Create a new model, set the model, and issue the event.  However,
        // the problem is that WTable gets its data from the server, so the new model
        // was set prior to it having any data.  This resulted in the table 
        // "flashing".  That is the table would go all blank, then turn around and fill
        // with the data from the server.  This didn't look good, so the below code fixes
        // this.  A callback was added to the store so that when it finishes handling
        // data from the server, it will call the callback.  This enables us to first 
        // create the model, and load its first page, then swap it in to the table.
        
        // Create the callback function that will swap in the new model when it has some data
        var cb = dojo.hitch(this,function(){  
                                              this.grid.setLoadCompleteCallback(null);
                                              // I found that the following update is needed when only
                                              // one row is in the model.
//                                              this.grid.update();
                                              this.updateFooter(this.gridParms.store.id);
                                              dojo.publish (this.id + "#Refresh", [ "Refresh" ]);
                                            });
                                            
        this.grid.setLoadCompleteCallback(cb);  // set the callback
        this.grid._refresh(true);
	},
	refreshWithArgs: function (args) {
		this.tableArgs = args;
		var dataQuery = {query:this.query};

	  	if (this.tableArgs) {
	  		for (var key in this.tableArgs) {
	  			if (key) {
	  				dataQuery[key] = this.tableArgs[key];
	  			}	
	  		}
	  	}
	  	
	  	if (this.widgetID !== null) {
			dataQuery.widgetID = this.widgetID;
		}
	  	
	  	this.grid.setQuery(dataQuery);	
	  	this.onRefresh();
	},
	updateFooter: function (storeID) {
		window.document.body.style.cursor = "default";
		if (storeID == this.gridParms.store.id) {
			var total = this.totalRowCount;
			var filtered = this.filteredRows;
			var displayed = this.grid.getTotalRows();
			var numSelected = 0;
	    	if(this.selectRowCount == 0)
		       numSelected = this.grid.selection.getSelectedCount();
		    else
		       numSelected = this.selectRowCount;
			if(this.toggleFilterRowFeature)
				var footerText = dojo.string.substitute(this.resources_.TABLE_FOOTER_TEXT, { 0: total, 1: filtered, 2: displayed, 3: numSelected });
			else
				var footerText = dojo.string.substitute(this.resources_.TABLE_FOOTER_TEXT_NO_FILTERING, { 0: total, 1: displayed, 2: numSelected });
        	this.getFooterToolbar().setInfoAreaHTML( footerText );
        }
		if(this.pagingFeature == true){
			if(this.renderOnce == false){
				//this.PageRowSpinner();
			} else {
				if(this.filteredRows <= this.rowsPerPage){
					this.startValue = 0;
					this.countValue = this.filteredRows;
					//this.pageRowControl.setRowMax(this.filteredRows);
					//this.pageRowControl.setRowsPerPage(this.filteredRows);
					//this.pageRowControl.setCurrentPage(1);
					//this.pageRowControl.setPageMax(1);
					//this._currentPage = this.pageRowControl.getCurrentPage() - 1;
					this.pageSize = this.filteredRows;
				} else if(this.filteredRows < this.totalRowCount){
					this.countValue = this.rowsPerPage;
					//this.pageRowControl.setRowsPerPage(this.countValue);
					//this.pageRowControl.setRowMax(this.filteredRows);
					//this.pageRowControl.setPageMax(Math.ceil(this.filteredRows/this.countValue));
					//this._currentPage = this.pageRowControl.getCurrentPage() - 1;
					/*if(this.pageRowControl.rowMax < (this.startValue + this.countValue))
						this.pageSize = this.pageRowControl.rowMax - this.startValue;
					else
						this.pageSize = this.pageRowControl.rowsPerPage;*/
				} else {
					this.countValue = this.rowsPerPage;
					//this.pageRowControl.setRowsPerPage(this.countValue);
					//this.pageRowControl.setRowMax(this.totalRowCount);
					//this.pageRowControl.setPageMax(Math.ceil(this.totalRowCount/this.countValue));
					//this._currentPage = this.pageRowControl.getCurrentPage() - 1;
					/*if(this.pageRowControl.rowMax < (this.startValue + this.countValue))
						this.pageSize = this.pageRowControl.rowMax - this.startValue;
					else
						this.pageSize = this.pageRowControl.rowsPerPage;*/
				}
			}
		}
		this.renderOnce = true;
	},
	
	updateFooterSelected: function(gridSelector){
		window.document.body.style.cursor = "default";
		var total = this.totalRowCount;
		var filtered = this.filteredRows;
		var displayed = this.grid.getTotalRows();
		var numSelected = 0;
		if(this.selectRowCount == 0)
		   numSelected = this.grid.selection.getSelectedCount();
		else
		   numSelected = this.selectRowCount;
		   
		if(this.toggleFilterRowFeature)
			var footerText = dojo.string.substitute(this.resources_.TABLE_FOOTER_TEXT, { 0: total, 1: filtered, 2: displayed, 3: numSelected });
		else
			var footerText = dojo.string.substitute(this.resources_.TABLE_FOOTER_TEXT_NO_FILTERING, { 0: total, 1: displayed, 2: numSelected });
		this.getFooterToolbar().setInfoAreaHTML( footerText );
		if(this.pagingFeature == true){
			if(this.filteredRows <= this.rowsPerPage){
				this.startValue = 0;
				this.countValue = this.filteredRows;
				//this.pageRowControl.setRowMax(this.filteredRows);
				//this.pageRowControl.setRowsPerPage(this.filteredRows);
				//this.pageRowControl.setCurrentPage(1);
				//this.pageRowControl.setPageMax(1);
				//this._currentPage = this.pageRowControl.getCurrentPage() - 1;
				this.pageSize = this.filteredRows;
			} else if(this.filteredRows < this.totalRowCount){
				this.countValue = this.rowsPerPage;
				//this.pageRowControl.setRowsPerPage(this.countValue);
				//this.pageRowControl.setRowMax(this.filteredRows);
				//this.pageRowControl.setPageMax(Math.ceil(this.filteredRows/this.countValue));
				//this._currentPage = this.pageRowControl.getCurrentPage() - 1;
				/*if(this.pageRowControl.rowMax < (this.startValue + this.countValue))
					this.pageSize = this.pageRowControl.rowMax - this.startValue;
				else
					this.pageSize = this.pageRowControl.rowsPerPage;*/
			} else {
				this.countValue = this.rowsPerPage;
				//this.pageRowControl.setRowsPerPage(this.countValue);
				//this.pageRowControl.setRowMax(this.totalRowCount);
				//this.pageRowControl.setPageMax(Math.ceil(this.totalRowCount/this.countValue));
				//this._currentPage = this.pageRowControl.getCurrentPage() - 1;
				/*if(this.pageRowControl.rowMax < (this.startValue + this.countValue))
					this.pageSize = this.pageRowControl.rowMax - this.startValue;
				else
					this.pageSize = this.pageRowControl.rowsPerPage;*/
			}
		}
	},
	getFooterToolbar: function () {
		return (this.footerToolbar);
	},
	getToolbar: function () {
		return (this.toolbar);
	}, 
	onSearch: function (wclSearchField, event) 
	{		
		if (this.search) 
		{
			var columns = this.searchField.getSelectedColumns();
			this.search (columns, wclSearchField.searchField.value);
		}
	},
	search: function (columns, searchFor) {
		this.query = {};
		for (var x in columns) {
			if (x) {
				this.query[columns[x]] = searchFor;
			}
		}
		
		if (this.widgetID !== null && this.query.widgetID !== null) {
			this.query.widgetID = this.widgetID;
		}

		//convert to json
		var filterQueryOptions = dojo.toJson(this.query);
		
	   //this.grid.setQuery(this.query);
		this.gridParms.store._fetchCache = [];
		//var results = this.gridParms.store.fetch({query:this.query,queryOptions:{cache:true}, onComplete:this.fetchComplete()}) ;
		this.grid.setQuery(this.query);
		
		var kw = {
                    content:   {
                                  command: "quickFilter",
                                  arg_fqTableId: this.tableID,
                                  arg_portletNamespace: this.global.namespace,
								  filterQueryOptions: filterQueryOptions
                               },
                    timeout:   this.requestTimeout,
                    onResponse:{
                                  callback: dojo.hitch(this, this.getViewCallback)
                               },
                    error: this.handleError
                 };
	  	
        ibm.psw.wcl.dojo.Server.getSingleton().get( kw );
		
		if (searchFor == null || searchFor == "") {
			if (this.pagingFeature == true) {
				this.countValue = this.defaultRowsPerPage;
				this.rowsPerPage = this.defaultRowsPerPage;
				//this.pageRowControl.setRowsPerPage(this.defaultRowsPerPage);
				//this.pageRowControl.setRowMax(this.totalRowCount);
				//this.pageRowControl.setPageMax(Math.ceil(this.totalRowCount / this.countValue));
				//this.pageRowControl.setCurrentPage(1);
				//this._currentPage = this.pageRowControl.getCurrentPage() - 1;
				this.pageSize = this.defaultRowsPerPage;
			}
			this.gridParms.store._fetchCache = [];
			this.grid._refresh(true);
		}
			
		
	},
	_onRowClick: function (evt) {
		
		//First check if row is already selected
		if(this.grid.indirectSelector.get(evt.rowIndex)){
		  //console.debug("Row is already selected");
		}else{
		   this.grid.indirectSelector.preSelection(this.rowsPerPage);	
			if (this.serverSideSelect) {
				this.updateServerOnRowClick();
			}	
		}
     	/*if (this.multiSelect) {
			this.grid.indirectSelector.preSelection(this.rowsPerPage);	
			if (this.serverSideSelect) {
				this.updateServerOnRowClick();
			}	
		}else {
			var value = this.grid.selection.selected[evt.rowIndex];
			this.grid.indirectSelector._toggleSingleRow(evt.rowIndex, value);
		}*/
		
		
		this.updateFooter (this.gridParms.store.id);
	},
	
	updateServerOnRowClick: function(){
		var rowIDs = [];
		
		var actionParams = '';
		for (var i = 0, l = this.rowsPerPage; i < l; i++) {
			var index = i;
			var rowIdJSON = {};
			
			if (this.pagingFeature === true) {
				index = index + this.rowsPerPage * this._currentPage;
			}
			
			rowIdJSON.index = index;
			actionParams = actionParams + index + "-";
			
			if (this.grid.selection.selected[i]) {
				rowIdJSON.value = true;
				actionParams = actionParams + true + ",";
			}		
			else {
				rowIdJSON.value = false;
				actionParams = actionParams + false + ",";
			}
			
			rowIDs.push(rowIdJSON);
			
			var jsonSelectRowIds = {
				selectRowIDs: rowIDs
			};
		}
		
		var  jsonSelectCols = dojo.toJson(jsonSelectRowIds);
		
		var kw = {
                    content:   {
                                  command: "serverSelect",
                                  arg_fqTableId: this.tableID,
								  jsonSelectCols: jsonSelectCols,
                                  arg_portletNamespace: this.global.namespace
                               },
                    timeout:   this.requestTimeout,
                    onResponse:{
                                  callback: dojo.hitch(this, this.handleSelectCallBack)
                               },
                    error: this.handleError
                 };
	  	  	
        ibm.psw.wcl.dojo.Server.getSingleton().get( kw );
		
	},
	
	_onCellMouseOver: function (e) {
		//console.dir(e.cell);
		if (e.cell.editable) {
			dojo.style(e.cellNode, {cursor:"pointer"});
		}
	},
	
	showTableOptions: function () 
	{
//		
		this.tableOptionsDialog = new ibm.psw.wcl.dijit.WDTableOptionsDialog ( 
				{ table: this } 
			);
		
		this.tableOptionsDialog.show();
	},
	
	editSort: function(){
		
		this.tableSortDialog = new ibm.psw.wcl.dijit.WDTableSortDialog ( 
				{ table: this } 
			);
		
		this.tableSortDialog.show();
		
	},
	
	multiColSort: function(jsonSortCols){
		
		var columns = this.grid.layout.cells;
		var columnsVisible = new Array();
		
		for (var i in columns) {
			if (i) {
				var column = columns[i];
				
					var isVisible = column.visible===undefined?!column.hidden:column.visible;
					if(isVisible)
						columnsVisible[i]= i;
			}
		}
		
		if (columnsVisible.length > 0) {
			this.gridParms.store._fetchCache = [];
			var jsonSortOptions = dojo.toJson(jsonSortCols);
			var kw = {
                    content:   {
                                  command: "editSort",
                                  arg_fqTableId: this.tableID,
								  sortColsArr: jsonSortOptions,
                                  arg_portletNamespace: this.global.namespace
                               },
                    timeout:   this.requestTimeout,
                    onResponse:{
                                  callback: dojo.hitch(this, this.getViewCallback)
                               },
                    error: this.handleError
                 };
            ibm.psw.wcl.dojo.Server.getSingleton().get( kw );
		}
		
	},
	clearSorts: function(){
		
		var columns = this.grid.layout.cells;
		var columnsVisible = new Array();
		
		for (var i in columns) {
			if (i) {
				var column = columns[i];
				var isVisible = column.visible===undefined?!column.hidden:column.visible;
				if(isVisible)
				  columnsVisible[i]= i;
			}
		}
		
		if (columnsVisible.length > 0) {
			this.gridParms.store._fetchCache = [];
			var kw = {
				content: {
					command: "clearSorts",
					arg_fqTableId: this.tableID,
					arg_portletNamespace: this.global.namespace
				},
				timeout: this.requestTimeout,
				onResponse: {
					callback: dojo.hitch(this, this.getViewCallback)
				},
				error: this.handleError
			};
			
			ibm.psw.wcl.dojo.Server.getSingleton().get(kw);
		}
		
	},
	
	getColumnById: function (id) {
		var viewIndex = this.getViewColumnIndex (id);
		var column = this.grid.getCell (viewIndex);
//		
//		
		return (column);
	},
	toggleToolbar: function () {
		// TODO: implement
	},
	updateServer: function(gridSelector){
        var rowIDs = [];
        var total = this.totalRowCount;
		
		for(var i=0, l=this.rowsPerPage; i<l; i++){
			if(this.grid.selection.selected[i]){
				rowIDs.push(i);
			}
		}
		var actionParams = "";
		if (this.gridParms.selectionMode === "single") {
			var index = this.grid.selection.selectedIndex;
			if (this.pagingFeature == true) {
				index = index + this.rowsPerPage * this._currentPage;
			}
			actionParams = "" + index;
		}else{
		    if(this.isSelectAll === true && this.grid.selection.getSelectedCount() === this.gridParms.rowsPerPage){
			    actionParams = "all";
		    }else if(this.isDeselectAll === true && this.grid.selection.selectedIndex === -1){
			    actionParams = "none";
		    }else{
				var index = this.grid.indirectSelector.lastClickRowIdx;
				if (this.pagingFeature == true) {
					index = index + this.rowsPerPage * this._currentPage;
				}
				actionParams = "" + index;
		    }
		}
		
		var kw = {
                    content:   {
                                  command: "serverSelect",
                                  arg_fqTableId: this.tableID,
								  actionParam: actionParams,
                                  arg_portletNamespace: this.global.namespace
                               },
                    timeout:   this.requestTimeout,
                    onResponse:{
                                  callback: dojo.hitch(this, this.handleSelectCallBack)
                               },
                    error: this.handleError
                 };
	  	
        ibm.psw.wcl.dojo.Server.getSingleton().get( kw );
	},
	
	handleSelectCallBack: function(data){
		this.selectRowIndices = data[0].selectRowIndices;
		var list = dojox.json.query("=$.[?index='*']", this.selectRowIndices);
		if(list !== null)
		    this.selectRowCount = list.length;
		this.updateFooter (this.gridParms.store.id);
	},
	
	refreshSelection: function(){
		//Refresh the selection based on server side selection
		if (this.serverSideSelect) {
			if (this.selectRowIndices !== null) {
				var list = dojox.json.query("=$.[?index='*']", this.selectRowIndices);
				if (list !== null) {
					this.grid.selection.deselectAll();
					for (i = 0; i < list.length; i++) {
						var index = dojox.json.query("[" + i + "].index", this.selectRowIndices);
						index = index - this.rowsPerPage * this._currentPage;
						if (index >= 0 && index < this.rowsPerPage) {
							this.grid.selection.addToSelection(index);
						}
					}
					this.grid.indirectSelector.preSelection(this.rowsPerPage);
				}
			}
		}
	},
	
	_onMoveColumn: function (srcViewIndex, destViewIndex, srcIndex, destIndex, drugBefore) {
		this.grid.render();
		this.grid._resize();
		
		var columns = this.grid.layout.cells;
		for (var i in columns) {
			if (i) {
				column = columns[i];
			}
		}	
		
		var kw = {
                    content:   {
                                  command: "moveColumn",
                                  arg_fqTableId: this.tableID,
								  actionParam: actionParams,
								  srcIndex: srcIndex,
								  destIndex: destIndex,
                                  arg_portletNamespace: this.global.namespace
                               },
                    timeout:   this.requestTimeout,
                    error: this.handleError
                 };
	  	
	  
	  	
        ibm.psw.wcl.dojo.Server.getSingleton().get( kw );
	},
	
	PageRowSpinner: function(){
		var rowMax = this.totalRowCount;
		if(this.totalRowCount == 0)
		{
			var pageMax = 1;
			this.rowsPerPage = 0;
		} else {
			var pageMax = Math.ceil(this.totalRowCount/this.rowsPerPage);
		}
		divPageRowSpinner = dojo.doc.createElement( 'div' );
		this.footerAttach = this.footerToolbar.toolbar;
		this.pageRowControl = new ibm.psw.wcl.dijit.WDTablePageRowSpinner({
			pageMax: pageMax,
			pageMin: 1,
			currentPage: this._currentPage + 1,
			rowMax: rowMax,
			rowMin: 1,
			rowsPerPage: this.rowsPerPage
		}, divPageRowSpinner);
		this.footerAttach.addChild(this.pageRowControl);
		this.connections.push (dojo.connect (this.pageRowControl, "_onPageUpArrowClick", this, "onPageUpArrowClick"));
		this.connections.push (dojo.connect (this.pageRowControl, "_onPageDownArrowClick", this, "onPageDownArrowClick"));
		this.connections.push (dojo.connect (this.pageRowControl, "_onRowUpArrowClick", this, "onRowUpArrowClick"));
		this.connections.push (dojo.connect (this.pageRowControl, "_onRowDownArrowClick", this, "onRowDownArrowClick"));
		this.connections.push (dojo.connect (this.pageRowControl, "_updatePageSpinner", this, "updatePageSpinner"));
		this.connections.push (dojo.connect (this.pageRowControl, "_updateRowSpinner", this, "updateRowSpinner"));
		if(this.pageRowControl.currentPage == this.pageRowControl.pageMin)
			this.pageRowControl.imagePageDownArrow.style.opacity = 0.2;
		if(this.pageRowControl.currentPage == this.pageRowControl.pageMax)
			this.pageRowControl.imagePageUpArrow.style.opacity = 0.2;
		if(this.pageRowControl.rowsPerPage == this.pageRowControl.rowMin)
			this.pageRowControl.imageRowDownArrow.style.opacity = 0.2;
		if(this.pageRowControl.rowsPerPage == this.pageRowControl.rowMax)
			this.pageRowControl.imageRowupArrow.style.opacity = 0.2;
	},
	
	onPageUpArrowClick: function(){
		if(this._currentPage !== (this.pageRowControl.pageMax - 1)){
			this.startValue = this.pageRowControl.currentPage*this.pageRowControl.rowsPerPage - this.pageRowControl.rowsPerPage;
			this.countValue = this.pageRowControl.rowsPerPage;
			this.rowsPerPage = this.pageRowControl.rowsPerPage;
			this._currentPage = this.pageRowControl.getCurrentPage() - 1;
			this.pageSize = this.pageRowControl.rowsPerPage;
			if(this.pageRowControl.currentPage == this.pageRowControl.pageMin)
				this.pageRowControl.imagePageDownArrow.style.opacity = 0.2;
			else
				this.pageRowControl.imagePageDownArrow.style.opacity = 1;
			if(this.pageRowControl.currentPage == this.pageRowControl.pageMax)
				this.pageRowControl.imagePageUpArrow.style.opacity = 0.2;
			else
				this.pageRowControl.imagePageUpArrow.style.opacity = 1;
		this.gridParms.store._fetchCache = [];
		this.grid.setQuery(this.query);
		this.getView();
		this.refreshSelection();
		} else {
			window.document.body.style.cursor = "default";
		}
	},
	
	
	onPageDownArrowClick: function(){
		if(this._currentPage !== (this.pageRowControl.pageMin - 1)){
			this.startValue = this.pageRowControl.currentPage*this.pageRowControl.rowsPerPage - this.pageRowControl.rowsPerPage;
			this.countValue = this.pageRowControl.rowsPerPage;
			this.rowsPerPage = this.pageRowControl.rowsPerPage;
			this._currentPage = this.pageRowControl.getCurrentPage() - 1;
			this.pageSize = this.pageRowControl.rowsPerPage;
			if(this.pageRowControl.currentPage == this.pageRowControl.pageMin)
				this.pageRowControl.imagePageDownArrow.style.opacity = 0.2;
			else
				this.pageRowControl.imagePageDownArrow.style.opacity = 1;
			if(this.pageRowControl.currentPage == this.pageRowControl.pageMax)
				this.pageRowControl.imagePageUpArrow.style.opacity = 0.2;
			else
				this.pageRowControl.imagePageUpArrow.style.opacity = 1;
			this.gridParms.store._fetchCache = [];
		this.grid.setQuery(this.query);
		this.getView();
			this.refreshSelection();
		} else {
			window.document.body.style.cursor = "default";
		}
	},
	
	onRowUpArrowClick: function(){
		if(this.pageSize !== this.pageRowControl.rowMax){
			if(this.pageRowControl.pageMax <= this.pageRowControl.currentPage){
				this.pageRowControl.setCurrentPage(this.pageRowControl.pageMax);
			}
			this.startValue = this.pageRowControl.currentPage*this.pageRowControl.rowsPerPage - this.pageRowControl.rowsPerPage;
			this.countValue = this.pageRowControl.rowsPerPage;
			this.rowsPerPage = this.pageRowControl.rowsPerPage;
			this._currentPage = this.pageRowControl.getCurrentPage() - 1;
			this.pageSize = this.pageRowControl.rowsPerPage;
			if(this.pageRowControl.currentPage == this.pageRowControl.pageMin)
				this.pageRowControl.imagePageDownArrow.style.opacity = 0.2;
			else
				this.pageRowControl.imagePageDownArrow.style.opacity = 1;
			if(this.pageRowControl.currentPage == this.pageRowControl.pageMax)
				this.pageRowControl.imagePageUpArrow.style.opacity = 0.2;
			else
				this.pageRowControl.imagePageUpArrow.style.opacity = 1;
			this.gridParms.store._fetchCache = [];
		this.grid.setQuery(this.query);
		this.getView();
		this.refreshSelection();
		} else {
			window.document.body.style.cursor = "default";
		}
	},
	
	onRowDownArrowClick: function(){
		if(this.pageSize !== this.pageRowControl.rowMin){
			this.startValue = this.pageRowControl.currentPage*this.pageRowControl.rowsPerPage - this.pageRowControl.rowsPerPage;
			this.countValue = this.pageRowControl.rowsPerPage;
			this.rowsPerPage = this.pageRowControl.rowsPerPage;
			this._currentPage = this.pageRowControl.getCurrentPage() - 1;
			this.pageSize = this.pageRowControl.rowsPerPage;
			if(this.pageRowControl.currentPage == this.pageRowControl.pageMin)
				this.pageRowControl.imagePageDownArrow.style.opacity = 0.2;
			else
				this.pageRowControl.imagePageDownArrow.style.opacity = 1;
			if(this.pageRowControl.currentPage == this.pageRowControl.pageMax)
				this.pageRowControl.imagePageUpArrow.style.opacity = 0.2;
			else
				this.pageRowControl.imagePageUpArrow.style.opacity = 1;
			this.gridParms.store._fetchCache = [];
		this.grid.setQuery(this.query);
		this.getView();
		this.refreshSelection();
		} else {
			window.document.body.style.cursor = "default";
		}
	},
	
	updatePageSpinner: function(e){
		if(window.event){
			var keyNum = e.keyCode;
		} else if(e.which){
			var keyNum = e.which;
		}
		if(keyNum == "13"){
			if(this._currentPage !== (this.pageRowControl.pageMax - 1) || this._currentPage !== (this.pageRowControl.pageMin - 1)){
				this.startValue = this.pageRowControl.currentPage*this.pageRowControl.rowsPerPage - this.pageRowControl.rowsPerPage;
				this.countValue = this.pageRowControl.rowsPerPage;
				this.rowsPerPage = this.pageRowControl.rowsPerPage;
				this._currentPage = this.pageRowControl.getCurrentPage() - 1;
				this.pageSize = this.pageRowControl.rowsPerPage;
				if(this.pageRowControl.currentPage == this.pageRowControl.pageMin)
					this.pageRowControl.imagePageDownArrow.style.opacity = 0.2;
				else
					this.pageRowControl.imagePageDownArrow.style.opacity = 1;
				if(this.pageRowControl.currentPage == this.pageRowControl.pageMax)
					this.pageRowControl.imagePageUpArrow.style.opacity = 0.2;
				else
					this.pageRowControl.imagePageUpArrow.style.opacity = 1;
				this.gridParms.store._fetchCache = [];
				this.grid.setQuery(this.query);
			this.getView();
			this.refreshSelection();
			} else {
				window.document.body.style.cursor = "default";
			}
		}
	},
	
	updateRowSpinner: function(e){
		if(window.event){
			var keyNum = e.keyCode;
		} else if(e.which){
			var keyNum = e.which;
		}
		if(keyNum == "13"){
			if(this.pageSize !== this.pageRowControl.rowMin || this.pageSize !== this.pageRowControl.rowMax){
				if(this.pageRowControl.pageMax < this.pageRowControl.currentPage){
					this.pageRowControl.setCurrentPage(this.pageRowControl.pageMax);
				}
				this.startValue = this.pageRowControl.currentPage*this.pageRowControl.rowsPerPage - this.pageRowControl.rowsPerPage;
				this.countValue = this.pageRowControl.rowsPerPage;
				this.rowsPerPage = this.pageRowControl.rowsPerPage;
				this._currentPage = this.pageRowControl.getCurrentPage() - 1;
				this.pageSize = this.pageRowControl.rowsPerPage;
				if(this.pageRowControl.currentPage == this.pageRowControl.pageMin)
					this.pageRowControl.imagePageDownArrow.style.opacity = 0.2;
				else
					this.pageRowControl.imagePageDownArrow.style.opacity = 1;
				if(this.pageRowControl.currentPage == this.pageRowControl.pageMax)
					this.pageRowControl.imagePageUpArrow.style.opacity = 0.2;
				else
					this.pageRowControl.imagePageUpArrow.style.opacity = 1;
			this.gridParms.store._fetchCache = [];
			this.grid.setQuery(this.query);
			this.getView();
			this.refreshSelection();
			} else {
				window.document.body.style.cursor = "default";
			}			
		}
	},

	/** WDTable **
	 * formName - the encoded name of the form
	 * actionValue - the name of the component performing the action
	 * anchorName - the name of the anchor used when the page is refreshed
	 * wclhidden - the encoded name of the hidden field
	 * wclanchor - the encoded name of the hidden field for the anchor
	 * userActions - the userActions id to be used if the GO button is missing
	 */
	doUserActionAjax: function(formName, actionValue, anchorName, wclhidden, wclanchor, userActions) {
	   debug("-->doUserActionAjax");
	   var result = false;
	   //var dropDownId = "userActions"; //+ actionValue.substring(10);
	   //var dropDown = document.getElementById(dropDownId);
	   //debug("dropDownId [" + dropDownId + "]");
	   var ajax = true;
	   var skip = false;
	   if(this.tableDropDown.onItemClick() == this.exportDataServletPath)
			this.exportDataIconClicked = true;
	   /*if (dropDown) {
		  debug("got dropDown [" + dropDown.id + "]");
		  // See if we can skip this action (the --- Select Action --- is selected).
		  if (dropDown.selectedIndex == 0) {
			 debug("skip");
			 skip = true;
		  }
		  // See if this is a table action (not a user one).
		  else { //if (dropDown.options[dropDown.selectedIndex].value.indexOf("user(") == -1) {
			 debug("ajax");
			 ajax = true;
		  }
		  
		  var option = dropDown.options[dropDown.selectedIndex];
		  // check if this should be executed as AJAX or not
		  if(option.getAttribute("use_ajax") == null){
			return doAnchor(formName, anchorName, wclanchor, dropDownId);
		  }
		  
	   }*/
	   var message = this.tableDropDown.message();
	   if (WClient.isBrowserInternetExplorer()){  
				if(message!== null && message !== undefined){
					skip = !(confirm(message)); 
				}
			 } else {
				if(message !== null && message !== undefined){
					skip = !(confirm(message));
				}
			 }	  
				
	   if (!skip) {
		  var actionName = "action_";
		  actionName = actionName.concat(actionValue.substring(actionValue.indexOf("_") + 1));
		 //result = doAnchorAjax(formName, actionValue, anchorName, wclhidden, wclanchor, userActions);
		  if (this.exportDataIconClicked) {
		  	window.open(this.exportDataServletPath, '_self');
		  	this.exportDataIconClicked = false;
		  }
		  if (ajax) {
		      this.doTblAjax(formName, actionName, this.tableDropDown.onItemClick(), anchorName, actionName, wclhidden, wclanchor);	
		  } 
		 else {
			// result = doAnchor(formName, anchorName, wclanchor);
			 this.doTbl(formName, actionName, this.tableDropDown.onItemClick(), anchorName, actionName, wclhidden, wclanchor);
			 if (userActions) {
				var form = document.forms[formName];
				form.submit();
			 }
		  }
	   }
	   //dropDown.selectedIndex = 0;
	   debug("-->doUserActionAjax : " + result);
	   return result;
	},
	
	/** WDTable **
	 * formName - the encoded name of the form
	 * actionName - the name of the action being performed
	 * actionValue - the name of the component performing the action
	 * anchorName - the name of the anchor used when the page is refreshed
	 * actionNameEnc - the encoded name of the action being performed
	 * wclhidden - the encoded name of the hidden field
	 * wclanchor - the encoded name of the hidden field for the anchor
	 */
	doTblAjax: function(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor) {
	   if (document != null && document.forms != null && formName != null) {
		  var form = document.forms[formName];
		  if (form != null) {
			 if (actionName != null) {
				eval("form." + actionNameEnc + ".value = '" + actionValue + "'");
				eval("form." + wclhidden + ".value = '" + actionName + "'");
			 }

			 debug("actionNameEnc = " + actionNameEnc);
			 debug("actionValue = " + actionValue);

			 debug("AJAX request with action = " + form.action);
			 
			 startJSONTableRequest(form, null);
			 // Reset the form values.
			 eval("form." + actionNameEnc + ".value = ''");
			 eval("form." + wclhidden + ".value = ''");
		  }
		  return false;
	   }
	},
	
	/** WDTable **
	 * formName - the encoded name of the form
	 * actionName - the name of the action being performed
	 * actionValue - the name of the component performing the action
	 * anchorName - the name of the anchor used when the page is refreshed
	 * actionNameEnc - the encoded name of the action being performed
	 * wclhidden - the encoded name of the hidden field
	 * wclanchor - the encoded name of the hidden field for the anchor
	 */
	doTbl: function(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor) {
	   if (document != null && document.forms != null && formName != null) {
		  var form = document.forms[formName];
		  if (form != null) {
			 if (actionName != null) {
				eval("form." + actionNameEnc + ".value = '" + actionValue + "'");
				eval("form." + wclhidden + ".value = '" + actionName + "'");
			 }

			 this.doAnchor(formName, anchorName, wclanchor);

			 form.submit();
		  }
		  return false;
	   }
	},
	/** WDTable **
	 * formName - the encoded name of the form
	 * anchorName - the name of the anchor used when the page is refreshed
	 * wclanchor - the encoded name of the hidden field for the anchor
	 */
	doAnchor: function(formName, anchorName, wclanchor, dropDownId) {
	   var dropDown = document.getElementById(dropDownId);
	   var skip = false;
	   if (dropDown) { // message box must be shown
			// See if we can skip this action (the --- Select Action --- is selected).
			
			if(dropDown.value.indexOf("/ExportData?exportId") != -1) {
				window.open(dropDown.value,'_self');
				dropDown.selectedIndex = 0;
				skip = true;
			}else if (dropDown.selectedIndex != 0) {
				var option = dropDown.options[dropDown.selectedIndex];
				if (option){
					if (WClient.isBrowserInternetExplorer()) {  
						if (option.message!=null) {
							var message = option.getAttribute("message");
							skip = !(confirm(message)); 
						}
					} else {
						if (option.hasAttribute("message")) {
							var message = option.getAttribute("message");
							skip = !(confirm(message)); 
						}	     	
					}
				}
			}else{
				skip = true;        	
			}
	   }

		if (!skip) {
		   var form = document.forms[formName];
		   if (form != null && anchorName != null && wclanchor != null) {
			  var aDate = new Date().getTime();
			  eval("form." + wclanchor + ".value = '" + aDate + "'");
		
			  // remove existing anchorName
			  var index = form.action.indexOf( "#" );
			  if ( index != -1 )
			  {
				  form.action = form.action.substring( 0, index );
			  }
			  form.action += '#' + anchorName;
		
			  var inputName = "wclAnchorHash";
			  var input  = document.getElementById( inputName );
			  if ( !input )
			  {
				  input = document.createElement( "INPUT" );
				  with ( input )
				  {
					  type  = "hidden";
					  id    = inputName;
					  name  = inputName;
				  }
				  form.appendChild( input );
			  }
			  input.value = anchorName;
		   }
	   }
	   return !skip;
	}
	
	/*setStore: function(store){
		//	summary:
		//		Function to set the store on the paging table.
		//
		//	store:
		//		The store to set on the grid.
		this._store = new ibm.psw.wcl.dijit._ForcedPageStore(store, this);
		this.grid.setStore(this._store);
	}*/
});

dojo.declare("ibm.psw.wcl.dijit._ForcedPageStore", null,{
	//	summary:
	//		This class is designed to take any particular data store and wrap around it.
	//		The wrapper then modifies all incoming requests as well as alters the response
	//		to the callbacks of the requestin order to control how data is returned.
	//		This allows for forcing the grid into a 'page table' mode.

	//The datastore referenced and used by this store
	_store: null,

	//The paging table to get current/next page info from.
	_table: null,

	_selector: null,

	constructor: function(store, table) {
		//	summary:
		//		Function to builds the ForcedPaging table store.
		//
		//	store:
		//		The datastore to use.
		//	table:
		//		The paging table to get the current/netx page details from.
		if(store && table){
			this._store = store;
			this._table = table;
			this._buildMapperFunctions();
			this._customizeFetch();
		}else{
			throw new Error("Data store not provided.");
		}
	},

	_buildMapperFunctions: function(){
		//	summary:
		//		Function to construct the mapper functions to the data store.
		//		Loops through all public functions on the store and builds calls to them
		var i;
		for(i in this._store){
			if(i.toString().charAt(0) !== '_'){
				var member = this._store[i];
				//Check that all the 'Read' defined functions exist on the test store.
                if(dojo.isFunction(member)){
                    this[i] = this._createFunction(i);
				}
			}
		}
	},

	_customizeFetch: function(){
		//	summary:
		//		This function builds a custom fetch function, which over-rides 
		//		some of the datastore behaviors  to get page table mode.	 
		//		Effectively just usurps the callbacks callback and controls start/count.
		var self = this;
		this.fetch = function(request){
			request.start = self._table._currentPage * self._table.pageSize;
			if(self._table.renderOnce == true){
				var extraRows = self._table.startValue + self._table.countValue;
				if(self._table.pageRowControl.rowMax < extraRows){
					self._table.pageSize = self._table.pageRowControl.rowMax - self._table.startValue;
				}
			}
			request.count = self._table.pageSize;		
			var scope = request.scope || dojo.global;
			var onBegin = request.onBegin;
			var onComplete = request.onComplete;
			var onError = request.onError;
			var onItem = request.onItem;
			if(onBegin){
				request.onBegin = function(size, req){
					req.start = 0;
					req.count = self._table.pageSize;
					self._table._maxSize = size;
					//console.log("onBegin maxSize " + self._table._maxSize);
					//Now we figure out the new set of pages to list in the table selector.
					//Just using IFRS to do this.
					var pc = Math.ceil(self._table._maxSize/self._table.pageSize);
					var data = {identifier: "page", label: "desc", items: []};
					var i;
					for(i = 0; i < pc; i++){
						data.items.push({page: i, desc: "Page " + (i + 1) + " of " + pc});
					}
					var ifsStore = new dojox.data.util.JsonQuery({data: data});
					
                    self._table._maxSize = size;
					req.onBegin = onBegin;
					req.onBegin.call(scope, self._table.pageSize, req);
				};
			}
			if(onComplete){
				request.onComplete = function(items, req){
					req.start = 0;
					req.count = self._table.pageSize;
					req.onComplete = onComplete;
					req.onComplete.call(scope, items, req);
				};
			}
			if(onError){
				request.onError = function(err, req){
					req.start = 0;
					req.count = self._table.pageSize;
					req.onError = onError;
					req.onError.call(scope, err, req);
				};
			}
			if(onItem){
				request.onItem = function(item, req){
					req.start = 0;
					req.count = self._table.pageSize;
					req.onItem = onItem;
					req.onItem.call(scope, item, req);
				};
			}
			return self._store.fetch(request);
		};
	},

	_createFunction: function(name){
		//	summary:
		//		Creator function to generate a mapper to the actual store function.
		//	
		//	name:
		//		The name of the function to map to on the store.
		var self = this;
		return function(){
			return self._store[name].apply(self._store, arguments);
		};
	}
});
	

}//if _hasResource check
