/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.psw.wcl.dijit.WDTableFilter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.psw.wcl.dijit.WDTableFilter"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: %W%
 * Version:       %I%
 * Last Modified: %G%
 *******************************************************************************/

dojo.provide("ibm.psw.wcl.dijit.WDTableFilter");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.ContentPane");

// NLS
dojo.requireLocalization("ibm.psw.wcl.dijit", "resources", null, "ROOT,cs,de,en,en-us,es,fr,hu,it,ja,ko,pl,pt-br,ru,zh-cn,zh-tw");


// define the widget class
dojo.declare (
	"ibm.psw.wcl.dijit.WDTableFilter", 
    [ dijit._Widget, dijit._Container ],
{
    table: null,
    
	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
	    
	    this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");
	   // this.connections = [];
	   this.topics = [];
	   
	},
	postCreate: function() { 
		this.inherited ("postCreate", arguments);
		this.topics.push (dojo.subscribe ("columnsChanged", this, "_columnsVisible"));	
		this.addColumnsVisible (this.table.grid.layout.cells);	
		
	},
	_columnsVisible:function(){
		var columns = this.table.grid.layout.cells;
		this.destroyDescendants();
		this.addColumnsVisible(columns);
	},
	addColumnsVisible: function (columns) {
		
		var widget = null;
		var column = null;

		for (var i in columns) {
			if (i) {
				column = columns[i];
				//console.log("columnName"+column.name);
				var isVisible = column.visible===undefined?!column.hidden:column.visible;
				if(column.field != undefined && isVisible){
					if (column.name) {
						widget = new ibm.psw.wcl.dijit.FilterColumns ({
							id: this.id + "column_" + column.field,
							columnid: this.id + "column_" + column.field,
							baseid: column.field,
							label: column.name
						});
						//this.connections.push (dojo.connect (widget, "_onCheckBoxClick", this, "_onFilterClick"));
						this.addChild(widget);
					} else {
						
					}
				}
				
			}
		}	
		
			

		
	}
	
		
		
});


// define the widget class
dojo.declare (
	"ibm.psw.wcl.dijit.FilterColumns", 
    [ dijit._Widget, dijit._Templated ],
{
	columnid: null,
	label: null,
	baseid: null,
	widgetsInTemplate: true,
	templateString:"<div>\n\t<table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" >\n\t<tr>\n\t<td width=\"50%\"><a href=\"javascript:void(0)\" id=\"${columnid}HL\" dojoAttachPoint=\"linkNode\" dojoAttachEvent=\"onclick:_onHyperLinkClick\" >${label}</a>&nbsp;\n\t</td>\n\t\n\t</tr>\n\t</table>\n\t\t\n</div>\n",
	
	constructor: function () {
		
	},
	postCreate: function () {
		
		
	},
	
	destroy: function () {
		this.inherited (arguments);
		
	},
	_onHyperLinkClick: function() {
		
		//var checked =  dijit.byId (this.columnid+"CB").checked;
		dojo.publish ("filterSelected", [this.baseid,this.label]);
		//console.debug("here in _onCheckBoxClick....");
		
	}
	
	
});


}
