if(!dojo._hasResource["ibm.psw.wcl.dijit.WDTableFilterCriteria"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.psw.wcl.dijit.WDTableFilterCriteria"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: %W%
 * Version:       %I%
 * Last Modified: %G%
 *******************************************************************************/

dojo.provide("ibm.psw.wcl.dijit.WDTableFilterCriteria");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("ibm.psw.wcl.dijit.WDButton");
dojo.require("dijit.form.DateTextBox");
dojo.require("dijit.form.TimeTextBox");
dojo.require("dijit.form.NumberTextBox");

// NLS
dojo.requireLocalization("ibm.psw.wcl.dijit", "resources", null, "ROOT,cs,de,en,en-us,es,fr,hu,it,ja,ko,pl,pt-br,ru,zh-cn,zh-tw");

// define the widget class
dojo.declare (
	"ibm.psw.wcl.dijit.WDTableFilterCriteria", 
    [ dijit._Widget, dijit._Container ],
{
	id:null,
	filterType: "String",
	formID: null,
	tableID: null,
	table: null,
	stringFilter: null,
	columnid: null,
	columnName:null,
	dateFilter: null,
	numberFilter: null,
	booleanFilter: null,
	
	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
	    
	    this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");
	    //this.filterType = "String";
	   // this.connections = [];
	   	this.topics = [];
	   
	},
	postCreate: function() { 
		this.inherited ("postCreate", arguments);
		this.topics.push (dojo.subscribe ("columnsChanged", this, "_filtersVisible"));	
		this.createFilter();
		
	},
	_filtersVisible:function(){
		var columns = this.table.grid.layout.cells;
		
 		var columnsVisible = new Array();
		
		for (var i in columns) {
			if (i) {
				var column = columns[i];
				
					var isVisible = column.visible===undefined?!column.hidden:column.visible;
					if(isVisible)
						columnsVisible[i]= i;
					if((column.field == this.columnid) && !isVisible){
						this.destroyDescendants();
						break;
					}
				
			}
				
		}
		
		if(columnsVisible.length ==0){
			this.destroyDescendants();
			//this.filterType = null;
			//this.createFilter();
		}
		
	},
	createFilter: function(){
		if(this.filterType != null && this.filterType == "String"){
			//create String Filter
			this.cleanupWidgets();
			this.stringFilter = new ibm.psw.wcl.dijit.StringFilter({
				id: this.columnid + "_StringFilter",
				columnID: this.columnid,
				columnName: this.columnName,
				formID: this.formID,
				tableID: this.tableID,
				table: this.table
			});
			
			this.addChild(this.stringFilter);
			
		}
		if(this.filterType != null && this.filterType == "Date"){
			//create String Filter
			this.cleanupWidgets();
			this.dateFilter = new ibm.psw.wcl.dijit.DateFilter({
				id:this.columnid + "_DateFilter",
				columnID: this.columnid,
				columnName: this.columnName,
				formID: this.formID,
				tableID: this.tableID,
				table: this.table
			});
			
			this.addChild(this.dateFilter);
			
		}
		
		if(this.filterType != null && this.filterType == "Number"){
			//create String Filter
			this.cleanupWidgets();
			this.numberFilter = new ibm.psw.wcl.dijit.NumberFilter({
				id:this.columnid + "_NumberFilter",
				columnID: this.columnid,
				columnName: this.columnName,
				formID: this.formID,
				tableID: this.tableID,
				table: this.table
			});
			
			this.addChild(this.numberFilter);
			
		}
		
		if(this.filterType != null && this.filterType == "Boolean"){
			//create String Filter
			this.cleanupWidgets();
			this.booleanFilter = new ibm.psw.wcl.dijit.BooleanFilter({
				id:this.columnid + "_BooleanFilter",
				columnID: this.columnid,
				columnName: this.columnName,
				formID: this.formID,
				tableID: this.tableID,
				table: this.table
			});
			
			this.addChild(this.booleanFilter);
			
		}
	},
	cleanupWidgets: function(){
		if(this.dateFilter){
				this.dateFilter.destroy();
			}
			
		if(this.stringFilter){
				this.stringFilter.destroy();
			}
	},
	destroy: function(){
		// destroy all children
		var id = this.id;
		this.destroyDescendants();
		dijit.registry.remove (id);
		// then let the widget destroy itself
		this.inherited("destroy",arguments);
	}

	

});

dojo.declare (
	"ibm.psw.wcl.dijit.StringFilter", 
    [ dijit._Widget, dijit._Templated ],
 {
 
 	/*Stores the path to the template string*/
	templatePath: dojo.moduleUrl("ibm.psw.wcl.dijit", "templates/WDStringFilter.html"),
	widgetsInTemplate: true,
	id: null,
	columnName: null,
	columnID:null,
	condition: null,
	conditionText: null,
	matchCase: false,
	table: null,
	formID: null,
	tableID: null,
	attributeMap: {condition: "conditionCB",conditionText: "conditionTextBox",matchCase: "matchCaseCB" },
		
	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
		
	    this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");
	    
	},
	postCreate: function () {
		this.inherited ("postCreate", arguments);
		
		if (this.matchCase) {
			this.matchCaseCB.setChecked (this.matchCase);
		}
		if(this.condition == null) {
			this.condition = "0";
		}
		else{
			this.conditionCB.setValue(this.condition);
		}
		
		if(this.conditionText)
		this.conditionTextBox.setValue(this.conditionText);
		
		
		
		
	},
	
	setAttributes: function(matchCase, condition, conditionText) {
		
		this.matchCase = matchCase;
		this.matchCaseCB.setChecked (matchCase);
		
		this.condition = condition;
		this.conditionCB.setValue(condition);
				
		this.conditionText= conditionText;
		this.conditionTextBox.setValue(conditionText);
	
		
	},
	
	onOK: function() {
 		var columns = this.table.grid.layout.cells;
		var allColumns = [];
		var isVisible = true;
		
		for (var i in columns) {
			if (i) {
				var column = columns[i];
				
				if(this.columnID!= undefined && (this.columnID == column.field) ){
					isVisible = column.visible===undefined?!column.hidden:column.visible;
				}
			}
		}
		if(isVisible){
	      	this.table.gridParms.store._fetchCache = [];
	      	this.table.gridParms.queryOptions = {cache:false} ;
			 var kw = {
	                    content:   {
	                                  command: "applyFilter",
									  arg_fqTableId: this.tableID,
	                                  filterType:"String",
	                                  columnName:this.columnName,
	                                  columnid: this.columnID,
	                                  condition: this.conditionCB.getValue(),
	                                  conditionText: this.conditionTextBox.getValue(),
	                                  matchCase: this.matchCaseCB.checked
	                               },
	                    timeout: this.requestTimeout,
						onResponse:{
                                     callback: dojo.hitch(this.table, this.table.getViewCallback)
                                   },
	                    error: this.table.handleError
	                 };
		  	ibm.psw.wcl.dojo.Server.getSingleton().get( kw );
		}	
		
	},
	
	onCancel: function(){
	},
	destroy: function(){
		// destroy all children
		this.destroyDescendants();
		dijit.registry.remove (this.id);
		// then let the widget destroy itself
		this.inherited("destroy",arguments);
	}
	   
 
 });
  
 
 dojo.declare (
	"ibm.psw.wcl.dijit.DateFilter", 
    [ dijit._Widget, dijit._Templated ],
 {
 
 	/*Stores the path to the template string*/
	templatePath: dojo.moduleUrl("ibm.psw.wcl.dijit", "templates/WDDateFilter.html"),
	widgetsInTemplate: true,
	id: null,
	columnName: null,
	columnID:null,
	condition: null,
	date1: new Date(),
	date2: new Date(),
	time1: null,
	time2: null,
	table: null,
	formID: null,
	tableID: null,
	attributeMap: {condition: "conditionCB",date1: "date1TB",date2: "date2TB", time1:"time1TB",time2:"time2TB"  },
		
	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
		
	    this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");
	    
	},
	postCreate: function () {
		this.inherited ("postCreate", arguments);
		
		
		if(this.condition == null) {
			this.condition = "0";
		}
		else{
			this.conditionCB.setValue(this.condition);
		}
		
			
		
	},
	
	setAttributes: function(condition) {
		
		this.condition = condition;
		this.conditionCB.setValue(condition);
		
	},
	_setDateTime: function(){
		if(this.conditionCB.getValue() != "0"){
			this.dateTime1.style.display = "block";
		}else{
			this.dateTime1.style.display = "none";
		}
		
		if(this.conditionCB.getValue() == "3"){
			this.dateTime2.style.display = "block";
		}else{
			this.dateTime2.style.display = "none";
		}
			
	},
	
	onOK: function() {
 		var columns = this.table.grid.layout.cells;
		var allColumns = [];
 		
 		var isVisible = true;
		
		for (var i in columns) {
			if (i) {
				var column = columns[i];
				
				if(this.columnID!= undefined && (this.columnID == column.field) ){
					isVisible = column.visible===undefined?!column.hidden:column.visible;
				}
			}
		}
		if (isVisible) {
			this.table.gridParms.store._fetchCache = [];
			this.table.gridParms.queryOptions = {
				cache: false
			};
			
			var date1 = null;
			var time1 = null;
			if (this.dateTime1.style.display == "block") {
				date1 = this.date1TB.getValue();
				time1 = this.time1TB.getValue();
			}
			var date2 = null;
			var time2 = null;
			if (this.dateTime2.style.display == "block") {
				date2 = this.date2TB.getValue();
				time2 = this.time2TB.getValue();
			}
			
			var kw = {
				content: {
					command: "applyFilter",
					arg_fqTableId: this.tableID,
					filterType: "Date",
					columnName: this.columnName,
					columnid: this.columnID,
					condition: this.conditionCB.getValue(),
					date1: date1,
					time1: time1,
					date2: date2,
					time2: time2
				
				},
				timeout: this.requestTimeout,
				onResponse: {
					callback: dojo.hitch(this.table, this.table.getViewCallback)
				},
				error: this.table.handleError
			};
			ibm.psw.wcl.dojo.Server.getSingleton().get(kw);
		}
		
	},
	
	onCancel: function(){
	},
	destroy: function(){
		// destroy all children
		this.destroyDescendants();
		// then let the widget destroy itself
		this.inherited("destroy",arguments);
	}
	   
 
 });
 
 dojo.declare (
	"ibm.psw.wcl.dijit.NumberFilter", 
    [ dijit._Widget, dijit._Templated ],
 {
 
 	/*Stores the path to the template string*/
	templatePath: dojo.moduleUrl("ibm.psw.wcl.dijit", "templates/WDNumberFilter.html"),
	widgetsInTemplate: true,
	id: null,
	columnName: null,
	columnID:null,
	condition: null,
	number1: null,
	number2: null,
	table: null,
	formID: null,
	tableID: null,
	attributeMap: {condition: "conditionCB",number1: "number1TB",number2: "number2TB"},
		
	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
		
	    this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");
	    
	},
	postCreate: function () {
		this.inherited ("postCreate", arguments);
		
		
		if(this.condition == null) {
			this.condition = "0";
		}
		else{
			this.conditionCB.setValue(this.condition);
		}
		
			
		
	},
	
	setAttributes: function(condition) {
		
		this.condition = condition;
		this.conditionCB.setValue(condition);
		
	},
	_setNumber: function(){
		if(this.conditionCB.getValue() != "0"){
			this.number1Node.style.display = "block";
		}else{
			this.number1Node.style.display = "none";
		}
		
		if((this.conditionCB.getValue() == "7") || (this.conditionCB.getValue() == "8")){
			this.number2Node.style.display = "block";
		}else{
			this.number2Node.style.display = "none";
		}
			
	},
	
	onOK: function() {
 		var columns = this.table.grid.layout.cells;
		var allColumns = [];
 		
 		var isVisible = true;
		
		for (var i in columns) {
			if (i) {
				var column = columns[i];
				
				if(this.columnID!= undefined && (this.columnID == column.field) ){
					isVisible = column.visible===undefined?!column.hidden:column.visible;
				}
			}
		}
		if (isVisible) {
			this.table.gridParms.store._fetchCache = [];
			this.table.gridParms.queryOptions = {
				cache: false
			};
			
			var number1 = null;
			
			if (this.number1Node.style.display == "block") {
				number1 = this.number1TB.getValue();
				
			}
			var number2 = null;
			
			if (this.number2Node.style.display == "block") {
				number2 = this.number2TB.getValue();
				
			}
			
			var kw = {
				content: {
					command: "applyFilter",
					arg_fqTableId: this.tableID,
					filterType: "Number",
					columnName: this.columnName,
					columnid: this.columnID,
					condition: this.conditionCB.getValue(),
					number1: number1,
					number2: number2
				
				},
				timeout: this.requestTimeout,
				onResponse: {
					callback: dojo.hitch(this.table, this.table.getViewCallback)
				},
				error: this.table.handleError
			};
			
			ibm.psw.wcl.dojo.Server.getSingleton().get(kw);
		}
		
		
	},
	
	onCancel: function(){
	},
	destroy: function(){
		// destroy all children
		this.destroyDescendants();
		// then let the widget destroy itself
		this.inherited("destroy",arguments);
	}
});

dojo.declare (
	"ibm.psw.wcl.dijit.BooleanFilter", 
    [ dijit._Widget, dijit._Templated ],
 {
 
 	/*Stores the path to the template string*/
	templatePath: dojo.moduleUrl("ibm.psw.wcl.dijit", "templates/WDBooleanFilter.html"),
	widgetsInTemplate: true,
	id: null,
	columnName: null,
	columnID:null,
	condition: null,
	table: null,
	formID: null,
	tableID: null,
	attributeMap: {condition: "conditionCB"},
		
	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
		
	    this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");
	    
	},
	postCreate: function () {
		this.inherited ("postCreate", arguments);
		
		
		if(this.condition == null) {
			this.condition = "0";
		}
		else{
			this.conditionCB.setValue(this.condition);
		}
	},
	
	setAttributes: function(condition) {
		
		this.condition = condition;
		this.conditionCB.setValue(condition);
		
	},
	
	onOK: function() {
 		var columns = this.table.grid.layout.cells;
		var allColumns = [];
 		
 		var isVisible = true;
		
		for (var i in columns) {
			if (i) {
				var column = columns[i];
				
				if(this.columnID!= undefined && (this.columnID == column.field) ){
					isVisible = column.visible===undefined?!column.hidden:column.visible;
				}
			}
		}
		if (isVisible) {
			this.table.gridParms.store._fetchCache = [];
			this.table.gridParms.queryOptions = {
				cache: false
			};
			
			var kw = {
				content: {
					command: "applyFilter",
					arg_fqTableId: this.tableID,
					filterType: "Boolean",
					columnName: this.columnName,
					columnid: this.columnID,
					condition: this.conditionCB.getValue()
				
				},
				timeout: this.requestTimeout,
				onResponse: {
					callback: dojo.hitch(this.table, this.table.getViewCallback)
				},
				error: this.table.handleError
			};
			
			ibm.psw.wcl.dojo.Server.getSingleton().get(kw);
		}
	},
	
	onCancel: function(){
	},
	destroy: function(){
		// destroy all children
		this.destroyDescendants();
		// then let the widget destroy itself
		this.inherited("destroy",arguments);
	}
	
	
	});
 
 
 }
