/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.psw.wcl.dijit.WDTableFilterDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.psw.wcl.dijit.WDTableFilterDialog"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: %W%
 * Version:       %I%
 * Last Modified: %G%
 *******************************************************************************/

dojo.provide("ibm.psw.wcl.dijit.WDTableFilterDialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Form");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit._Container");
dojo.require("ibm.psw.wcl.dijit.WDButton");
dojo.require("ibm.psw.wcl.dijit.WDTableFilter");
dojo.require("ibm.psw.wcl.dijit.WDTableFilterCriteria");

// NLS
dojo.requireLocalization("ibm.psw.wcl.dijit", "resources", null, "ROOT,cs,de,en,en-us,es,fr,hu,it,ja,ko,pl,pt-br,ru,zh-cn,zh-tw");


// define the widget class
dojo.declare (
	"ibm.psw.wcl.dijit.WDTableFilterDialog", 
    [ dijit._Widget, dijit._Templated ],
{
	templateString:"<div>\n  <div dojoType=\"dijit.Dialog\" dojoAttachPoint=\"dialog\"\ttitle=\"${resources_.TABLE_FILTER}\"\tstyle=\"display:none;\" >\n\n\t\t<div id=\"${id}tabs\" dojoType=\"dijit.layout.TabContainer\" class=\"dialog\" style=\"width: 550px; height: 300px;\" >\n\t\t\t<div dojoType=\"dijit.layout.BorderContainer\" title=\"${resources_.COLUMNS}\"\n\t\t\t \tclass=\"dialog\" style=\"width: 550px;height: 300px;\">\n\t\t\t<div dojoType=\"dijit.layout.ContentPane\"  style=\"width: 250px;height: 250px;\" region=\"left\"  \n\t\t\t \tclass=\"dialog\" style=\"padding: 15px\">\n\t\t\t\t<div style=\"width: 220px; height: 250px; overflow: auto\" >\n\t\t\t\t \t${resources_.COLUMNS_FILTERABLE}\n\t\t\t\t \t<div id=\"${id}columnsVisibleDivContainer\">\n\t\t\t\t \t</div>\n\t\t\t\t </div>\n\t\t\t</div>\n\t\t<div dojoType=\"dijit.layout.ContentPane\"  dojoAttachPoint=\"filterPane\" style=\"width: 250px;height: 200px;\" region=\"right\" title=\"${resources_.COLUMNS}\" \n\t\t\t \tclass=\"dialog\" style=\"padding: 15px\">\n\t\t\t\t<div id=\"${id}filterCriteriaContainer\">\n\t\t\t\t \t</div>\n\t\t\t\t </div>\t  \n\n\t\t</div>\t  \n\n\t\t  </div>\t  \n\n\t\t<div dojoType=\"dijit.Toolbar\" style=\"padding: 0px\">\n\t\t\t<button  \n\t\t\t       value=\"${resources_.CLOSE}\"\n\t\t\t       dojoType=\"ibm.psw.wcl.dijit.WDButton\"\n\t\t\t       dojoAttachEvent=\"onClick:onOK\" \n\t\t\t>${resources_.CLOSE}</button>\n\t\t\t</div>\n\n  </div>\n</div>\n",
	widgetsInTemplate: true,
	table: null,
	formID: null,
	tableID: null,
	filter: null,
	stringFilter: null,
	dateFilter: null,
	numberFilter: null,
	booleanFilter: null,

	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
		
	    this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");
	    this.connections = [];
	    this.topics = [];
	    this.filter = null;
	},
	postCreate: function() { 
		this.inherited ("postCreate", arguments);
		

		this.filter =new ibm.psw.wcl.dijit.WDTableFilter (
			{
				table: this.table
			}, 
			dojo.byId(this.id + "columnsVisibleDivContainer")
		);
		this.filter.startup();
		this.topics.push (dojo.subscribe ("filterSelected", this, "_onClick"));	
		
	},
	_onClick: function(columnid,columnName){
		//console.debug("here in onclick of Filter dialog...."+columnid + columnName+ this.id);
		
		var columns = this.table.grid.layout.cells;
		var allColumns = [];
		
			for (var i in columns) {
				if (i) {
					var column = columns[i];
					if(columnid!= undefined && (columnid == column.field) ){
						var dataType = column.dataType;
						
						if(dataType == "number"){
							this.cleanupFilters();
							numDiv = dojo.doc.createElement( 'div' );
							numDiv.id = columnid+columnName+"_NumberFilter";
							dojo.byId(this.id + "filterCriteriaContainer").appendChild(numDiv);
							this.numberFilter = this.createNumberFilter(columnid,columnName,numDiv);
							this.numberFilter.startup();
						}else if(dataType == "date"){
							this.cleanupFilters();
							dateDiv = dojo.doc.createElement( 'div' );
							dateDiv.id = columnid+columnName+"_DateFilter";
							dojo.byId(this.id + "filterCriteriaContainer").appendChild(dateDiv);
							this.dateFilter = this.createDateFilter(columnid,columnName,dateDiv);
							this.dateFilter.startup();
						}else if(dataType == "String"){
							this.cleanupFilters();
							strDiv = dojo.doc.createElement( 'div' );
							strDiv.id = columnid+columnName+"_StringFilter";
							dojo.byId(this.id + "filterCriteriaContainer").appendChild(strDiv);
							this.stringFilter = this.createStringFilter(columnid,columnName,strDiv);
							this.stringFilter.startup();
						}else if(dataType == "boolean"){
							this.cleanupFilters();
							boolDiv = dojo.doc.createElement( 'div' );
							boolDiv.id = columnid+columnName+"_BoolFilter";
							dojo.byId(this.id + "filterCriteriaContainer").appendChild(boolDiv);
							this.booleanFilter = this.createBooleanFilter(columnid,columnName,boolDiv);
							this.booleanFilter.startup();
						}
					
					}
					
				}
			}
			
		
		
	},
	
	cleanupFilters: function(){
		
		if(this.numberFilter){
			this.numberFilter.destroy();
		}
		if(this.dateFilter){
			this.dateFilter.destroy();
		}
		if(this.stringFilter){
			this.stringFilter.destroy();
		}
		if(this.booleanFilter){
			this.booleanFilter.destroy();
		}
		
		
	},
	
	createStringFilter: function(columnid,columnName,strDiv){
		var filter = new ibm.psw.wcl.dijit.WDTableFilterCriteria(
				{
				  id:columnid+columnName,
				  filterType:"String",
				  columnid: columnid,
				  columnName: columnName,
				  formID: this.formID,
				  tableID: this.tableID,
				  table: this.table
				},
				strDiv
				);
				
		return filter;
				
	},
	createNumberFilter: function(columnid,columnName,numDiv){
		var filter = new ibm.psw.wcl.dijit.WDTableFilterCriteria(
				{
				  id:columnid+columnName,
				  filterType:"Number",
				  columnid: columnid,
				  columnName: columnName,
				  formID: this.formID,
				  tableID: this.tableID,
				  table: this.table
				},
				numDiv
				);
				
		return filter;
				
	},
	createDateFilter: function(columnid,columnName,dateDiv){
		var filter = new ibm.psw.wcl.dijit.WDTableFilterCriteria(
				{
				  id:columnid+columnName,
				  filterType:"Date",
				  columnid: columnid,
				  columnName: columnName,
				  formID: this.formID,
				  tableID: this.tableID,
				  table: this.table
				},
				dateDiv
				);
				
		return filter;
				
	},
	createBooleanFilter: function(columnid,columnName,boolDiv){
		var filter = new ibm.psw.wcl.dijit.WDTableFilterCriteria(
				{
				  id:columnid+columnName,
				  filterType:"Boolean",
				  columnid: columnid,
				  columnName: columnName,
				  formID: this.formID,
				  tableID: this.tableID,
				  table: this.table
				},
				boolDiv
				);
				
		return filter;
				
	},
		
	onOK: function () {
		// TODO: persist changes
		
		//this.filter.onSave();
		this.hide();
	},
	onCancel: function () {
		
		this.hide();
		// TODO: revert changes
	},
	show: function () {
		this.dialog.show();
		dijit.byId (this.id + "tabs").resize();
	},
	hide: function () {
		this.dialog.hide();
		//setTimeout (dojo.hitch (this, this.kill), 100);
	},
	kill: function () {
		var id = this.id;
		this.destroyRecursive();
		dijit.registry.remove (id);
	},
	getFilter: function () {
		return (this.filter);
	}
});



}
