/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.psw.wcl.dijit.WDTableFooter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.psw.wcl.dijit.WDTableFooter"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * 5724-C51
 *
 * (C) Copyright IBM Corp. 2008 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

// NLS
dojo.requireLocalization("ibm.psw.wcl.dijit", "resources", null, "ROOT,cs,de,en,en-us,es,fr,hu,it,ja,ko,pl,pt-br,ru,zh-cn,zh-tw");

dojo.provide("ibm.psw.wcl.dijit.WDTableFooter");
/******************************************************************************
* The footer for the WCL Table
*
* Authors: Joseph Firebaugh, Joshua Allen
******************************************************************************/
dojo.declare("ibm.psw.wcl.dijit.WDTableFooter",
            [ dijit._Widget, dijit._Templated ],
{
  widgetsInTemplate: true,

  templateString:"<table class=\"wcl-table-footer-border\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n\t<tbody>\n\t\t<tr class=\"wcl-table-footer\" dir=\"ltr\">\n\t\t\t<td class=\"wcl-table-footer-data\" width=\"45%\" nowrap=\"nowrap\"> \n\t\t\t\t<div dojoType=\"dijit.Toolbar\" dojoAttachPoint=\"toolbar\" class=\"tableToolbarArea\" align=\"left\" width=\"100%\"></div>\n\t\t\t</td>\t\t\t\n\t\t\t<td width=\"35%\"></td>\t\t\t\n\t\t\t<td class=\"wcl-table-footer-data\" nowrap=\"nowrap\" valign=\"middle\" width=\"20%\"> \n\t\t\t\t<div dojoAttachPoint=\"infoArea\" class=\"footerLabel\" align=\"right\" width=\"100%\"></div>\n\t\t\t</td>\n\t\t</tr>\n\t</tbody>\n</table>\n",
  
  //the dojox.Grid that this footer belongs to
  table: null,
  
  constructor: function () 
  {
    this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");    
  },
  
  postCreate: function()
  {
    if ( this.table !== null )
    {
      this.setTable( this.table );
    }        
  },
  
  setTable: function( table )
  {
    this.table = table;
    
    this._rowClickListener = dojo.connect( this.table, "onRowClick", this, "_onRowClick");            
    this._updateListener   = dojo.connect( this.table, "setModel",   this, "_onRowClick" );            
    
  },
  
  getToolbar: function () 
  {
  	return (this.toolbar);
  },
  
  _onRowClick: function()
  {      
    var numSelected = 0;
    var totalRows   = 0;
    
    if ( this.table.model )
    {
		if (this.table.model.getRealRowCount) {
			totalRows = this.table.model.getRealRowCount();
		} else {
			totalRows = this.table.model.getRowCount();
		}
    }

    numSelected = this.table.selection.getSelectedCount();
    
    this.updateFooter( numSelected, totalRows );
  },
    
  updateFooter: function( numSelected, totalRows )
  {
    this.setInfoAreaHTML( dojo.string.substitute( this.resources_.TABLE_FOOTER_TEXT, { 0: numSelected, 1: totalRows } ) );  
  },
  
  setInfoAreaHTML: function ( html )
  {
    this.infoArea.innerHTML = html;
  },
  
  destroy: function()
  {
    if ( this._rowClickListener ) { dojo.disconnect( this._rowClickListener ); }
    if ( this._updateListener )   { dojo.disconnect( this._updateListener ); }
    
    this.toolbar.destroy();
    
    this.inherited( "destroy", arguments );
  }  
});

}
