/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.psw.wcl.dijit.WDTableOptions"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.psw.wcl.dijit.WDTableOptions"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: %W%
 * Version:       %I%
 * Last Modified: %G%
 *******************************************************************************/

dojo.provide("ibm.psw.wcl.dijit.WDTableOptions");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");
dojo.require("dijit.form.CheckBox");

// NLS
dojo.requireLocalization("ibm.psw.wcl.dijit", "resources", null, "ROOT,cs,de,en,en-us,es,fr,hu,it,ja,ko,pl,pt-br,ru,zh-cn,zh-tw");


// define the widget class
dojo.declare (
	"ibm.psw.wcl.dijit.WDTableOptions", 
    [ dijit._Widget, dijit._Container ],
{
    table: null,

	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
	    
	    this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");
	},
	postCreate: function() { 
		this.inherited ("postCreate", arguments);
		
		this.addColumnsVisible (this.table.grid.layout.cells);
	},
	addColumnsVisible: function (columns) {
		
		var widget = null;
		var column = null;

		for (var i in columns) {
			if (i) {
				column = columns[i];
				//console.log("columnName"+column.name);
				
				if (column.name) {
					widget = new ibm.psw.wcl.dijit.ColumnVisible ({
						id: this.id + "column_" + column.field,
						columnid: this.id + "column_" + column.field,
						baseid: column.field,
						checked: column.visible===undefined?!column.hidden:column.visible,  
						label: column.name
					});
					this.addChild (widget);
					
				} else {
					
				}
			}
		}		

		
	},
	
	// add on2009/07/07 by chujing for function selectall
	
	onSelectAll: function(){
		
	var columns = this.table.grid.layout.cells;	 
		for (var i in columns) {
			if (i) {
				var columnWidget = dijit.byId (this.id + "column_" + columns[i].field);
				columnWidget.setVisible(true);	 
			}
		}
		
	},
	// add on2009/07/07 by chujing for function deselectall
	onDeselectAll:function (){
    var columns = this.table.grid.layout.cells;
		 
		for (var i in columns) {
			if (i) {
				var columnWidget = dijit.byId (this.id + "column_" + columns[i].field);
				columnWidget.setVisible(false);	 
			}
		}

	},
	onSave: function () {
		var columns = this.table.grid.layout.cells;
		var allColumns = [];
	
		for (var i in columns) {
			if (i) {
				var column = columns[i];
				var columnWidget = dijit.byId (this.id + "column_" + column.field);
				var tblColumn = this.table.getColumnById (column.field);
				column.visible = columnWidget.isVisible();
				columns[i].visible=columnWidget.isVisible();//added at 2009/04/24 for function show/hidden column
				

				if (tblColumn) {
					// In order to preserve the column width, we need to set the width property
					tblColumn.width = tblColumn.unitWidth;
					// set these values on the originalStruture so they will be in memory
					// in case the dialog is opened again
					column.width = tblColumn.unitWidth;
				} else {
					tblColumn = column;
				}
				
				this.table.grid.layout.setColumnVisibility(i, columnWidget.isVisible());

				
				
				allColumns.push (column);
			}
		}
	
		this.table.savePreferences();
		this.table.grid.layout.cells = allColumns;
		
		
	},
	isColumnVisible: function (columnID) {
		var columnWidget = dijit.byId (this.id + "column_" + columnID);
		return (columnWidget.isVisible());
	}
	
});


// define the widget class
dojo.declare (
	"ibm.psw.wcl.dijit.ColumnVisible", 
    [ dijit._Widget, dijit._Templated ],
{
	columnid: null,
	label: null,
	checked: false,
	widgetsInTemplate: true,
	templateString:"<div>\n\t<input dojoType=\"dijit.form.CheckBox\" dojoAttachPoint=\"checkbox\" name=\"${columnid}CB\" id=\"${columnid}CB\" value=\"\" />\n\t\t&nbsp;\n\t<label for=\"${columnid}CB\">${label}</label>\n</div>\n",
	
	constructor: function () {
		
	},
	postCreate: function () {
		
		if (this.checked) {
			this.checkbox.setChecked (this.checked);
		}
		
	},
	setVisible: function (checked) {
		this.checkbox.setChecked (checked);
	},
	isVisible: function () {
		return this.checkbox.checked;
	},
	destroy: function () {
		
		
		this.inherited (arguments);
		
	}
	
});


}
