/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.psw.wcl.dijit.WDTableSearchField"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.psw.wcl.dijit.WDTableSearchField"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * 5724-C51
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.Dialog");
dojo.require("dijit.Menu");
dojo.require("dijit.Tooltip");
dojo.require("ibm.psw.wcl.dijit.WDTableDropDownButton");

// NLS
dojo.requireLocalization("ibm.psw.wcl.dijit", "resources", null, "ROOT,cs,de,en,en-us,es,fr,hu,it,ja,ko,pl,pt-br,ru,zh-cn,zh-tw");

dojo.provide("ibm.psw.wcl.dijit.WDTableSearchField");

dojo.declare("ibm.psw.wcl.dijit.WDTableSearchField",
            [ dijit._Widget, dijit._Templated ],
{
  widgetsInTemplate: true,
  
  /* The WTable that this search bar is attached to */
  table: null,
  
  _ALL_COLS_NAME: "QF_ALL_COLS",
  
  /** An array of column names that should participate in filtering **/
  columnsToFilterOn: { "QF_ALL_COLS": true },
  
  /** Keeps track of all topic subscriptions to cleanly destroy later **/
  topics: [],
  
  _qf_arrow_src: dojo.moduleUrl("ibm.psw.wcl.dijit","themes/images/qf_arrow.gif"),
  
  /** Keeps track of all event connections **/
  objectConnections: [],
  
  /** Keeps track of all children widgets in dropdown **/
  childrenWidgets: [],
  
  templateString:"<div class=\"quick-filter\">\n<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n<tbody>\n<tr>\n<td dojoAttachPoint=\"colFilter\" class=\"qf-lcap\" width=\"20px\" valign=\"top\" dojoAttachEvent='onmouseover:_onHover,onmouseout:_onUnHover'>\n</td>\n<td class=\"qf-mid\" width=\"170\" valign=\"middle\">\n<label title=\"${resources_.SEARCH_TEXT}\">\n<input dojoAttachPoint=\"searchField\" class=\"qf-textfield-label\" type=\"text\" valign=\"middle\" dojoAttachEvent='onfocus:_onFocus,onblur:_onBlur,onkeypress:_onKeyPress' />\n</label>\n</td>\n<td class=\"qf-rcap\" width=\"15\"/>\n</tr>\n</tbody>\n</table>\n</div>\n",

  constructor: function( parms ) 
  {
  	this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");
  	this.lastColumns = null;
  },
  
  postCreate: function()
  {
    if ( this.table !== null )
    {
      this.setTable( this.table );
    }        
  },  
   
  /********************************************************************
  * This method must be called to set the underlying table that the 
  * search bar will filter on.  As soon as this method is called
  * the table is queried for its "structure" (columns) and the dropdown
  * column filter dialog is populated
  *********************************************************************/
  setTable: function( table )
  {
    
  	// Save a reference to the table
  	this.table = table;
  	
  	this.clear(); //ensure that we start with a fresh slate
  	
	var columns = this.table.layout.cells;
	var columnsVisible = new Array();
		
	for (var i in columns) {
		if (i) {
			var column = columns[i];
			var isVisible = column.visible === undefined ? !column.hidden : column.visible;
			if (isVisible) 
				columnsVisible[i] = i;
		}
	}
	
  	var div  = document.createElement( 'DIV' );
  	var div2 = document.createElement( 'DIV' );
  	div2.className="qf-col-filter-title";	  
  
  	div2.appendChild( document.createTextNode( this.resources_.FILTER_ON ) );
  	div.appendChild( div2 );
	
	if (columnsVisible.length > 0) {
	
		div2 = document.createElement('DIV');
		div2.className = "qf-col-chkbox-label-row";
		
		var checkbox = new dijit.form.CheckBox({
			id: table.id + this._ALL_COLS_NAME,
			pId: table.id,
			name: table.id + this._ALL_COLS_NAME,
			checked: true
		});
		//  	                                          checked: this.columnsToFilterOn[ this._ALL_COLS_NAME ] } );
		
		this.childrenWidgets[checkbox.id] = checkbox;
		
		checkbox.onColsFilter = function(){
			this.attr("checked", false);
		};
		
		checkbox.onCheckedEvent = function(){
		
			if (this.checked) {
				dojo.publish(this.pId + "_filterOnAll", ["Filter on all rows"]);
			}
		};
		
		this.topics[this._ALL_COLS_NAME] = dojo.subscribe(table.id + "_filterByCol", checkbox, "onColsFilter");
		this.objectConnections[this._ALL_COLS_NAME] = dojo.connect(checkbox, "_setCheckedAttr", checkbox, "onCheckedEvent");
		
		var label = document.createElement('LABEL');
		label.className = "qf-col-chkbox-label";
		label["for"] = checkbox.id;
		label.title = this.resources_.ALL_COLUMNS;
		
		label.appendChild(document.createTextNode(this.resources_.ALL_COLUMNS));
		
		div2.appendChild(checkbox.domNode);
		div2.appendChild(label);
		
		div.appendChild(div2);
		
	}

	var columns = [];
	var i = 0;
	var j = 0;
	
	table.views.forEach( function( view, k )
	{
		if ( view.structure.cells )
		{
			for ( var i in view.structure.cells )
			{
				if (i) {
					for ( var j in view.structure.cells[i] )
					{
						if (j) {
						 	var v = view.structure.cells[i][j];				
		    	         	if (v.field !== undefined) {
                	         	columns.push( v );
	                 		}
	                 	}
					}			
				}
			}
		}
	});  	
  	  	
  	for ( i in columns )
  	{
  		if (i) {
		  	if ( columns[i].isSearchable === false || columns[i].hidden) {
		    	continue;
			}
  			div2 = document.createElement( 'DIV' );
  			div2.className="qf-col-chkbox-label-row";
  		
  			checkbox = new dijit.form.CheckBox( { id     : table.id + columns[i].name,
  											  pId    : table.id,
  											  columnID: columns[i].field,
  	                                          name   : table.id + columns[i].name,
  	                                          checked: this.columnsToFilterOn[ columns[i].name ] } );

			this.childrenWidgets[ checkbox.id ] = checkbox;
		
			checkbox.onAllColsFilter = function() {
				this.attr ("checked", false);
			};
		
			checkbox.onCheckedEvent = function () {
	  			if ( this.checked )
	  			{
			  		dojo.publish( this.pId + "_filterByCol", ["Filter on individual columns"] );		
	  			}
			};  	           
		
			this.topics[ columns[i].name ] = dojo.subscribe( table.id + "_filterOnAll", checkbox, "onAllColsFilter" );                               
  	    
			this.objectConnections[ columns[i].name ] = dojo.connect( checkbox, "_setCheckedAttr", checkbox, "onCheckedEvent" );  	                                          
  	                                          
			div2.appendChild( checkbox.domNode );  	                            

			label = document.createElement( 'LABEL' );
			label["for"] = checkbox.id;
			label.title = columns[i].name;
			label.className = "qf-col-chkbox-label";
		
			label.appendChild( document.createTextNode( columns[i].name ) );
		
			div2.appendChild( label );  	                                         		             
  		
  			div.appendChild( div2 );  		
  		}
  	}
  	  	
  	var button = new dijit.form.Button( { id: table.id + "close_btn",
                                        type: "submit", 
                                        onClick: dojo.hitch (this, "onFilterOK"),
  								       label: this.resources_.OK } );

	this.childrenWidgets[ button.id ] = button;	  								       
  								     
	div.appendChild( button.domNode );  								     
  	
  	var tooltipDialog = new dijit.TooltipDialog( { id: table.id + "gf_tooltipdialog" } );

	this.childrenWidgets[ tooltipDialog.id ] = tooltipDialog;	  								       
  	  	
  	tooltipDialog.containerNode.appendChild( div );
  	
  	/** OVERLOAD to allow our own styling to be added **/
//  	tooltipDialog.orient = function(/*Object*/ corner)
//  	{
		// summary: configure widget to be displayed in given position relative to the button
//		this.domNode.className="dijitTooltipDialog " +" dijitTooltipAB"+(corner.charAt(1)=='L'?"Left":"Right")+" dijitTooltip"+(corner.charAt(0)=='T' ? "Below" : "Above" ) + " qf-TooltipDialog";
//	};  	
  	
  	tooltipDialog.execute = function( args )
  	{  		
  	    this.columnsToFilterOn = [];
  	    
  		for ( var i in args )
  		{
  			if (i) {
				this.columnsToFilterOn[i] = args[i][0] ? true : false ;
			}
  		}  	
  	};
  	
	var btn = new ibm.psw.wcl.dijit.WDTableDropDownButton( { id: table.id + "_coltrigger", 
												dropDown: tooltipDialog,
												label: "",
												baseClass: "qf-col-trigger" } );
												
	this.tooltip_dropdownhelp = new dijit.Tooltip({label:this.resources_.SEARCH_DROP_DOWN_HELP, connectId:[btn.id]}, document.createElement("div"));
												
	
	this.childrenWidgets[ btn.id ] = btn;	  								       

	this.colFilter.appendChild( btn.domNode );
		
	btn.startup();
	
//	var downArrowSpan =  dojo.query("span.dijitArrowButtonChar", btn.domNode );	
	
//	dojo.query("span.dijitButtonText", btn.domNode ).orphan();
	
//	downArrowSpan[0].innerHTML = "";
//	dojo.removeClass( downArrowSpan[0], "dijitArrowButtonChar" );
//	dojo.removeClass( downArrowSpan[0], "dijitArrowButtonInner" );
//	downArrowSpan[0].style.padding="0px";
	
//	var image = dojo.doc.createElement( 'IMG' );	
//	image.src = this._qf_arrow_src;
//	image.border = 0;
//	image.style.padding="0px";
//	image.style.margin="0px";
//	image.alt = this.resources_.SEARCH_DROP_DOWN_HELP;
	
//	downArrowSpan[0].appendChild( image );	
  },
  
  onFilterOK: function () {
  	
	var columns = this.table.layout.cells;
	var columnsVisible = new Array();
		
	for (var i in columns) {
		if (i) {
			var column = columns[i];
			var isVisible = column.visible === undefined ? !column.hidden : column.visible;
			if (isVisible) 
				columnsVisible[i] = i;
		}
	}
  	if (columnsVisible.length > 0) {
		var columns = this.getSelectedColumns();
		if (this.columnsEqual(columns, this.lastColumns)) {
		
		}
		else {
		
			dojo.publish(this.id + "searchInvoked", [this, null]);
			this.lastColumns = columns;
		}
	}else{
		//console.debug("All the columns are hidden");
	}
	   
  },
  
  columnsEqual: function (columns1, columns2) {
  	if ((columns1 === null) && (columns2 === null)) {
  		return (true);
  	} else if ((columns1 === null) || (columns2 === null)) {
  		return (false);
  	} else if (columns1.length !== columns2.length) {
  		return (false);
  	} else {
		for (var x in columns1) {
			if (columns1[x] !== columns2[x]) {
				return (false);
			}
  		}
  		
  		return (true);
  	}
  },
  
  _onFocus: function()
  {
	this.domNode.className="quick-filter-focus";  
  },
  
  _onBlur: function()
  {
	this.domNode.className="quick-filter";
  },
  
  _onKeyPress: function(event)
  {
  	var columns = this.table.layout.cells;
	var columnsVisible = new Array();
		
	for (var i in columns) {
		if (i) {
			var column = columns[i];
			var isVisible = column.visible === undefined ? !column.hidden : column.visible;
			if (isVisible) 
				columnsVisible[i] = i;
		}
	}
  	if (columnsVisible.length > 0) {
		if (event.keyCode == 13) {
			event.cancelBubble = true;
			event.returnValue = false;
			dojo.publish("onEnter", [this, event]);
			dojo.publish(this.id + "searchInvoked", [this, event]);
		}
	}else{
		//console.debug("All the columns are hidden");
	}
  },
  
  _onHover: function()
  {
	this.colFilter.className="qf-lcap-over";
  },
  
  _onUnHover: function()
  {
	this.colFilter.className="qf-lcap";
  },
  
  _setFilterCol: function ()
  {  	
  },
  

  getSelectedColumns: function ()
  {
  	var result = [];
  	
  	if (this.childrenWidgets[this.table.id + this._ALL_COLS_NAME].checked) {
	  	for (var x in this.childrenWidgets) {
	  		if (x) {
	  			if (this.childrenWidgets[x].columnID !== undefined ) {
		  			result.push (this.childrenWidgets[x].columnID);
		  		}
  			}
  		}
  	} else {
	  	for (var y in this.childrenWidgets) {
	  		if (y) {
	  			if (this.childrenWidgets[y].checked) {
		  			if (this.childrenWidgets[y].columnID !== undefined ) {
		  				result.push (this.childrenWidgets[y].columnID);
		  			}
	  			}
	  		}
	  	}
  	}
  	
	return (result);
  },
  
  /*************************************************************
  * Clears the contents of the search drop down to be recreated
  *************************************************************/
  clear: function()
  {
  	/** Destroy all subscriptions **/
  	for ( var i in this.topics )
  	{
  		if (i) {
  			dojo.unsubscribe( this.topics[i] );
  		}
  	}
  	
  	delete this.topics;
  	this.topics = [];

  	/** Destroy all event connections **/
  	for ( i in this.objectConnections )
  	{
  		if (i) {
	  		dojo.disconnect( this.objectConnections[i] );
	  	}
  	}  	

  	delete this.objectConnections;
  	this.objectConnections = [];
  	
  	/** Destroy all children widgets **/
  	for ( i in this.childrenWidgets )
  	{
  		if (i) {
  			this.childrenWidgets[i].destroy();
  		}
  	}  
  	
  	if ( this.tooltip_dropdownhelp )
  	{
  		this.tooltip_dropdownhelp.destroy();
  	}

  	delete this.childrenWidgets;
  	this.childrenWidgets = [];
  	
  	delete this.columnsToFilterOn;
  	this.columnsToFilterOn = [];
  },
  
  /*************************************************************
  * Destroy this widget -- remove all subscriptions and event
  * connections
  *************************************************************/
  destroy: function()
  {  	
  	this.clear();
  	
  	/** call super **/
  	this.inherited( "destroy", arguments );
  }
  
});

}
