/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["ibm.psw.wcl.dijit.WTableSortDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.psw.wcl.dijit.WTableSortDialog"] = true;
/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: %W%
 * Version:       %I%
 * Last Modified: %G%
 *******************************************************************************/

dojo.provide("ibm.psw.wcl.dijit.WDTableSortDialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Form");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit._Container");
dojo.require("ibm.psw.wcl.dijit.WDButton");
dojo.require("ibm.psw.wcl.dijit.WDSortOptions");

// NLS
dojo.requireLocalization("ibm.psw.wcl.dijit", "resources", null, "ROOT,cs,de,en,en-us,es,fr,hu,it,ja,ko,pl,pt-br,ru,zh-cn,zh-tw");


// define the widget class
dojo.declare (
	"ibm.psw.wcl.dijit.WDTableSortDialog", 
    [ dijit._Widget, dijit._Templated ],
{
	templatePath: dojo.moduleUrl("ibm.psw.wcl.dijit", "templates/WDTableSortDialog.html"),
	widgetsInTemplate: true,
	table: null,

	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
	    this.resources_ = dojo.i18n.getLocalization("ibm.psw.wcl.dijit", "resources");
		this.sortOptions = [];
	},
	postCreate: function() { 
		this.inherited ("postCreate", arguments);
		for (var i = 0; i < this.table.sortColumnLimit; i++) {
			this.createSortLayout(i);
		}
		
	},
	
	createSortLayout: function(index){
			//Creating Sort Label
			var tr1 = document.createElement('TR');
		    var td1 = document.createElement('TD');
			tr1.appendChild(td1);
			var label = document.createElement( 'LABEL' );	
			var sortTitle = "";
			switch (index) {
				case 0:sortTitle = this.resources_.SORT0;break;
				case 1:sortTitle = this.resources_.SORT1;break;
				case 2:sortTitle = this.resources_.SORT2;break;
				case 3:sortTitle = this.resources_.SORT3;break;
				case 4:sortTitle = this.resources_.SORT4;break;
				default:sortTitle = this.resources_.SORT0;
			}

	        label.title = sortTitle;	
	        label.appendChild( document.createTextNode( sortTitle ) );
			td1.appendChild(label);
			this.sortLayout.appendChild(tr1);
			
			//Creating div containing sort options
			var tr2 = document.createElement('TR');
		    var td2 = document.createElement('TD');
			tr2.appendChild(td2);
			var sortDiv = document.createElement('DIV');
			sortDiv.id = this.id + "SortDiv" + index;
			td2.appendChild(sortDiv);
			this.sortLayout.appendChild(tr2);
			
			this.sortOptions[index]=new ibm.psw.wcl.dijit.WDSortOptions (
			{
				table: this.table
			}, dojo.byId(this.id + "SortDiv" + index));
			
		    this.sortOptions[index].startup();
			
	},
	
	onOK: function () {
				
		this.saveSortOptions();
		this.hide();
	},
	onCancel: function () {
		
		this.hide();
		// TODO: revert changes
	},
	show: function () {
		this.sortDialog.show();
		dijit.byId (this.id + "tabs").resize();
	},
	hide: function () {
		this.sortDialog.hide();
		setTimeout (dojo.hitch (this, this.kill), 200);
	},
	kill: function () {
		var id = this.id;
		this.destroyRecursive();
		dijit.registry.remove (id);
	},
	saveSortOptions: function () {
		var sortColsArr = [];
		
		for (var i = 0; i < this.table.sortColumnLimit; i++) {
		    var sortJSON = {};
			
			/*if (this.sortOptions[i].getSortColumnId() === '-1') {
				continue;
			}*/
			sortJSON.sortColId = this.sortOptions[i].getSortColumnId();
			sortJSON.sortType = this.sortOptions[i].getSortType();
			sortColsArr.push(sortJSON);
		}
		
		var jsonSortCols = {sortColumns: sortColsArr};
	    this.table.multiColSort(jsonSortCols);
		
		
	}
});



}
