/****************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* 5724-Q87 
*
* (C) Copyright IBM Corp. 2008
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
********************************************************** {COPYRIGHT-END} **/

dojo.provide("ibm.psw.wcl.wdojocomp.WTableActionList");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");
dojo.require("dijit.MenuItem");
dojo.require("dijit.PopupMenuItem");
dojo.require("dijit.MenuBar");
dojo.require("dijit.MenuBarItem");
dojo.require("dijit.PopupMenuBarItem");
dojo.require("dijit.MenuSeparator"); 
dojo.require("dijit.Toolbar");
dojo.require("dijit.ToolbarSeparator");
dojo.require("dijit.form.DropDownButton");

/******************************************************************************
* Nested DropDown Menu.
******************************************************************************/
dojo.declare("ibm.psw.wcl.wdojocomp.WTableActionList", 
		[dijit._Widget, dijit._Templated],{
		menuItems : [],
		subMenus : [],
		ajaxEnabled: true,
		prefetchingEnabled: true,
		makeUniqueTable : "",
		formName : "",
		actionValue : "",
		anchorName : "",
		wclhidden : "",
		wclanchor : "",
		dropDownList: "",
		userActions: "",
		exportDataServletPath : "",
		templateString: 
			"<table  width=\"100%\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" style=\"font-size:100%;\" >"+
				"<tr>"+
					"<td align=\"right\" width=\"50%\">"+
						"<div dojoAttachPoint=\"menuContainer\" style=\"\">"+
						"</div>"+
					"</td>"+
					"<td align=\"left\" width=\"10%\">"+
						"<div dojoAttachPoint=\"attachButton\" class=\"goButton\" >"+
						"</div>"+
					"</td>"+
					"<td  width=\"40%\">&nbsp;"+
					"</td>"+
				"</tr>"+
			"</table>",
		comboButton:null,
		rootMenu:null,
		button:null,
		createButton: false,
		goButton: null,
		itemClicked: null,
		messageItem: null,
		ajaxOption: null,
		imageEnabled: false,
		SELECT_ACTION: "",
		SELECT_ACTION_TITLE: "",
		SELECT_ACTION_COMBO_BUTTON: "",
		GO_BUTTON: "",
		GO_BUTTON_TITLE: "",
		isPortlet: false,
	  
		postCreate: function()
		{   
			this.inherited( arguments );
			
			//dojo 1.4.3 - templatePath is deprecated
			dijit.form.DropDownButton.prototype.templateString = dojo.cache("ibm.psw.wcl.dijit", "templates/DropDownButton.html");
			dijit.form.Button.prototype.templateString = dojo.cache("ibm.psw.wcl.dijit", "templates/Button.html");
			
			//dijit.form.DropDownButton.prototype.templatePath = dojo.moduleUrl("ibm.psw.wcl.dijit", "templates/DropDownButton.html");
			//dijit.form.Button.prototype.templatePath = dojo.moduleUrl("ibm.psw.wcl.dijit", "templates/Button.html");
			
						
			this.rootMenu = new dijit.Menu({
				style: "display: none;"
			});
			//[#137718]-No hint for Select Action Menu, for Catalan lang arrow is not displayed
			var selectActionTitle = this.SELECT_ACTION_TITLE;
			while(selectActionTitle.match("&#39;"))
			   selectActionTitle = selectActionTitle.replace("&#39;","'");
			
			this.button =  new dijit.form.DropDownButton({
				optionsTitle : this.SELECT_ACTION_COMBO_BUTTON,
				label: this.SELECT_ACTION,
				title: selectActionTitle,
				dropDown: this.rootMenu
			});
			
						
			//dojo.connect(this.button, 'onClick', dojo.hitch(this.button, '_onArrowClick'));
			//dojo.connect(this.button, 'onKeypress', dojo.hitch(this.button, '_onKey'));
			
			//dojo 1.4.3 _onMouse change
			dojo.connect(this.button, 'onClick', dojo.hitch(this.button, '_onMouse'));
			dojo.connect(this.button, 'onKeypress', dojo.hitch(this.button, '_onMouse'));
			
			//Fix For French Locale for WCL 5.8
			var goButtonTitle = this.GO_BUTTON_TITLE;
			while(goButtonTitle.match("&#39;"))
				goButtonTitle = goButtonTitle.replace("&#39;","'");
			if(this.createButton === true){
				this.goButton = new dijit.form.Button({
					alt: this.GO_BUTTON, 
					label: this.GO_BUTTON,
					title: goButtonTitle
				}, this.attachButton);
				dojo.connect(this.goButton, 'onClick', dojo.hitch(this, this.onButtonClick));
			}
			this.menuContainer.appendChild(this.button.domNode);
			this.populateMenu(this.rootMenu);
			formatDojoMenu(this.rootMenu);
			
		},
		
		populateMenu: function(menu)
		{		 
			var  model = this.dropDownList;
			if ( model !== undefined && model !== null )
			{
				this.addItemsToMenu( menu, model );
				menu.startup();
			}               
		},
				
		addItemsToMenu:function( parent, items )
		{
			var params;
			var subMenuIndex;
			var menuItemIndex;		  
			for ( var i in items )
			{
			    //JS Error on IE with Ajax On Fix - for loop returns "indexOf" as index i
			    if(i == "indexOf"){
				   continue;
				}
				if ( items[i].submenu_items ){
					subMenuIndex = this.subMenus.length;
					this.subMenus[ subMenuIndex ] = new dijit.Menu();
					params = 
					{
						popup: this.subMenus[ subMenuIndex ]
					};
					dojo.mixin( params, items[i] );
					parent.addChild( new dijit.PopupMenuItem( params ) );
					parent.startup();
					this.addItemsToMenu( this.subMenus[ subMenuIndex ], items[i].submenu_items );          
				} else {
					if (items[i].id && items[i].id.substring(0,9) === "Separator"){
						items[i].actionID = "_separator_";
					} else if (items[i].id && !items[i].actionID){
						items[i].actionID = items[i].id;
					}
					if ( items[i].actionID === "_separator_" ){
						menuItemIndex = this.menuItems.length;
						this.menuItems[ menuItemIndex ]  = new dijit.MenuSeparator();
						parent.addChild( this.menuItems[ menuItemIndex ] );
					} else {
						params = {
							adapter: this,
							onClick: function() { 
								this.adapter.onMenuItemClick( this ); 
							}
						};
						dojo.mixin( params, items[i] );
						menuItemIndex = this.menuItems.length;
						this.menuItems[ menuItemIndex ] = new dijit.MenuItem( params );
						parent.addChild( this.menuItems[ menuItemIndex ] );
						parent.startup();
					}
				}         
			}
		},
		
		onMenuItemClick: function( menuItem ){ 
			this.itemClicked = menuItem.name;
			var messageItem = dojox.json.query("=$.[?id='"+ menuItem.id +"']", this.dropDownList);
			this.messageItem = dojox.json.query("[0].message", messageItem);
			this.ajaxOption = dojox.json.query("[0].use_ajax", messageItem) && this.ajaxEnabled;
			this.button.setAttribute("label", menuItem.label);
			if(this.createButton == false){
				if( this.itemClicked === "select(all)" ){
					if(this.prefetchingEnabled && this.ajaxEnabled){
						RegisteredTables.select(this.makeUniqueTable, 'all');
					} else if (this.prefetchingEnabled == "false" && (this.ajaxEnabled == "true")){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					}else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "select(none)" ){
					if(this.prefetchingEnabled && this.ajaxEnabled){
						RegisteredTables.select(this.makeUniqueTable, 'none');
					}else if (this.prefetchingEnabled == "false" && (this.ajaxEnabled == "true")){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === this.exportDataServletPath ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, this.exportDataServletPath, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, this.exportDataServletPath,null);
					}
				} else if ( this.itemClicked === "changeSelected()" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "toggleFilterRow" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "clearFilters" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "editSort" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "clearSorts" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "toggleDataRows" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "toggleActionbar" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "configureColumns" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "restoreDefault" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				}
				/*User Defined Actions*/
				var list = dojox.json.query("=$.[?parentAction=null]", this.userActions);
				for(var i=0; i < list.length; i++){
					if ( this.itemClicked === dojox.json.query("[" + i + "].name", this.userActions) ){
						if (this.ajaxEnabled) {
							dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, this.messageItem, this.ajaxOption);
						}
						else {
							dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, this.messageItem);
						}
					}
				}
				var subList = dojox.json.query("=$.[?parentAction!=null]", this.userActions);
				for (var i = 0; i < subList.length; i++) {
					if (this.itemClicked === dojox.json.query("[" + i + "].name", subList)) {
						if (this.ajaxEnabled) {
							dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, this.messageItem, this.ajaxOption);
						}
						else {
							dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, this.messageItem);
						}
					}
				}
				this.reset();
			}
		},
		onButtonClick: function(){
			    if( this.itemClicked === "select(all)" ){
					if(this.prefetchingEnabled && this.ajaxEnabled){
						RegisteredTables.select(this.makeUniqueTable, 'all');
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "select(none)" ){
					if(this.prefetchingEnabled && this.ajaxEnabled){
						RegisteredTables.select(this.makeUniqueTable, 'none');
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === this.exportDataServletPath ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, this.exportDataServletPath, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, this.exportDataServletPath,null);
					}
				} else if ( this.itemClicked === "changeSelected()" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "toggleFilterRow" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "clearFilters" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "editSort" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "clearSorts" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "toggleDataRows" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "toggleActionbar" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "configureColumns" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				} else if ( this.itemClicked === "restoreDefault" ){
					if(this.ajaxEnabled){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null, this.ajaxOption);
					} else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
					}
				}
				/*User Defined Actions*/
				var list = dojox.json.query("=$.[?parentAction=null]", this.userActions);
				for (var i = 0; i < list.length; i++) {
					if (this.itemClicked === dojox.json.query("[" + i + "].name", this.userActions)) {
						if (this.ajaxEnabled) {
							dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, this.messageItem, this.ajaxOption);
						}
						else {
							dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, this.messageItem);
						}
					}
				}
				var subList = dojox.json.query("=$.[?parentAction!=null]", this.userActions);
				for (var i = 0; i < subList.length; i++) {
					if (this.itemClicked === dojox.json.query("[" + i + "].name", subList)) {
						if (this.ajaxEnabled) {
							dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, this.messageItem, this.ajaxOption);
						}
						else {
							dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null, null);
						}
					}
				}
				
			    this.reset();
		},
		reset: function(){
			this.itemClicked = null;
			this.messageItem = null;
			this.button.setAttribute("label", this.SELECT_ACTION);
		},
		destroy: function(){
			// destroy all children
			var widgetArr = this.rootMenu.getChildren();
			dojo.forEach(widgetArr, function(child){
				child.destroyRecursive();
			});
			this.inherited("destroy", arguments);
		}	
	}
); 


