/****************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* 5724-Q87 
*
* (C) Copyright IBM Corp. 2008
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
********************************************************** {COPYRIGHT-END} **/

dojo.provide("ibm.psw.wcl.wdojocomp.WTableRowContextMenu");

dojo.require("dijit._Widget");
dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");
dojo.require("dijit.MenuItem");
dojo.require("dijit.PopupMenuItem");
dojo.require("dijit.MenuBar");
dojo.require("dijit.MenuBarItem");
dojo.require("dijit.PopupMenuBarItem");
dojo.require("dijit.MenuSeparator"); 
dojo.require("dijit.Toolbar");
dojo.require("dijit.ToolbarSeparator");

/******************************************************************************
* Nested DropDown Menu.
******************************************************************************/
dojo.declare("ibm.psw.wcl.wdojocomp.WTableRowContextMenu", [dijit._Widget],
		{
		menuItems : [],
		subMenus : [],
		initialTargetIds :[],
		dropDownList: [],
		userActions: [],
		targetDomNodes:[],
		ajaxEnabled: true,
		prefetchingEnabled:false,
		clientSideRowSelection :true,
		SingleSelectMode :true,//  true : SingleSelect, false : MultiSelect
		makeUniqueTable : "",
		tableDivId : "",
		formName : "",
		actionValue : "",
		anchorName : "",
		wclhidden : "",
		wclanchor : "",
		exportDataServletPath : "",
		rootMenu:null,
		itemClicked: null,
		messageItem: null,
		createButton:false,	
		iconEnabled:false,
		_context:null,
	  
		postCreate: function()
		{   
		    //console.info("postCreate "+this.tableDivId);
			this.inherited( arguments );
			this.rootMenu = new dijit.Menu({
				style: "display: none;"
				
			});
			var tableDivContextNode = dojo.byId(this.tableDivId);
			dojo.connect( tableDivContextNode, "oncontextmenu", dojo.hitch(this, this.contextMenuOpen ));
			this.populateMenu(this.rootMenu);
			formatDojoMenu(this.rootMenu);
		},
	    ClientSideRowSelection :function(clickedRow){
			//console.info("ClientSideRowSelection ");
			var checkBox=null;
			//var checkBoxNode = dojo.query("tr#"+clickedRow.id+" input[type=checkbox]"); 
			//var radioNode = dojo.query("tr#"+clickedRow.id+" input[type=radio]");
			var checkBoxNode = dojo.query("tr#"+clickedRow.id+" input[onclick$=\"doTgl(this);\"]"); 
			var radioNode = dojo.query("tr#"+clickedRow.id+" input[onclick$=\"doRTgl(this);\"]");
			
			if(checkBoxNode!=null && checkBoxNode[0]!=null) {
			 checkBoxNode[0].checked=true;
            }
			else {
			    var selected = getSelectedRadio(radioNode[0]); // wcl.js
				 if (selected != null) {
					   selected.checked=false;	//tbls4
					  var cells1 = dojo.query("td[class*=\"tbls\"]");
					  //console.info(" cells1");
						//console.dir(cells1);					  
					  if (cells1 != null)
					  {						
						 for (var i=0; i<cells1.length; i++)
						 {
							cells1[i].className = "tbl2";
						 }
					  }
				 }
				radioNode[0].checked=true;	
			}   
						
		  	 var cells = null;
			 cells = clickedRow.childNodes;
			  
			  if (cells != null)
			  {
				 var suffix = cells[0].className.substring(cells[0].className.indexOf("s") > -1 ? 4 : 3);
				 var style = "tbls"  + suffix;
				 for (var i=0; i<cells.length; i++)
				 {
					cells[i].className = style;
				 }
			  }
		   
		},
		isThisRowSelected : function(clickedRow){

        var firstTdNode = clickedRow.childNodes[0];
		 if(firstTdNode.className.indexOf("s")> -1)  // td contains classname tbls4 or tbls2
          return true;
		  else
		   return false;
		}, 		
	    contextMenuOpen: function ( event )
	   {
	     
		  this.rootMenu._contextMenuWithMouse = true;
		  //console.info("this.clientSideRowSelection : "+this.clientSideRowSelection + "  this.SingleSelectMode : "+this.SingleSelectMode);
		  var clickedRow =null;
		  clickedRow =this.getContextRowData(event);
		  				  
		  if(clickedRow!=null) {// clicked on one of table rows
		    var checkBox=null;
			var isRowSelected = this.isThisRowSelected(clickedRow);  // wcl implementation isInSelectedRow is so pathetic and gives unpredictable results
			//console.info("isRowSelected : "+isRowSelected);				
			if(isRowSelected==false) {
			    var rowId = clickedRow.id;
				var rowNum = rowId.split('_');
				var selectRowVar="select(" + rowNum[1] + ")";
				//console.info("Row Num "+selectRowVar);
				if (this.clientSideRowSelection == false) { // Do ClientSide Selection
					this.ClientSideRowSelection(clickedRow);
					
				}
				else { // Do the ServerSide Selection
					if (this.prefetchingEnabled && this.ajaxEnabled) {
						RegisteredTables.select(this.makeUniqueTable, rowNum[1]);
					}else if (this.prefetchingEnabled == "false" && (this.ajaxEnabled == "true")){
						dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", selectRowVar, null, null, this.ajaxOption);
					}
					else {
						dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", selectRowVar, null, null);
					}
				}
			}
            //console.info("Before rootMenu._openMyself");			
			//To Do Delayed Opening of Contextmenu ex after row is selected completely
		    this.rootMenu._openMyself( event );
		   
		  }
	   },
	  
	   getContextRowData : function(event) {
	     var rowDomNodes = dojo.query("tr [id^='TR_']"); //tr#main image'
		 
		 var clickedRow =null;
		 var x =event.clientX;
		 var y=event.clientY;
		for(var i=0;i< rowDomNodes.length;i++) {
		       var node =  rowDomNodes[i];
			   var clientRect =dojo.coords(node);
			     var clientLeft=clientRect.x;
				var clientTop=clientRect.y;
				var clientRight=clientLeft+clientRect.w;
				var clientBottom =clientTop+clientRect.h;
		    	if(x > clientLeft && x <clientRight && y>clientTop&& y<clientBottom) {
				   clickedRow=node;
				   //console.info("Target Row id "+node.id)
				}
						  
			}
	     return clickedRow;
	   },
		populateMenu: function(menu)
		{		 
			var  model = this.dropDownList;
			if ( model !== undefined && model !== null )
			{
			    //console.info("JSON Coming from Server");
				//console.log(model);
				this.addItemsToMenu( menu, model );
				menu.startup();
			}               
		},
		addItemsToMenu:function( parent, items )
		{
			var params;
			var subMenuIndex;
			var menuItemIndex;
            if(parent!=null)
              parent.startup();  			
			for ( var i in items )
			{
			    //JS Error on IE with Ajax On Fix - for loop returns "indexOf" as index i
			    if(i == "indexOf"){
				   continue;
				}
				if ( items[i].submenu_items ){
					subMenuIndex = this.subMenus.length;
					this.subMenus[ subMenuIndex ] = new dijit.Menu();
					params = 
					{
						popup: this.subMenus[ subMenuIndex ]
					};
					dojo.mixin( params, items[i] );
					parent.addChild( new dijit.PopupMenuItem( params ) );  
					this.addItemsToMenu( this.subMenus[ subMenuIndex ], items[i].submenu_items );           
				} else {
					if (items[i].id && items[i].id.substring(0,9) === "Separator"){
						items[i].actionID = "_separator_";
					} else if (items[i].id && !items[i].actionID){
						items[i].actionID = items[i].id;
					}
					if ( items[i].actionID === "_separator_" ){
						menuItemIndex = this.menuItems.length;
						this.menuItems[ menuItemIndex ]  = new dijit.MenuSeparator();
						parent.addChild( this.menuItems[ menuItemIndex ] );
					} else {
						params = {
							adapter: this,
							onClick: function() { 
								this.adapter.onMenuItemClick( this ); 
							}
						};
						dojo.mixin( params, items[i] );
						menuItemIndex = this.menuItems.length;
						this.menuItems[ menuItemIndex ] = new dijit.MenuItem( params );
						parent.addChild( this.menuItems[ menuItemIndex ] );  
					}
				}         
			}
		},
		
		onMenuItemClick: function( menuItem ){ 
		    //console.info("onMenuItemClick "+menuItem.name);
			this.itemClicked = menuItem.name;
			var messageItem = dojox.json.query("=$.[?name='"+ menuItem.name +"']", this.dropDownList);
			//console.log("itemclick " + this.itemClicked);
			if(this.ajaxEnabled==false)
				dojoUserActions(this.formName, this.actionValue, this.anchorName, this.wclhidden, "wa", this.itemClicked, null,null);
		    else
			dojoUserActionsAjax(this.formName, this.actionValue, this.anchorName, "wh", "wa", this.itemClicked, null,null, this.ajaxEnabled);				
				this.reset();
			
		},
		reset: function(){
			//console.log("in reset");
			this.itemClicked = null;
			this.messageItem = null;
			
		},
		destroy: function(){
			// destroy all children
			 this.targetDomNodes=[];
			//console.debug("destroy WclContextMenu");
			var widgetArr = this.rootMenu.getChildren();
			//console.debug("child widgets in menu:" + widgetArr);
			dojo.forEach(widgetArr, function(child){
				child.destroyRecursive();
			});
			this.inherited("destroy", arguments);
		}	
	}
); 


