dojo.provide("ibm.psw.wcl.wdojocomp.WTableRowSpinner");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.NumberSpinner");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.TextBox");
dojo.require("dojo.parser");
dojo.require("ibm.psw.wcl.dijit.WDImages");

dojo.declare("ibm.psw.wcl.wdojocomp.WTableRowSpinner",
            [ dijit._Widget, dijit._Templated ],{
				_upArrowIcon: "",
				_downArrowIcon: "",
				opacityUpArrow: "1",
				opacityDownArrow: "1",
				pageMax: 0,
				pageMin: 0,
				currentPage: 0,
				rowMax: 0,
				rowMin: 0,
				rowsPerPage: 0,
				image_sep: "",
				tableId: "",
				isAjaxEnabled: "",
				formName: "",
				actionName: "",
				actionValue: "",
				wclhidden: "",
			    rppTextfieldTitle: "",
				rppUpArrowTitle: "",
				rppDownArrowTitle: "",
				isPrefetchingEnabled: "true",
				rowspinner: null,
				textDisabled: "false",
				filterUpArrow: "alpha(opacity=80)",
				filterDownArrow: "alpha(opacity=80)",
				
				templateString:
						"<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"100%\">"+
							"<tr>"+
								
								"<td width=\"13%\" align=\"right\" valign=\"middle\"  style=\"padding-top:1px;\">"+
									"<div dojoAttachPoint=\"rowContainer\""+
									"</div>"+
								"</td>"+
								"<td width=\"6%\">"+
									"<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\">"+
										"<tr>"+
											"<td>"+
												"<img id=\"${id}${rppUpArrowTitle}\" src=\"${_upArrowIcon}\" alt=\"${rppUpArrowTitle}\" title=\"${rppUpArrowTitle}\" height=\"12\" width=\"12\" style=\"opacity:${opacityUpArrow};filter:${filterUpArrow};\"  dojoAttachPoint=\"imageRowUpArrow\" dojoAttachEvent=\"onclick:_onRowUpArrowClick,onmouseover:_onMouseOverRowUpArrow,onmouseout:_onMouseOutRowUpArrow\"/>"+
											"</td>"+
										"</tr>"+
										"<tr>"+
											"<td>"+
												"<img id=\"${id}${rppDownArrowTitle}\" src=\"${_downArrowIcon}\" alt=\"${rppDownArrowTitle}\" title=\"${rppDownArrowTitle}\" height=\"12\" width=\"12\" style=\"opacity:${opacityDownArrow};filter:${filterDownArrow};\" dojoAttachPoint=\"imageRowDownArrow\" dojoAttachEvent=\"onclick:_onRowDownArrowClick,onmouseover:_onMouseOverRowDownArrow,onmouseout:_onMouseOutRowDownArrow\"/>"+
											"</td>"+
										"</tr>"+
									"</table>"+
								"</td>"+
							"</tr>"+
						"</table>",
				
				constructor: function(){
					//NLS
					this._upArrowIcon = ibm.psw.wcl.dijit.WDImages.get()["IMAGE_UPARROW"];
					this._downArrowIcon = ibm.psw.wcl.dijit.WDImages.get()["IMAGE_DOWNARROW"];
					this.connections = [];					
					//this.isAjaxEnabled = "true";		
				},
				
				postCreate: function(){
					this.inherited( arguments );
					
					//disable the textbox also for empty table and table with one row
					var teDisabled = false;
					if(this.textDisabled == "true")
					     teDisabled = true;
					this.rowspinner = new dijit.form.TextBox({
								 style: "font-size:100%; vertical-align:middle; border-top:1px solid black; border-left:1px solid black;height:100%;width:52px; text-align: right; padding-top:1px;padding-bottom:1px;",
								 value: this.rowsPerPage,
								 disabled: teDisabled,
								 title: this.rppTextfieldTitle+": "+this.rowsPerPage,
				   				  intermediateChanges: "true"
								  },this.rowContainer );
								  
					//dojo.connect(this.rowspinner, 'onkeypress', this._updateRowSpinner);
					dojo.connect(this.rowspinner, "onKeyPress",this, "updateRowSpinner");	

				},
					
				_onRowUpArrowClick: function(e){
					if(this.imageRowUpArrow.style.opacity == "0.2"){
					//do not do any processing if arrow is disabled
						dojo.stopEvent(e);
						return;
					}
					window.document.body.style.cursor = "wait";	
					if(this.rowsPerPage < this.rowMax){
						this.rowspinner.attr("value",parseInt(this.rowsPerPage) + 1) ;
						this.rowsPerPage = parseInt(this.rowsPerPage) + 1;
						if(this.rowsPerPage == 0){
							this.pageMax = 1;
						} else {
							this.pageMax = Math.ceil(this.rowMax/this.rowsPerPage);
						}
						this.rowContainer.setAttribute("title", this.rppTextfieldTitle + ": " + this.rowsPerPage);
					} else {
						if(this.rowspinner.value > this.rowMax){
							this.rowsPerPage = this.rowMax;
							this.rowspinner.attr("value",this.rowMax) ;
						}
					} 
					if(this.rowspinner.attr("value") < this.rowMin){
						this.rowsPerPage = this.rowMin;
						this.rowspinner.attr("value",this.rowMin) ;
					}
					if(this.rowsPerPage == this.rowMax){
						this.imageRowUpArrow.style.opacity = 0.2;
						this.imageRowUpArrow.style.filter = "alpha(opacity=20)";
					}else{
						this.imageRowUpArrow.style.opacity = 1;
						this.imageRowUpArrow.style.filter = "alpha(opacity=80)";
					}
					if(this.rowsPerPage == this.rowMin){
						this.imageRowDownArrow.style.opacity = 0.2;
						this.imageRowDownArrow.style.filter = "alpha(opacity=20)";
					}else{
						this.imageRowDownArrow.style.opacity = 1;
						this.imageRowDownArrow.style.filter = "alpha(opacity=80)";
					}
					
					if(this.isPrefetchingEnabled == "true" && (this.isAjaxEnabled == "true")){						
						RegisteredTables.changeRowsPerPage(this.tableId,this.rowsPerPage );
						if(window.document.body.style.cursor == "wait"){
		          			window.document.body.style.cursor = "default";
		          		}
					}else if (this.isPrefetchingEnabled == "false" && (this.isAjaxEnabled == "true")){
						this.actionValue = "changeRowsPerPage("+this.rowsPerPage+")";
						doTblAjax(this.formName,this.actionName,this.actionValue,null,this.actionName,this.wclhidden,null );
						if(window.document.body.style.cursor == "wait"){
		          			window.document.body.style.cursor = "default";
		          		}
					}else {						
						this.actionValue = "changeRowsPerPage("+this.rowsPerPage+")";
						doTbl(this.formName,this.actionName,this.actionValue,null,this.actionName,this.wclhidden,null );
					}
					
					
					
				},
				
				_onRowDownArrowClick: function(e){
					if(this.imageRowDownArrow.style.opacity == "0.2"){
					//do not do any processing if arrow is disabled
						dojo.stopEvent(e);
						return;
					}
					window.document.body.style.cursor = "wait";	
					if(this.rowsPerPage > this.rowMin){
						this.rowspinner.attr("value",parseInt(this.rowsPerPage) - 1) ;
						this.rowsPerPage = parseInt(this.rowsPerPage) - 1;
						if(this.rowsPerPage == 0){
							this.pageMax = 1;
						} else {
							this.pageMax = Math.ceil(this.rowMax/this.rowsPerPage);
						}
						this.rowContainer.setAttribute("title", this.rppTextfieldTitle + ": " + this.rowsPerPage);
					} else {
						if(this.rowspinner.attr("value") < this.rowMin){
							this.rowsPerPage = this.rowMin;
							this.rowspinner.attr("value",this.rowMin) ;
						}
					}
					if (this.rowContainer.value > this.rowMax){
						this.rowsPerPage = this.rowMax;
						this.rowspinner.attr("value",this.rowMax) ;
					}
					if(this.rowsPerPage == this.rowMax){
						this.imageRowUpArrow.style.opacity = 0.2;
						this.imageRowUpArrow.style.filter = "alpha(opacity=20)";
					}else{
						this.imageRowUpArrow.style.opacity = 1;
						this.imageRowUpArrow.style.filter = "alpha(opacity=80)";
					}
					if(this.rowsPerPage == this.rowMin){
						this.imageRowDownArrow.style.opacity = 0.2;
						this.imageRowDownArrow.style.filter = "alpha(opacity=20)";
					}else{
						this.imageRowDownArrow.style.opacity = 1;
						this.imageRowDownArrow.style.filter = "alpha(opacity=80)";
					}
					
					//console.debug("this.isPrefetchingEnabled: "+ this.isPrefetchingEnabled);
					//console.debug("this.isAjaxEnabled "+ this.isAjaxEnabled);		
					if(this.isPrefetchingEnabled == "true" && (this.isAjaxEnabled == "true")){	
						//console.debug("prefetching is enabled, ajax is enabled...");					
						RegisteredTables.changeRowsPerPage(this.tableId,this.rowsPerPage );
						if(window.document.body.style.cursor == "wait"){
		          			window.document.body.style.cursor = "default";
		          		}
					}else if (this.isPrefetchingEnabled == "false" && (this.isAjaxEnabled == "true")){
						this.actionValue = "changeRowsPerPage("+this.rowsPerPage+")";
						//console.debug("prefetching is disabled, ajax is enabled...");
						doTblAjax(this.formName,this.actionName,this.actionValue,null,this.actionName,this.wclhidden,null );
						if(window.document.body.style.cursor == "wait"){
		          			window.document.body.style.cursor = "default";
		          		}
					}else {						
						this.actionValue = "changeRowsPerPage("+this.rowsPerPage+")";
						//console.debug("prefetching is disabled, ajax is disabled...");
						doTbl(this.formName,this.actionName,this.actionValue,null,this.actionName,this.wclhidden,null );
					}	
					
				},
				
							
				_onMouseOverRowUpArrow: function(){
					dojo.removeClass( this.imageRowUpArrow, "out" );
					dojo.addClass( this.imageRowUpArrow, "over"  );
				},
				
				_onMouseOutRowUpArrow: function(){
					dojo.removeClass( this.imageRowUpArrow, "over" );
					dojo.addClass( this.imageRowUpArrow, "out"  );
				},
				
				_onMouseOverRowDownArrow: function(){
					dojo.removeClass( this.imageRowDownArrow, "out" );
					dojo.addClass( this.imageRowDownArrow, "over"  );
				},
				
				_onMouseOutRowDownArrow: function(){
					dojo.removeClass( this.imageRowDownArrow, "over" );
					dojo.addClass( this.imageRowDownArrow, "out"  );
				},

				
				updateRowSpinner: function(e){
					if(window.event){
						var keyNum = e.keyCode;
					} else if(e.which){
						var keyNum = e.which;
					}
					if(keyNum == "13"){
						window.document.body.style.cursor = "wait";	
						if(this.rowspinner.attr("value") >= this.rowMin && this.rowspinner.attr("value") <= this.rowMax){
							this.rowsPerPage = parseInt(this.rowspinner.attr("value"));
							if(this.rowsPerPage == 0){
								this.pageMax = 1;
							} else {
								this.pageMax = Math.ceil(this.rowMax/this.rowsPerPage);
							}
							this.rowContainer.setAttribute("title", this.rppTextfieldTitle + ": " + this.rowsPerPage);
						} else {
							this.rowspinner.attr("value", this.rowsPerPage);
						}
						if(this.rowsPerPage == this.rowMax){
							this.imageRowUpArrow.style.opacity = 0.2;
							this.imageRowUpArrow.style.filter = "alpha(opacity=20)";
						}else{
							this.imageRowUpArrow.style.opacity = 1;
							this.imageRowUpArrow.style.filter = "alpha(opacity=80)";
						}
						if(this.rowsPerPage == this.rowMin){
							this.imageRowDownArrow.style.opacity = 0.2;
							this.imageRowDownArrow.style.filter = "alpha(opacity=20)";
						}else{
							this.imageRowDownArrow.style.opacity = 1;
							this.imageRowDownArrow.style.filter = "alpha(opacity=80)";
						}
							if(this.isPrefetchingEnabled == "true" && (this.isAjaxEnabled == "true")){								
								RegisteredTables.changeRowsPerPage(this.tableId,this.rowsPerPage );
								if(window.document.body.style.cursor == "wait"){
		          					window.document.body.style.cursor = "default";
		          				}
							}else if (this.isPrefetchingEnabled == "false" && (this.isAjaxEnabled == "true")){
								this.actionValue = "changeRowsPerPage("+this.rowsPerPage+")";
								doTblAjax(this.formName,this.actionName,this.actionValue,null,this.actionName,this.wclhidden,null );
								if(window.document.body.style.cursor == "wait"){
				          			window.document.body.style.cursor = "default";
				          		}
							}	else {	
								this.actionValue = "changeRowsPerPage("+this.rowsPerPage+")";
								doTbl(this.formName,this.actionName,this.actionValue,null,this.actionName,this.wclhidden,null );
							}
         			
		          			dojo.stopEvent(e); //equivalent to return false;
					}
					
				},
				
				getCurrentPage: function(){
					return this.currentPage;
				},
				
				getRowsPerPage: function(){
					return this.rowsPerPage;
				},
				
				getRowMax: function(){
					return this.rowMax;
				},
				
				setRowsPerPage: function(rowsPerPage){
					this.rowsPerPage = rowsPerPage;
					this.rowContainer.value = rowsPerPage;
					if(this.rowsPerPage == 0){
						this.rowMax = 0;
					}
				},
				
				setCurrentPage: function(currentPage){
					this.currentPage = currentPage;
					this.pageContainer.value = currentPage;
					this.rowContainer.setAttribute("title", this.rppTextfieldTitle + ": " + this.rowsPerPage);
				},
				
				setPageMax: function(pageMax){
					this.pageMax = pageMax;
					this.rowContainer.setAttribute("title", this.rppTextfieldTitle + ": " + this.rowsPerPage);
				},
				
				setRowMax: function(rowMax){
					this.rowMax = rowMax;
					if(this.rowsPerPage == 0){
						this.pageMax = 1;
					} else {
						this.pageMax = Math.ceil(this.rowMax/this.rowsPerPage);
					}
					this.rowContainer.setAttribute("title", this.rppTextfieldTitle + ": " + this.rowsPerPage);
				}
			}
		);