////////////////////////////////////////////////////////////////////////
//The Source code for this program is not published or otherwise
//divested of its trade secrets, irrespective of what has been
//deposited with the U.S. Copyright Office
//
//(C) Copyright IBM Corp. 2008, 2009
//**********************************************************************

//debug variables
var auiDbgOn = false;
var auiDbgWin = null;
var auiDbgInf = false;

//----------------------------------------------------------------------
// Utility Functions - begin (put utility functions in this section)
//----------------------------------------------------------------------
function removeWindowOpenMethod()
{
    // Search for these values
    var searchStrWindowOpen = "window.open";
    var searchStrHelp = "WN_HELP";

    var currentScripts = document.getElementsByTagName('script');
    var existStrHelp;
    var existStrWindowOpen;
    
    var currentScriptsParentNode;

    for (var i = 0; i < currentScripts.length; i++)
    {
        if (currentScripts[i].innerHTML)
        {
            existStrHelp = currentScripts[i].innerHTML.search(searchStrHelp);
            existStrWindowOpen = currentScripts[i].innerHTML.search(searchStrWindowOpen);
            if ((existStrWindowOpen >= 0) &&  (existStrHelp >= 0))
            {
                currentScriptsParentNode = currentScripts[i].parentNode;
                currentScriptsParentNode.removeChild(currentScripts[i]); 
                break; 
            }
        }
    }	
}


function removeOldChoiceGroups(groupName)
{
         var documentHead = document.getElementsByTagName('head').item(0);
         var currentScripts = documentHead.getElementsByTagName('script');
         var numberExistingScripts = currentScripts.length;
         var cmpString = " function " + groupName + "JS";         
         var cmpString2 = " " + groupName + "JS";
         for (var j = 0; j < currentScripts.length; j++)
         {
	           if (currentScripts[j].innerHTML)
	           {
	           		var cmpp = currentScripts[j].innerHTML.substring(0, cmpString.length);
	           		var cmpp2 = currentScripts[j].innerHTML.substring(0, cmpString2.length);
	           		if ((cmpp == cmpString) || (cmpp2 == cmpString2))
	           		{
	           			documentHead.removeChild(currentScripts[j]);
	           		}
	           }
	     }	 
}

//----------------------------------------------------------------------
// Utility Functions - end
//----------------------------------------------------------------------

//----------------------------------------------------------------------
// Debugging Functions - begin (put debugging functions in this section)
//----------------------------------------------------------------------

function auiDbgMsg(msg) 
{
   if (auiDbgOn == true) 
   {
      if (auiDbgWin == null) 
      {
         auiDbgWin = window.open("","","width=400,height=700,left=0,top=0,resize=yes,scrollbars=yes");
         setAuiDbgWin();
      }
      try 
      {
         if (auiDbgWin != null) 
         {
               auiDbgWin.document.write('<ul><li>');
               auiDbgWin.document.write(msg);
               auiDbgWin.document.write("</li></ul>");
         }
         auiDbgWin.scroll(0,1000000);
         window.focus();
      }
      catch (err)
      {
         if (auiDbgInf == false) // If user has already been informed, don't do it again
         {
            alert("A popup blocker is preventing the debug info from displaying.");
            auiDbgInf = true;
         }
      }
   }
}

function setAuiDbgWin()
{
	auiDbgWin.document.write('<head>');
	auiDbgWin.document.write('<title>AUIML JavaScript Console</title>');
	auiDbgWin.document.write('</head>');
	auiDbgWin.document.write('</h3>AUIML JavaScript Console</h3>');
	auiDbgWin.document.write('<hr>');

	auiDbgWin.document.write('<style typetype="text/css">');
	auiDbgWin.document.write('body			{font-family: Arial, Helvetica, sans-serif}');                   
	auiDbgWin.document.write('h1, h2, h3, h4, ,h5, h6, p, table, td, caption, th, ul, ol, dl, li, dd, dt {font-family: Arial, Helvetica, sans-serif}');
	auiDbgWin.document.write('pre, code		{ font-family: Courier, monospace}');
	auiDbgWin.document.write('body			{ font-size: 10pt; background-color: #FFFFFF}');
	auiDbgWin.document.write('h1			{ font-size: 14pt; margin-top: 5px; margin-bottom: 1px }');
	auiDbgWin.document.write('h2			{ font-size: 12pt; margin-top: 15px; margin-bottom: 3px }');
	auiDbgWin.document.write('h3			{ font-size: 11pt; margin-top: 10px; margin-bottom: 3px; font-style: italic }');
	auiDbgWin.document.write('h4			{ font-size: 10pt; margin-top: 10px; margin-bottom: 3px }');
	auiDbgWin.document.write('p				{ font-size: 10pt; margin-top: 10px; margin-bottom: 10px }');
	auiDbgWin.document.write('a:link		{ color: #0000FF }');
	auiDbgWin.document.write('a:hover		{ color: #0000FF }');
	auiDbgWin.document.write('a:visited		{ color: #0000FF; text-decoration: underline }');
	auiDbgWin.document.write('ul			{ font-size: 10pt; list-style-type: disc; margin-top: 0; margin-bottom: 6px }');
	auiDbgWin.document.write('li			{ font-size: 10pt; margin-top: 0; margin-bottom: 0 }');
	auiDbgWin.document.write('ol			{ font-size: 10pt; list-style-type: decimal; margin-top: 0; margin-bottom: 6px }');
	auiDbgWin.document.write('ol ol			{ font-size: 10pt; list-style-type: lower-alpha; margin-top: 0; margin-bottom: 6px }');
	auiDbgWin.document.write('ol ol ol		{ font-size: 10pt; list-style-type: decimal; margin-top: 0; margin-bottom: 6px }');
	auiDbgWin.document.write('dl			{ padding: 0; font-size: 10pt; margin-top: 6px; margin-bottom: 6px }');
	auiDbgWin.document.write('dt			{ padding: 0; font-size: 10pt; margin-top: 0; margin-bottom: 6px; font-weight: bold }');
	auiDbgWin.document.write('dd			{ padding: 0; font-size: 10pt; margin-left: 15px; margin-top: 0; margin-bottom: 6px }');
	auiDbgWin.document.write('table			{ font-size: 10pt; float: none }');
	auiDbgWin.document.write('th			{ font-size: 10pt; font-weight: bold; background-color: #C0C8D4  }');
	auiDbgWin.document.write('td			{ font-size: 10pt}');
	auiDbgWin.document.write('table.ex		{ background-color: #CCCCCC }');
	auiDbgWin.document.write('strong		{ font-weight: bold}');
	auiDbgWin.document.write('em, cite		{ font-style: italic}');
	auiDbgWin.document.write('var			{ font-style: italic}');
	auiDbgWin.document.write('div.revision	{ border-left-style: solid; border-left-width: thin; border-left-color: #7B68EE; padding-left:5px }');
	auiDbgWin.document.write('.mini			{ font-family: Arial, sans-serif; font-size: 75% }');
	auiDbgWin.document.write('</style>');

}

function auiDbgObj(obj)
{
	var out;
	for (var i in obj)
	{
		out = out+i+"<br>";
	}
	auiDbgMsg(out);
}

function auiDbgPause()
{
	if (auiDbgOn == true)
	{
		alert("Press OK to continue");
	}
}

function auiGetAncestorByNodeName( element, name ) {
	//alert(element);
	if( element == null ) {
		return( null );
	}
	else if( element.nodeName.toLowerCase() == name.toLowerCase() ) {
		return( element );
	}
	else {
		return( auiGetAncestorByNodeName( element.parentNode, name ) );
	}
}

function runOnsubmit(element) {
	var bretVal = false;
	var elem = element;
	if (element.anchor)
	{
		elem = elem.anchor;
	}		
	var frmElement = auiGetAncestorByNodeName(elem, 'form');

	if (frmElement != null) {
	try
	{
		//check if wcl prevents from multi submit
		if (frmElement.sub1 == true || frmElement.submitflag.value == 'true')
		{
			//alert('2nd click');
			return false;
		}
		else
		{	
			frmElement.sub1 = true;
			//handle wcl mechanism
			frmElement.submitflag.value = 'true';
			bretVal = frmElement.onsubmit(frmElement.id);
			return true;
		}
	}
	catch(err)
	{
		return true;		
	}
	} else {
	   return true;
	}
}

//----------------------------------------------------------------------
// Debugging Utilities - end
//----------------------------------------------------------------------
