////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//The Source code for this program is not published or otherwise
//divested of its trade secrets, irrespective of what has been
//deposited with the U.S. Copyright Office
//
//(C) Copyright IBM Corp. 2006
//**********************************************************************

var tablehScrollState = new Array(); //associative array used to store table hScroll data - keyed by table name
var tablevScrollState = new Array(); //associative array used to store table vScroll data - keyed by table name

function scrollSubmit(formName, scrollButtonId)
{
	if (document != null && document.forms != null && formName != null)
	{
		var form = document.forms[formName];
		if (form != null) 
		{
			eval("form.wh.value = '" + scrollButtonId + "'");
			if(!runOnsubmit(form))
			{
				return false;
			}
		    form.submit();
		}
		return false;	
	}
}

// ------------------------------
// horizontal scrolling functions
// ------------------------------

function initTablehScrollState(tableName)
{
	if (tablehScrollState[tableName])
	{
		return;
	}

	//hScroll state information keyed by data name
	var hScrollState = new Array();
	
	//timeout object ids
	hScrollState['toIdSetScrollLeft'] = null;
	hScrollState['toIdhScrollFire'] = null;
	hScrollState['toIdhScrollMove'] = null;

	//boolean flag which indicates if we are actively scrolling
	hScrollState['hScrollAdjusting'] = false;

	//stores initial scroll position
	hScrollState['hInitScrollLeft'] = 0;

	//other values
	hScrollState['colsRatio'] = 0;
	hScrollState['viewTableWidth'] = 0;
	hScrollState['totalTableWidth'] = 0;
	hScrollState['maxScrollLeft'] = 0;

	tablehScrollState[tableName] = hScrollState;
}

function setScrollLeft(divId, scrollLeftRatio)
{
	var tableName = divId.substring(0,divId.indexOf("_hScrollBar"));

	//initialize table hScroll state information
	initTablehScrollState(tableName);
	
	//get table hScroll state information
	var hScrollState = tablehScrollState[tableName];
	
	//if there is an active timeout set, clear it
	if (hScrollState['toIdSetScrollLeft'] != null)
	{
		clearTimeout(hScrollState['toIdSetScrollLeft']);
	}
	
	//if div is not available, keep calling this method until it is
	if (document.getElementById(divId) != null)
	{
		var div = document.getElementById(divId);

		//if needed attributes have not been set keep calling this method until they are
		if  (div.getAttribute('HRATIO') != null && div.getAttribute('HFRAMEID') != null && document.getElementById(tableName+"_tableContainer") != null && document.getElementById(tableName+"_tableContainer").offsetWidth != null)
		{
			//we're going to calculate and set the scrollleft position, so set the scroll adjusting flag
			hScrollState['hScrollAdjusting'] = true;

			//calculate widths
			var colsRatio = div.getAttribute('HRATIO');
			var tableContainer = document.getElementById(tableName+"_tableContainer");
			var viewTableWidth = tableContainer.offsetWidth;
			if(viewTableWidth == 0)
				setTimeout(function(){setScrollLeft(divId, scrollLeftRatio);}, 100);
			var totalTableWidth = Math.floor(parseInt(viewTableWidth) * parseFloat(colsRatio));
			var maxScrollLeft = parseInt(totalTableWidth) - parseInt(viewTableWidth);

			//save off key values
			hScrollState['colsRatio'] = colsRatio;
			hScrollState['viewTableWidth'] = viewTableWidth;
			hScrollState['totalTableWidth'] = totalTableWidth;
			hScrollState['maxScrollLeft'] = maxScrollLeft;
			
			//set div and frame widths
			var frame = document.getElementById(div.getAttribute('HFRAMEID'));
			frame.style.width = totalTableWidth;
			div.style.width = viewTableWidth;
			
			//calculate new scrollleft position			
			var scrollLeft = Math.ceil(parseFloat(viewTableWidth) * parseFloat(scrollLeftRatio));
			scrollLeft = scrollLeft < 0 ? 0 : scrollLeft;
			scrollLeft = scrollLeft > maxScrollLeft ? maxScrollLeft : scrollLeft;

			//save initial scrollleft position
			hScrollState['hInitScrollLeft'] = scrollLeft;

			//set scrollleft position
			div.scrollLeft = scrollLeft;

			//wait for the div to adjust then set the scroll adjusting flag
			hScrollState['toIdSetScrollLeft'] = setTimeout(function(){hScrollState['hScrollAdjusting'] = false;}, 100);
		}
		else
		{
   	 		hScrollState['toIdSetScrollLeft'] = setTimeout(function(){setScrollLeft(divId, scrollLeftRatio);}, 100);
		}
	}
	else
	{
	    hScrollState['toIdSetScrollLeft'] = setTimeout(function(){setScrollLeft(divId, scrollLeftRatio);}, 100);
	}
}

function hScrollFire(formName, divId, scrollLeft, hMinId, colsPerView, ev)
{
	//horizontal scrolling is valid flag
	var hScrollValid = true;
	
	//get table hScroll state information
	var hScrollState = tablehScrollState[divId.substring(0,divId.indexOf("_hScrollBar"))];

	//if there is an active timeout set, clear it
	if (hScrollState['toIdhScrollFire'] != null)
	{
		clearTimeout(hScrollState['toIdhScrollFire']);
	}

	// check if left or right arrow key was pressed, ev will only be set when a key is pressed
	if (ev)
	{
		var keyPressed = null;
		if (window.event) //IE
		{
			keyPressed = window.event.keyCode;
		}
		else
		{
			keyPressed = ev.keyCode
		}

		// if the left or right arrow key was NOT pressed, set the valid flag to false so we don't attempt an unnecessary scroll move
		if (keyPressed != '37' && keyPressed != '39')
		{
			hScrollValid = false;
		}
	}
	
	//clicking scrollbar buttons when in the leftmost or rightmost position still triggers an event; in these specific cases there is no need to process the event
	if (parseInt(scrollLeft) < parseInt(hScrollState['hInitScrollLeft']))
	{ //attempting to scroll left when in the leftmost position?
		if (parseInt(hScrollState['hInitScrollLeft']) == 0)
		{
			hScrollValid = false;
		}
	}
	else if (parseInt(scrollLeft) > parseInt(hScrollState['hInitScrollLeft']))
	{ //attempting to scroll right when in the rightmost position?
		if (parseInt(hScrollState['hInitScrollLeft']) == parseInt(hScrollState['maxScrollLeft']))
		{
			hScrollValid = false;
		}
	}
	else
	{
		hScrollValid = false;
	}
	
	//only move the scrollleft position if we finished setting the initial scrollleft position and the scroll action is valid
	if (hScrollState['hScrollAdjusting'] == false && hScrollValid == true)
	{
		hScrollState['toIdhScrollFire'] = setTimeout(function(){hScrollMove(formName, divId, scrollLeft, hMinId, colsPerView);},500);
	}
}

function hScrollMove(formName, divId, scrollLeft, hMinId, colsPerView)
{
	var tableName = divId.substring(0,divId.indexOf("_hScrollBar"));

	//get table hScroll state information
	var hScrollState = tablehScrollState[divId.substring(0,divId.indexOf("_hScrollBar"))];

	//if there is an active timeout set, clear it
	if (hScrollState['toIdhScrollFire'] != null)
	{
		clearTimeout(hScrollState['toIdhScrollFire']);
	}
	if (hScrollState['toIdhScrollMove'] != null)
	{
		clearTimeout(hScrollState['toIdhScrollMove']);
	}

	//if the min field is not available, keep calling this method until it is
	if (document.getElementById(hMinId) != null)
	{
		var div = document.getElementById(divId);
		var minField = document.getElementById(hMinId);

		//calculate scroll adjustment		
		var prvScrollLeft = hScrollState['hInitScrollLeft'];
		var newScrollLeft = scrollLeft;
		var scrollAdj = Math.abs(parseInt(newScrollLeft) - parseInt(prvScrollLeft));

		//calculate widths
		var colsRatio = hScrollState['colsRatio'];
		var viewTableWidth = hScrollState['viewTableWidth'];
		var totalTableWidth = hScrollState['totalTableWidth'];

		//calculate minimum scrollleft adjustment
	    var minScrollAdj = Math.ceil(parseFloat(viewTableWidth) / parseFloat(colsPerView));
			
		//if minimum scrollbar adjustment has not occurred, adjust accordingly
		var adjustedScrollLeft = newScrollLeft;
		var scrollAdjusted = false;
		if (scrollAdj < minScrollAdj)
		{
			var minScrollLeft = 0;
			var maxScrollLeft = parseInt(totalTableWidth) - parseInt(viewTableWidth);

			if (parseInt(newScrollLeft) > parseInt(prvScrollLeft))
			{ //scrolling right
				newScrollLeft = parseInt(newScrollLeft) + parseInt(minScrollAdj);
				newScrollLeft = (parseInt(newScrollLeft) <= parseInt(maxScrollLeft)) ? newScrollLeft : maxScrollLeft;
				scrollAdjusted = true;
				adjustedScrollLeft = newScrollLeft;
			}
			if (parseInt(newScrollLeft) < parseInt(prvScrollLeft))
			{ //scrolling left
				newScrollLeft = parseInt(newScrollLeft) - parseInt(minScrollAdj);
				newScrollLeft = (parseInt(newScrollLeft) >= parseInt(minScrollLeft)) ? newScrollLeft : minScrollLeft;
				scrollAdjusted = true;
				adjustedScrollLeft = newScrollLeft;
			}
		}

		var minFieldValue = minField.value;
		var scrollLeftValue = scrollLeft;
		if (scrollAdjusted == true)
		{
			//we need to adjust the scrollleft position
			div.scrollLeft = adjustedScrollLeft;
			scrollLeftValue = adjustedScrollLeft;
		}
		//we're done scrolling - update min field and submit the form
		minFieldValue = Math.round(parseInt(scrollLeftValue) * parseInt(colsPerView) / parseInt(div.offsetWidth));
		minField.value = minFieldValue;
		var scrollButtonId = divId.substring(0,divId.indexOf("_hScrollBar"))+"_scrollButton";
		scrollSubmit(formName, scrollButtonId);
	}
	else
	{
		hScrollState['toIdhScrollMove'] = setTimeout(function(){hScrollMove(formName, divId, scrollLeft, hMinId, colsPerView);},100);
	}
}

// ------------------------------
// vertical scrolling functions
// ------------------------------

function initTablevScrollState(tableName)
{
	if (tablevScrollState[tableName])
	{
		return;
	}

	//hScroll state information keyed by data name
	var vScrollState = new Array();
	
	//timeout object ids
	vScrollState['toIdSetScrollTop'] = null;
	vScrollState['toIdvScrollFire'] = null;
	vScrollState['toIdvScrollMove'] = null;

	//boolean flag which indicates if we are actively scrolling
	vScrollState['vScrollAdjusting'] = false;

	//stores initial scroll position
	vScrollState['vInitScrollTop'] = 0;

	//other values
	vScrollState['rowsRatio'] = 0;
	vScrollState['viewTableHeight'] = 0;
	vScrollState['totalTableHeight'] = 0;
	vScrollState['maxScrollTop'] = 0;
	
	tablevScrollState[tableName] = vScrollState;
}
	
function setScrollTop(divId, scrollTopRatio, tableDivId)
{
	var tableName = divId.substring(0,divId.indexOf("_vScrollBar"));
	
	//initialize table vScroll state information
	initTablevScrollState(tableName);
	
	//get table vScroll state information
	var vScrollState = tablevScrollState[tableName];

	//if there is an active timeout set, clear it
	if (vScrollState['toIdSetScrollTop'] != null)
	{
		clearTimeout(vScrollState['toIdSetScrollTop']);
	}
	
	//if divs are not available, keep calling this method until they are
	if (document.getElementById(divId) != null && document.getElementById(tableDivId) != null)
	{
		var div = document.getElementById(divId);
		var tableDiv = document.getElementById(tableDivId);

		//if needed attributes have not been set, keep calling this method until they are
		if  (div.getAttribute('VRATIO') != null && div.getAttribute('VFRAMEID') != null && document.getElementById(tableName+"_tableContainer") != null && document.getElementById(tableName+"_tableContainer").getAttribute("TOTALHEIGHT") != null)
		{
			//size the top spacer image so that the vertical scrollbar will be aligned with the table data rows
			var spacerTopImageHeight = 0;
			var tableName = divId.substring(0,divId.indexOf("_vScrollBar"));
			
			var findToolBarRowSpan = document.getElementById(tableName + "_findToolBarRow");
			var findToolBarRow = null;
			if (findToolBarRowSpan != null && findToolBarRowSpan.firstChild)
			{
				findToolBarRow = findToolBarRowSpan.firstChild;
				spacerTopImageHeight = parseInt(spacerTopImageHeight)+parseInt(findToolBarRow.offsetHeight);
			}
			
			var toolBarRowSpan = document.getElementById(tableName + "_toolBarRow");
			var toolBarRow = null;
			if (toolBarRowSpan != null && toolBarRowSpan.firstChild)
			{
				if (toolBarRowSpan.firstChild.firstChild)
				{
					if (toolBarRowSpan.firstChild.firstChild.nextSibling)
					{
						toolBarRow = toolBarRowSpan.firstChild.firstChild.nextSibling;
						spacerTopImageHeight = parseInt(spacerTopImageHeight)+parseInt(toolBarRow.offsetHeight);
					}
				}
			}
			var headerRow = document.getElementById(tableName + "_headerRow");
			if (headerRow != null && headerRow.offsetHeight)
			{
				spacerTopImageHeight = parseInt(spacerTopImageHeight)+parseInt(headerRow.offsetHeight)-1;
			}
			var spacerTopImage = document.getElementById(tableName + "_vScrollBarTopSpacer");
			spacerTopImage.style.height = spacerTopImageHeight;
			
			//we're going to calculate and set the scrolltop position, so set the scroll adjusting flag
			vScrollState['vScrollAdjusting'] = true;

			//calculate heights
			var rowsRatio = div.getAttribute('VRATIO');
			var tableContainer = document.getElementById(tableName+"_tableContainer");
			var viewTableHeight = tableContainer.getAttribute("TOTALHEIGHT");
			var totalTableHeight = Math.floor(parseInt(viewTableHeight) * parseFloat(rowsRatio));
			var maxScrollTop = parseInt(totalTableHeight) - parseInt(viewTableHeight);
			
			//save off key values
			vScrollState['rowsRatio'] = rowsRatio;
			vScrollState['viewTableHeight'] = viewTableHeight;
			vScrollState['totalTableHeight'] = totalTableHeight;
			vScrollState['maxScrollTop'] = maxScrollTop;
			
			//set div and frame widths
			var frame = document.getElementById(div.getAttribute('VFRAMEID'));
			frame.style.height = totalTableHeight;
			div.style.height = viewTableHeight;
			
			//calculate new scrolltop position			
			var scrollTop = Math.ceil(parseFloat(viewTableHeight) * parseFloat(scrollTopRatio));
			scrollTop = scrollTop < 0 ? 0 : scrollTop;
			scrollTop = scrollTop > maxScrollTop ? maxScrollTop : scrollTop;

			//save initial scrolltop position
			vScrollState['vInitScrollTop'] = scrollTop;

			//set scrolltop position
			div.scrollTop = scrollTop;

			//size the bottom spacer image to fill the area below the vertical scrollbar
			var spacerBottomImage =  document.getElementById(tableName + "_vScrollBarBottomSpacer");
			var vScrollBarOuterTd = document.getElementById(tableName + "_vScrollBarOuterTd");
			var vScrollBarInnerTd = document.getElementById(tableName + "_vScrollBarInnerTd");
			var vScrollBarOuterTdHeight = vScrollBarOuterTd.offsetHeight;
			var vScrollBarInnerTdHeight = vScrollBarInnerTd.offsetHeight;
			var spacerBottomImageHeight = parseInt(vScrollBarOuterTdHeight)-parseInt(vScrollBarInnerTdHeight)-1;
			spacerBottomImage.style.height = spacerBottomImageHeight;

			//wait for the div to adjust then set the scroll adjusting flag
			vScrollState['toIdSetScrollTop'] = setTimeout(function(){vScrollState['vScrollAdjusting'] = false;}, 100);
		}
		else
		{
   	 		vScrollState['toIdSetScrollTop'] = setTimeout(function(){setScrollTop(divId, scrollTopRatio, tableDivId);}, 100);
		}
	}
	else
	{
	    vScrollState['toIdSetScrollTop'] = setTimeout(function(){setScrollTop(divId, scrollTopRatio, tableDivId);}, 100);
	}
}

function vScrollFire(formName, divId, scrollTop, vMinId, rowsPerView, tableDivId, ev)
{
	//vertical scrolling is valid flag
	var vScrollValid = true;

	//get table vScroll state information
	var vScrollState = tablevScrollState[divId.substring(0,divId.indexOf("_vScrollBar"))];
	
	//if there is an active timeout set, clear it
	if (vScrollState['toIdvScrollFire'] != null)
	{
		clearTimeout(vScrollState['toIdvScrollFire']);
	}

	//check if up or down arrow key was pressed, ev will only be set when a key is pressed
	if (ev)
	{
		var keyPressed = null;
		if (window.event) //IE
		{
			keyPressed = window.event.keyCode;
		}
		else
		{
			keyPressed = ev.keyCode
		}
		
		// if the up or down arrow key was NOT pressed, set the valid flag to false so we don't attempt an unnecessary scroll move
		if (keyPressed != '38' && keyPressed != '40')
		{
			vScrollValid = false;
		}
	}

	//clicking scrollbar buttons when in the topmost or bottommost position still triggers an event; in these specific cases there is no need to process the event
	if (parseInt(scrollTop) < parseInt(vScrollState['vInitScrollTop']))
	{ //attempting to scroll up when in the topmost position?
		if (parseInt(vScrollState['vInitScrollTop']) == 0)
		{
			vScrollValid = false;
		}
	}
	else if (parseInt(scrollTop) > parseInt(vScrollState['vInitScrollTop']))
	{ //attempting to scroll down when in the bottommost position?
		if (parseInt(vScrollState['vInitScrollTop']) == parseInt(vScrollState['maxScrollTop']))
		{
			vScrollValid = false;
		}
	}
	else
	{
		vScrollValid = false;
	}
	
	//only move the scrolltop position if we finished setting the initial scrolltop position and the scroll action is valid
	if (vScrollState['vScrollAdjusting'] == false && vScrollValid == true)
	{
		vScrollState['toIdvScrollFire'] = setTimeout(function(){vScrollMove(formName, divId, scrollTop, vMinId, rowsPerView, tableDivId);},500);
	}
}

function vScrollMove(formName, divId, scrollTop, vMinId, rowsPerView, tableDivId)
{
	//get table vScroll state information
	var vScrollState = tablevScrollState[divId.substring(0,divId.indexOf("_vScrollBar"))];

	//if there is an active timeout set, clear it
	if (vScrollState['toIdvScrollFire'] != null)
	{
		clearTimeout(vScrollState['toIdvScrollFire']);
	}
	if (vScrollState['toIdvScrollMove'] != null)
	{
		clearTimeout(vScrollState['toIdvScrollMove']);
	}

	//if divs and min field are not available, keep calling this method until they are
	if (document.getElementById(divId) != null  && document.getElementById(tableDivId) != null && document.getElementById(vMinId) != null)
	{
		var div = document.getElementById(divId);
		var tableDiv = document.getElementById(tableDivId);
		var minField = document.getElementById(vMinId);

		//calculate scroll adjustment		
		var prvScrollTop = vScrollState['vInitScrollTop'];
		var newScrollTop = scrollTop;
		var scrollAdj = Math.abs(parseInt(newScrollTop) - parseInt(prvScrollTop));

		//calculate heights
		var rowsRatio = vScrollState['rowsRatio'];
		/*var viewTableHeight = tableDiv.style.height;*/
		var viewTableHeight = vScrollState['viewTableHeight'];
		var totalTableHeight = vScrollState['totalTableHeight'];

		//calculate minimum scrolltop adjustment
	    var minScrollAdj = Math.ceil(parseFloat(viewTableHeight) / parseFloat(rowsPerView));
			
		//if minimum scrollbar adjustment has not occurred, adjust accordingly
		var adjustedScrollTop = newScrollTop;
		var scrollAdjusted = false;
		if (scrollAdj < minScrollAdj)
		{
			var minScrollTop = 0;
			var maxScrollTop = vScrollState['maxScrollTop'];
				
			if (parseInt(newScrollTop) > parseInt(prvScrollTop))
			{ //scrolling down
				newScrollTop = parseInt(prvScrollTop) + parseInt(minScrollAdj);
				newScrollTop = (parseInt(newScrollTop) <= parseInt(maxScrollTop)) ? newScrollTop : maxScrollTop;
				scrollAdjusted = true;
				adjustedScrollTop = newScrollTop;
			}
			if (parseInt(newScrollTop) < parseInt(prvScrollTop))
			{ //scrolling up
				newScrollTop = parseInt(prvScrollTop) - parseInt(minScrollAdj);
				newScrollTop = (parseInt(newScrollTop) >= parseInt(minScrollTop)) ? newScrollTop : minScrollTop;
				scrollAdjusted = true;
				adjustedScrollTop = newScrollTop;
			}
		}

		var minFieldValue = minField.value;
		var scrollTopValue = scrollTop;
		if (scrollAdjusted == true)
		{
			//we need to adjust the scrolltop position
			div.scrollTop = adjustedScrollTop;
			scrollTopValue = adjustedScrollTop;
		}
		//we're done scrolling - update min field and submit the form
		minFieldValue = Math.round(parseInt(scrollTop) * parseInt(rowsPerView) / parseInt(div.offsetHeight));
		minField.value = minFieldValue;
		var scrollButtonId = divId.substring(0,divId.indexOf("_vScrollBar"))+"_scrollButton";
		scrollSubmit(formName, scrollButtonId);
	}
	else
	{
		vScrollState['toIdvScrollMove'] = setTimeout(function(){vScrollMove(formName, divId, scrollTop, vMinId, rowsPerView, tableDivId);},100);
	}
}
