/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Presentation Services
*
* (C) Copyright IBM Corp. 2007, 2008  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} ***
*******************************************************************************/

AutoCompletion.prototype.hKeyDown = function(e){
	var keynum
	var numcheck

	keynum = e.keyCode;
	
	var arrow = false;
	var enter = false;
	// up
	if(keynum == 38){
		this.selectedHint--;
		arrow = true;
	// down
	}else if(keynum == 40){
		this.selectedHint++;
		arrow = true;
	}
	
		
	if(this.selectedHint < 0){
		// original value from input
		this.selectedHint = this.hintCount;
	}else if(this.selectedHint > this.hintCount){
		this.selectedHint = 0;
	}
	
	var newValue;
	if(this.selectedHint == this.hintCount){
		newValue = this.originalValue;
	}else{
		newValue = document.getElementById(this.hintIDPrefix + this.selectedHint).innerHTML;		
	}
	
	for(var i=0; i<this.hintCount; i++){
		var hintDiv = document.getElementById(this.hintIDPrefix + i);
		if(i == this.selectedHint){
			hintDiv.className = 'teac5';
		}else{
			hintDiv.className = 'teac4';
		}
			
	}
	if(arrow && (this.input.value.length >= this.minChars)){
		this.input.value = newValue;
		this.prevValue = this.input.value;
		this.valueIsDirty = false;
		if(this.hintCount > 0 ){
			this.hintDiv.style.display = 'block';
		}
	}
	return false;
}

AutoCompletion.prototype.hKeyUp = function(e){
	if(this.tComplete){
		clearTimeout(this.tComplete);
	}
	
	if(this.prevValue != this.input.value){
		this.valueIsDirty = true;
	}
	if(this.input.value.length >= this.minChars){
		if(this.valueIsDirty && e.keyCode!=40 && e.keyCode!=38){
			this.ajaxUpdate(true, this.delay, 0, new Date().getTime());
			}
	}else{
		document.getElementById(this.hintDivID).style.display = 'none';
		}
}

AutoCompletion.prototype.ajaxUpdate = function(show, delay, requestId, firedTime){
	if(requestId == 0){
		requestId = ++this.lastRequestId;
	}else if(requestId < this.lastRequestId){
		// new requests ready, omit this one
		return;
	}else if (delay < -3000){
		// request expired
		return;
		
	}
	if(isAJAXOutstanding){
		// cannot send request, retry after 50 ms
		var nextRequest = '' + this.varName +'.ajaxUpdate(' + show + ',' + (delay-50) + ', ' + requestId + ', ' + firedTime + ')';
		setTimeout(nextRequest, 50);
		return;
	}
	if(this.input.value.length >= this.minChars){
		document.getElementById(this.shID).value = show;
		var requestDelay = (firedTime>0) ? this.delay - (new Date().getTime() - firedTime) : 0;
		if(requestDelay> 0){
			this.tComplete = setTimeout(
					"document.getElementById('" + this.crID + "').value = true;"+
					"frmActAjax('" + this.inputID + "', '" + this.formID + "', '" + this.wh + "');" +
					"document.getElementById('" + this.crID + "').value = false;", 
					requestDelay);
	}else{
			document.getElementById(this.crID).value = true;
			frmActAjax(this.inputID, this.formID, this.wh);
			document.getElementById(this.crID).value = false;
		}
	}
	this.reinit(this.input.value);
}

function AutoCompletion(variableName, inputID, hintDivID, delay, minChars, formID, 
wh, showHintsID, scriptID, hintIDPrefix, crID){
	this.varName = variableName;
	this.inputID = inputID;
	this.input = document.getElementById(inputID);
	this.prevValue = this.input.value;
	this.hintDivID = hintDivID;	
	this.formID = formID;
	this.shID = showHintsID;
	this.wh = wh;
	this.delay = delay;
	this.minChars = minChars;
	this.tComplete = null;
	this.valueIsDirty = false;
	this.hintIDPrefix = hintIDPrefix;
	this.crID = crID;
	this.lastRequestId = 0;
	
	// remove this script to avoid executing it multiple times
	var se = document.getElementById(scriptID);
	se.parentNode.removeChild(se);
		
	    }

// this should be executed after instantiation of AutoCompletion, 
// or any updates to completion hints
AutoCompletion.prototype.reinit = function(value){
	var count = 0;
	while(document.getElementById(this.hintIDPrefix + count) != null){
		count++;
	}
	this.hintCount = count;
	this.selectedHint = this.hintCount;
	this.originalValue = this.input.value;
	this.hintDiv = document.getElementById(this.hintDivID);	
	if(value.length < this.minChars || value != this.input.value){
		this.hintDiv.style.display = 'none';
	}
}

AutoCompletion.prototype.hMouseOver = function(index){
	this.selectedHint = index;
	for(var i=0; i<this.hintCount; i++){
		var hint = document.getElementById(this.hintIDPrefix + i);
		if(i == index){
			hint.className = 'teac5';
		}else{
			hint.className = 'teac4';
		}
	}
}

AutoCompletion.prototype.hMouseOut = function(){
}

AutoCompletion.prototype.hClick = function(index){
	this.selectedHint = index;
	this.input.value = document.getElementById(this.hintIDPrefix + this.selectedHint).innerHTML;
	this.prevValue = this.input.value;
	this.valueIsDirty = false;
	this.hintDiv.style.display = 'none';
	this.input.focus();
	this.delay = '0';
	this.ajaxUpdate(false, 0, 0, 0);
}

AutoCompletion.prototype.hBlur = function(){
	var divId = this.hintDivID;
	clearTimeout(this.tComplete);
	setTimeout("if(document.getElementById('"+divId+"')) document.getElementById('"+divId+"').style.display = 'none'", 150);
}

AutoCompletion.prototype.hideHints = function(){
	this.hintDiv.style.display = 'none';
}

AutoCompletion.prototype.hKeyPress = function(event){
	if (event.keyCode==13 && this.selectedHint>=0 
		&& this.selectedHint<this.hintCount 
		&& this.hintDiv.style.display != 'none') {
			// selection by enter
			this.hClick(this.selectedHint);
			return false;
		}else if (event.keyCode==13){
			// enter
			textEntryActAjax(
				document.getElementById(this.inputID).id,	//	actionName
				this.formID,
				this.wh);
			return false;
		} ;
}
