/*********************************************************** {COPYRIGHT-TOP} ***
 * Licensed Materials - Property of IBM
 * Tivoli Presentation Services
 *
* (C) Copyright IBM Corp. 2006, 2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ************************************************************ {COPYRIGHT-END} ***
 *******************************************************************************/

/*******************************************************************************
 * This file contains AJAX utility functions.
 ******************************************************************************/
var isAJAXOutstanding = false;
var inputData = new FormsData();
var ajaxTables = new Array();

var refreshForm = "";
var refreshParams = new Array();

var requestTimeout = 0;// Time in milliseconds

function startRequest(form,actionValue) {
	if (!isAJAXOutstanding) {
		removeAnchorsForNB();
		isAJAXOutstanding = true;
	    var inputFieldsArray = getQueryInputFields(form, actionValue);
	    var inputFields = convertInputFieldsArrayToString(inputFieldsArray);
		
		// Save all the form fields so we can save user changes during the request.
		inputData.initialize();
		
        //window.status = "Retrieving data from server";
	    window.document.body.style.cursor = "wait";
		
		var idx = form.action.indexOf('#');
		if (idx > -1) {
			debug("Removing anchor");
			form.action = form.action.substring(0, idx);
		}
	    // Save the request so we can refresh if we get new content.
	    refreshForm = form.action;
	    refreshParams = inputFieldsArray;
	
	    debug("Request; Post Form : "+form.id+", action: " +form.action);
	    debug("Input: "+inputFields);
	    
		var actionString = getActionString(form);

		actionString = addAuimlTransactionSupport(actionString, inputFields);
		
		
		if(actionValue && actionValue.indexOf("wclSaveCmd")!= -1){
			actionString = form.action;
			
		}
		
		debug("action [" + actionString + "]");
		var wcldojo = WUtilities.getDojoNamespace();
		wcldojo.xhrPost( {
			// The following URL must match that used to test the server.
			url :actionString,
			handleAs :"text",
//			form :form,
			timeout : requestTimeout, // Time in milliseconds
			content : inputFieldsArray, // additional request parameters
	
			// The LOAD function will be called on a successful response.
			load : handleStateChange,
	
			// The ERROR function will be called in an error case.
			error :handleRequestErrorDojo
		});
	}
}

function startRequestSingleUpdate(form, actionValue, action) {
	   if (!isAJAXOutstanding) {
	      isAJAXOutstanding = true;

	      var inputFieldsArray = getQueryInputFieldsSingleUpdate(form, actionValue, action);
	      var inputFields = convertInputFieldsArrayToString(inputFieldsArray);
	      
	      // Save all the form fields so we can save user changes during the request.
	      inputData.initialize();

	      //window.status = "Retrieving data from server";
	      window.document.body.style.cursor = "wait";

	      var idx = form.action.indexOf('#');
	      if (idx > -1)
	      {
	         debug("Removing anchor");
	         form.action = form.action.substring(0, idx);
	      }

	      // Save the request so we can refresh if we get new content.
	      refreshForm = form.action;
	      refreshParams = inputFieldsArray;
	      
		var actionString = getActionString(form);
		var wcldojo = WUtilities.getDojoNamespace();
			wcldojo.xhrPost( {
				// The following URL must match that used to test the server.
				url : actionString,
				handleAs :"text",
//				form :form,
				timeout : requestTimeout, // Time in milliseconds
				content : inputFieldsArray, // additional request parameters
			
				// The LOAD function will be called on a successful response.
				load :handleStateChange,
			
				// The ERROR function will be called in an error case.
				error :handleRequestErrorDojo
			});

	   }
	}

function startHrefRequest(url) {
	if (!isAJAXOutstanding) {
		isAJAXOutstanding = true;
		debugInfo("Request: " + url);
		var wcldojo = WUtilities.getDojoNamespace();
		wcldojo.xhrGet({
			url : url + "&IsAjaxInvoked=YES" + getForms(),
			handleAs :"text",
			timeout : requestTimeout, // Time in milliseconds
			// The LOAD function will be called on a successful response.
			load :handleStateChange,
		
			// The ERROR function will be called in an error case.
			error :handleRequestErrorDojo			
		});
	}
}

var requestor = undefined;
function startDataRequest(form, actionValue, func, r) {
	if (!isAJAXOutstanding) {
		isAJAXOutstanding = true;

		requestor = r;
	    var inputFieldsArray;
	    if(form[form.wh.value].value.indexOf("changeSelected") != -1){
	    	inputFieldsArray = getSelectedRowsInput(form);
	      	if(inputFieldsArray['#selectedRows'] !== undefined){
			    actionValue = 'changeSelected(' + inputFieldsArray['#selectedRows'].join(',') + ')';
			    delete inputFieldsArray['#selectedRows'];
	      	}else{
	      		actionValue = 'changeSelected()';
	      	}
			putInputValueIntoArray(inputFieldsArray, form.wh.value, actionValue);
	
			putInputValueIntoArray(inputFieldsArray, 'IsAjaxInvoked', 'YES');
			putInputValueIntoArray(inputFieldsArray, 'AjaxForms', getFormsList());
			// TODO: de-hardcode 'wh' ?
			putInputValueIntoArray(inputFieldsArray, 'wh', form.wh.value);		
		    // ajax in portlets
		    putAjaxInPortletsParams(inputFieldsArray, form);
	    } else if (form[form.wh.value].value.indexOf("rowRefresh") != -1) {
	    	inputFieldsArray = new Array();
	    	putInputValueIntoArray(inputFieldsArray, form.wh.value, actionValue);
	
			putInputValueIntoArray(inputFieldsArray, 'IsAjaxInvoked', 'YES');
			putInputValueIntoArray(inputFieldsArray, 'AjaxForms', getFormsList());
			// TODO: de-hardcode 'wh' ?
			putInputValueIntoArray(inputFieldsArray, 'wh', form.wh.value);	

		    // ajax in portlets
		    putAjaxInPortletsParams(inputFieldsArray, form);
	    }else{
		    inputFieldsArray = getQueryInputFields(form, actionValue);
	    }		
	    
	    var inputFields = "IsAjaxDataRequest=YES&"+convertInputFieldsArrayToString(inputFieldsArray);

		// Save all the form fields so we can save user changes during the
		// request.
		inputData.initialize();

		// window.status = "Retrieving data from server";
		// window.document.body.style.cursor = "wait";

		var idx = form.action.indexOf('#');
		if (idx > -1) {
			debug("Removing anchor");
			form.action = form.action.substring(0, idx);
		}

		// Save the request so we can refresh if we get new content.
		refreshForm = form.action;
		refreshParams = inputFieldsArray;

		debugInfo("Request; Post Form : " + form.id + ", action: "
				+ form.action);
		debugInfo("Input: " + inputFields);

		var actionString = getActionString(form);
		var wcldojo = WUtilities.getDojoNamespace();
			wcldojo.xhrPost( {
				// The following URL must match that used to test the server.
				url : actionString,
				handleAs :"text",
				timeout : requestTimeout, // Time in milliseconds
				content : inputFieldsArray, // additional request parameters
			
				// The LOAD function will be called on a successful response.
				load :func,
			
				// The ERROR function will be called in an error case.
				error :handleRequestErrorDojo
			});
	}
}

function startServerSyncRequest(form, actionValue, func, r) {
	if (!isAJAXOutstanding) {
		isAJAXOutstanding = true;

		requestor = r;
	    var inputFieldsArray = getQueryInputFields(form, actionValue);
	    var inputFields = "IsAjaxServerSync=YES&"+convertInputFieldsArrayToString(inputFieldsArray);

		// Save all the form fields so we can save user changes during the
		// request.
		inputData.initialize();

		// window.status = "Retrieving data from server";
		// window.document.body.style.cursor = "wait";

		var idx = form.action.indexOf('#');
		if (idx > -1) {
			debug("Removing anchor");
			form.action = form.action.substring(0, idx);
		}

		// Save the request so we can refresh if we get new content.
		refreshForm = form.action;
		refreshParams = inputFieldsArray;

		debugInfo("Request; Post Form : " + form.id + ", action: "
				+ form.action);
		debugInfo("Input: " + inputFields);
		var actionString = getActionString(form);
		var wcldojo = WUtilities.getDojoNamespace();
		wcldojo.xhrPost( {
			// The following URL must match that used to test the server.
			url : actionString,
			handleAs :"text",
			timeout : requestTimeout, // Time in milliseconds
			content : inputFieldsArray, // additional request parameters
		
			// The LOAD function will be called on a successful response.
			load :func,
		
			// The ERROR function will be called in an error case.
			error :handleRequestErrorDojo
		});
	}
}



function startRefreshRequest(refreshFormAction, refreshInputFields, ajaxRefresh) {
	delete refreshInputFields["IsAjaxInvoked"];
	removeAnchorsForNB();		
	if (ajaxRefresh != null && ajaxRefresh == "YES") {
		refreshInputFields["AjaxRefresh"]=["YES"];
	}
	debug("startRefreshRequest : form [" + refreshFormAction + "] action ["
			+ convertInputFieldsArrayToString(refreshInputFields) + "]");

	isAJAXOutstanding = true;
	// window.status = "Retrieving data from server";
	window.document.body.style.cursor = "wait";
	var wcldojo = WUtilities.getDojoNamespace();
	wcldojo.xhrPost( {
		// The following URL must match that used to test the server.
		url : refreshFormAction,
		handleAs :"text",
		timeout : requestTimeout, // Time in milliseconds
		content : refreshInputFields, // additional request parameters
	
		// The LOAD function will be called on a successful response.
		load :handleRefreshStateChange,
	
		// The ERROR function will be called in an error case.
		error :handleRequestErrorDojo
	});	
}

function getFormsList(){
	var formsList = "";
	if (document.forms != null) {
		var addForm = false;
		var formDivs = null;
		for ( var i = 0; i < document.forms.length; ++i) {
			addForm = false;
			var parent = document.forms[i].parentNode;
			while (!addForm && parent) {
            //[#108688]-Accessibility - duplicated ids
			  
				if ((parent.nodeType == 1)
						&& (parent.getAttribute("id")) && (parent.getAttribute("id").indexOf("AJAX_CONTAINER")!=-1)) {
					addForm = true;
				}
				parent = parent.parentNode;
			}
			if (addForm) {
				formsList += document.forms[i].name + ",";
			}
		}
		debug("AJAX forms [" + formsList + "]");
	}
	return formsList;
}

function getForms() {
	var formsList = getFormsList();
	if (formsList.length > 0) {
		formsList = "&AjaxForms=" + formsList;
	}
	return formsList;
}

function putInputValueIntoArray(arr, index, val){
	if(arr!=null && index!=null){
		if(arr[index]!=null){
			arr[index].push(val);
		} else {
			arr[index]=[];
			arr[index].push(val);
		}
	}
}


function putAjaxInPortletsParams(arr, form){
	arr["namespace"] = form.namespace.value;
	arr["wcl_psk"] = form.wcl_psk.value;
}

function getSelectedRowsInput(form){
	var fieldArray = new Array();
	var rows = new Array();
	
	if (form != null) {
		fieldList = form.getElementsByTagName("input");
		if (fieldList.length != 0) {
			for ( var i = 0; i < fieldList.length; i++) {
				var fieldName = fieldList.item(i).getAttribute("name");
				var fieldType = fieldList.item(i).getAttribute("type");
				// Only process input tags with a NAME attr, and if row is selected
				if ((fieldName != null) && (fieldName != "")  && isInSelectedRow(fieldList.item(i))) {
					var row = getRowNumber(fieldList.item(i));
					rows[' ' +row] = row;
					if ((fieldType == "text") || (fieldType == "hidden")
							|| (fieldType == "password")) {
						debugInfo("queryInputFields: input fieldName is '"
								+ fieldName + "'  value is '"
								+ fieldList.item(i).value + "'  encodeURI: '"
								+ encodeURI(fieldList.item(i).value) + "'");
						putInputValueIntoArray(fieldArray, fieldName, fieldList.item(i).value);		
					} else if (((fieldType == "checkbox") || (fieldType == "radio"))
							&& (fieldList.item(i).checked)) {
						debugInfo("queryInputFields: input fieldName is '"
								+ fieldName + "'  value is '"
								+ fieldList.item(i).value + "'  encodeURI: '"
								+ encodeURI(fieldList.item(i).value) + "'");
						putInputValueIntoArray(fieldArray, fieldName, fieldList.item(i).value);		
					}
				}
			}
		}

		var selectList = form.getElementsByTagName("select");
		if (selectList.length != 0) {
			for ( var i = 0; i < selectList.length; i++) {
				if(isInSelectedRow(selectList.item(i))){
					var row = getRowNumber(selectList.item(i));
					rows[' ' +row] = row;
					var sel = selectList.item(i);
					for ( var j = 0; j < sel.length; j++) {
						if (sel.options[j].selected == true) {
							debugInfo("queryInputFields: select name is '"
									+ sel.name + "'  value is '"
									+ sel.options[j].value + "'  encodeURI: '"
									+ encodeURI(sel.options[j].value) + "'");
							putInputValueIntoArray(fieldArray, sel.name, sel.options[j].value);		
						}
					}
				}
			}
		}

		var textAreaList = form.getElementsByTagName("textarea");
		if (textAreaList.length != 0) {
			for ( var i = 0; i < textAreaList.length; i++) {
				var textArea = textAreaList.item(i);
				if (textArea.name != null && textArea.name != "" && isInSelectedRow(textAreaList.item(i))) {
					var row = getRowNumber(textAreaList.item(i));
					rows[' ' +row] = row;
					debugInfo("queryInputFields: textarea name is '"
							+ textArea.name + "'  value is '" + textArea.value
							+ "'  encodeURI: '" + encodeURI(textArea.value)
							+ "'");
					putInputValueIntoArray(fieldArray, textArea.name, textArea.value);		
				}
			}
		}
		putInputValueIntoArray(fieldArray, "btimestamp", new Date().getTime());		
	}
	for(i in rows){
		putInputValueIntoArray(fieldArray, '#selectedRows', rows[i]);		
	}
	return fieldArray;
	
}

function getSelectedRowNumbers(selectName){
	var rows = new Array();
	checkboxes = document.getElementsByName(selectName);
	for(var i=0; i < checkboxes.length; i++){
		if(checkboxes[i].checked){
			rows.push(checkboxes[i].value);
		}
	}
	return rows;
}

function getQueryInputFields(form, actionValue) {
	var fieldArray = new Array();
	if (form != null) {
		debug("action: " + actionValue);
		putInputValueIntoArray(fieldArray, 'IsAjaxInvoked', 'YES');
//		fieldArray['IsAjaxInvoked']='YES';
		// Add the list of form names so we can tell when we're all done with
		// AJAX request in the form renderer.
		putInputValueIntoArray(fieldArray, 'AjaxForms', getFormsList());		
//		fieldArray['AjaxForms']=getFormsList();

		fieldList = form.getElementsByTagName("input");
		if (fieldList.length != 0) {
			for ( var i = 0; i < fieldList.length; i++) {
				var fieldName = fieldList.item(i).getAttribute("name");
				var fieldType = fieldList.item(i).getAttribute("type");
								
				// Only process input tags with a NAME attr.
				if ((fieldName != null) && (fieldName != "")) {
					if ((fieldType == "text") || (fieldType == "hidden")
							|| (fieldType == "password")) {
						debugInfo("queryInputFields: input fieldName is '"
								+ fieldName + "'  value is '"
								+ fieldList.item(i).value + "'  encodeURI: '"
								+ encodeURI(fieldList.item(i).value) + "'");
						putInputValueIntoArray(fieldArray, fieldName, fieldList.item(i).value);		
//						fieldArray[fieldName]=fieldList.item(i).value;
					} else if (((fieldType == "CheckBox") || (fieldType == "checkbox")|| (fieldType == "radio")|| (fieldType == "RADIO"))
							&& (fieldList.item(i).checked)) {
						//console.debug("queryInputFields: input fieldName is '"
						//		+ fieldName + "'  value is '"
						//		+ fieldList.item(i).value + "'  encodeURI: '"
						//		+ encodeURI(fieldList.item(i).value) + "'");
						putInputValueIntoArray(fieldArray, fieldName, fieldList.item(i).value);		
//						fieldArray[fieldName]=fieldList.item(i).value;
					} else if ((actionValue != null) && (actionValue != "")
							&& (fieldName == actionValue)) {
						if ((fieldType == "submit") || (fieldType == "reset")) {
							putInputValueIntoArray(fieldArray, fieldName, fieldList.item(i).value);		
//							fieldArray[fieldName]=fieldList.item(i).value;
						} else if (fieldType == "image") {
							putInputValueIntoArray(fieldArray, fieldName+ ".x", "1");		
//							fieldArray[fieldName + ".x"]="1";
							putInputValueIntoArray(fieldArray, fieldName+ ".y", "1");		
//							fieldArray[fieldName + ".y"]="1";
						}
					}
				}
			}
		}

		var selectList = form.getElementsByTagName("select");
		if (selectList.length != 0) {
			for ( var i = 0; i < selectList.length; i++) {
				var sel = selectList.item(i);
				for ( var j = 0; j < sel.length; j++) {
					if (sel.options[j].selected == true) {
						debugInfo("queryInputFields: select name is '"
								+ sel.name + "'  value is '"
								+ sel.options[j].value + "'  encodeURI: '"
								+ encodeURI(sel.options[j].value) + "'");
						putInputValueIntoArray(fieldArray, sel.name, sel.options[j].value);		
//						fieldArray[sel.name]=sel.options[j].value;
					}
				}
			}
		}

		var textAreaList = form.getElementsByTagName("textarea");
		if (textAreaList.length != 0) {
			for ( var i = 0; i < textAreaList.length; i++) {
				var textArea = textAreaList.item(i);
				if (textArea.name != null && textArea.name != "") {
					debugInfo("queryInputFields: textarea name is '"
							+ textArea.name + "'  value is '" + textArea.value
							+ "'  encodeURI: '" + encodeURI(textArea.value)
							+ "'");
					putInputValueIntoArray(fieldArray, textArea.name, textArea.value);		
//					fieldArray[textArea.name]=textArea.value;
				}
			}
		}
		putInputValueIntoArray(fieldArray, "btimestamp", new Date().getTime());		
//		fieldArray["btimestamp"]=new Date().getTime();
	}
	return fieldArray;
}

function convertInputFieldsArrayToString(fieldArray){
	var fieldString = "";
	for (var i in fieldArray)
	{
		for(var j in fieldArray[i]){
	  		fieldString+=i+"="+encodeURI(fieldArray[i][j])+"&";
	  	}
	}
	fieldString=fieldString.substring(0,fieldString.length-1);
	return fieldString;
}

function getQueryInputFieldsSingleUpdate(form, actionValue, action){
	var fieldArray = new Array();
	if (form != null) {
		debug("action: " + actionValue);
		putInputValueIntoArray(fieldArray, 'IsAjaxInvoked', 'YES');
//		fieldArray['IsAjaxInvoked']='YES';
		putInputValueIntoArray(fieldArray, 'IsAjaxUpdate', 'TRUE');
//		fieldArray['IsAjaxUpdate']='TRUE';
		putInputValueIntoArray(fieldArray, 'menuId', action);
//		fieldArray['menuId']=action;
		
		// Add the list of form names so we can tell when we're all done with
		// AJAX request in the form renderer.
		putInputValueIntoArray(fieldArray, 'AjaxForms', getFormsList());
//		fieldArray['AjaxForms']=getFormsList();

		fieldList = form.getElementsByTagName("input");
		if (fieldList.length != 0) {
			for ( var i = 0; i < fieldList.length; i++) {
				var fieldName = fieldList.item(i).getAttribute("name");
				var fieldType = fieldList.item(i).getAttribute("type");
				// Only process input tags with a NAME attr.
				if ((fieldName != null) && (fieldName != "")) {
					if ((fieldType == "text") || (fieldType == "hidden")
							|| (fieldType == "password")) {
						debugInfo("queryInputFieldsSingleUpdate: input fieldName is '"
								+ fieldName
								+ "'  value is '"
								+ fieldList.item(i).value
								+ "'  encodeURI: '"
								+ encodeURI(fieldList.item(i).value) + "'");
						putInputValueIntoArray(fieldArray, fieldName, fieldList.item(i).value);
//						fieldArray[fieldName]=fieldList.item(i).value;
					} else if (((fieldType == "checkbox") || (fieldType == "radio"))
							&& (fieldList.item(i).checked)) {
						debugInfo("queryInputFieldsSingleUpdate: input fieldName is '"
								+ fieldName
								+ "'  value is '"
								+ fieldList.item(i).value
								+ "'  encodeURI: '"
								+ encodeURI(fieldList.item(i).value) + "'");
						putInputValueIntoArray(fieldArray, fieldName, fieldList.item(i).value);
//						fieldArray[fieldName]=fieldList.item(i).value;
					} else if ((actionValue != null) && (actionValue != "")
							&& (fieldName == actionValue)) {
						if ((fieldType == "submit") || (fieldType == "reset")) {
							putInputValueIntoArray(fieldArray, fieldName, fieldList.item(i).value);
//							fieldArray[fieldName]=fieldList.item(i).value;
						} else if (fieldType == "image") {
							putInputValueIntoArray(fieldArray, fieldName+ ".x", "1");
//							fieldArray[fieldName+ ".x"]="1";
							putInputValueIntoArray(fieldArray, fieldName+ ".y", "1");
//							fieldArray[fieldName+ ".y"]="1";
						}
					}
				}
			}
		}

		var selectList = form.getElementsByTagName("select");
		if (selectList.length != 0) {
			for ( var i = 0; i < selectList.length; i++) {
				var sel = selectList.item(i);
				for ( var j = 0; j < sel.length; j++) {
					if (sel.options[j].selected == true) {
						debugInfo("queryInputFieldsSingleUpdate: select name is '"
								+ sel.name
								+ "'  value is '"
								+ sel.options[j].value
								+ "'  encodeURI: '"
								+ encodeURI(sel.options[j].value) + "'");
						putInputValueIntoArray(fieldArray, sel.name, sel.options[j].value);
//						fieldArray[sel.name]=sel.options[j].value;
					}
				}
			}
		}

		var textAreaList = form.getElementsByTagName("textarea");
		if (textAreaList.length != 0) {
			for ( var i = 0; i < textAreaList.length; i++) {
				var textArea = textAreaList.item(i);
				if (textArea.name != null && textArea.name != "") {
					debugInfo("queryInputFieldsSingleUpdate: textarea name is '"
							+ textArea.name
							+ "'  value is '"
							+ textArea.value
							+ "'  encodeURI: '"
							+ encodeURI(textArea.value)
							+ "'");
					putInputValueIntoArray(fieldArray, textArea.name, textArea.value);
//					fieldArray[textArea.name]=textArea.value;
				}
			}
		}
		putInputValueIntoArray(fieldArray, "btimestamp", new Date().getTime());
//		fieldArray["btimestamp"]=new Date().getTime();
	}
	return fieldArray;	
}

function getResponseHeadElement(responseText, tempContent) {
	var result = null;
	var upperResponse = responseText.toUpperCase();
	var docBody = document.body;
	var divs = docBody.getElementsByTagName("DIV");
	
	var tableContIdArr = new Array();
	var tablePresent= false;
	var iscHeadPresent = true;
	for(var i=0 ;i< divs.length; i++){
		if((divs[i].getAttribute("id")) && (divs[i].getAttribute("id").indexOf("TB_") != -1) ){
			tableContIdArr[i] = divs[i].getAttribute("id");
			tablePresent = true;
			
		}
	}
	
	var upperResponse = responseText.toUpperCase();
		var headStartIndex = upperResponse.indexOf("<HEAD>");
		var headEndIndex = upperResponse.indexOf("</HEAD>");
		
	var tempResponse = responseText.toUpperCase();
	var temp = tempResponse.substr(headEndIndex+ "<HEAD>".length);
	
	if(temp.indexOf("<HEAD>") == -1){
		//only one head element not a isc response its wcl ajax update so no need to search for correct head...
		iscHeadPresent = false;
	}
	
	if(tablePresent && iscHeadPresent){
		
		result = findCorrectHead(tableContIdArr, responseText);
		//console.debug("result: "+ result.innerHTML);
		
	}else if(!iscHeadPresent){
		//only one head element present - wcl ajax update... 
		//var upperResponse = responseText.toUpperCase();
		//var headStartIndex = upperResponse.indexOf("<HEAD>");
		//var headEndIndex = upperResponse.indexOf("</HEAD>");
		if (headStartIndex != -1 && headEndIndex != -1) {
			var headElement = document.createElement('div');
			headElement.innerHTML = '<BODY>' + responseText.substring(
					headStartIndex + "<HEAD>".length, headEndIndex) + '</BODY>';
			result = headElement;
		}
		headStartIndex = upperResponse.indexOf("<HEAD>", headEndIndex);
		while (headStartIndex != -1) {
			var styleStartIndex = upperResponse.indexOf("<STYLE", headStartIndex);
			var cssStartIndex = upperResponse.indexOf(">", styleStartIndex);
			var cssEndIndex = upperResponse.indexOf("</STYLE>", cssStartIndex);
			if (cssStartIndex != -1 && cssEndIndex != -1) {
				var cssCode = responseText.substring(cssStartIndex+1, cssEndIndex);  //@wcl team -changed offset back to 1.
				addCss(cssCode);
			}
			headEndIndex = upperResponse.indexOf("</HEAD>", headStartIndex);
			headStartIndex = upperResponse.indexOf("<HEAD>", headEndIndex);
		}
	}
	return result;
}

function addCss(cssCode) {
	var styleElement = document.createElement("style");
	styleElement.type = "text/css";
	if (styleElement.styleSheet) {
		styleElement.styleSheet.cssText = cssCode;
	} else {
	    styleElement.appendChild(document.createTextNode(cssCode));
	}
	document.getElementsByTagName("head")[0].appendChild(styleElement);
}

// TG: takes about 100 ms on average.. some improvements may be needed 
// (ie. parse response only once and reuse DOM fragment with updateAjaxDivs)
function getScriptReferences(response){
	var responseContainer = document.createElement('div');
	responseContainer.innerHTML = response;	// this takes time
	var scriptsContainer = document.createElement('div');
	var scripts = responseContainer.getElementsByTagName('script');
	for(var i=0; i<scripts.length; i++){
		var aScript = scripts[i];
		if(aScript.getAttribute('src') && aScript.getAttribute('wcl_script') && (!aScript.innerHTML || aScript.innerHTML == '')){
			scriptsContainer.appendChild(aScript.cloneNode(true));
		}
	}
	return scriptsContainer;
}

function addScriptsToHead(documentElement) {
	if (documentElement != null) {
		var scriptContent = documentElement.getElementsByTagName('script');
		if (scriptContent != null && scriptContent.length > 0) {
			var documentHead = document.getElementsByTagName('head').item(0);
			var currentScripts = documentHead.getElementsByTagName('script');
			var scriptExists;
			var numberExistingScripts = currentScripts.length;
			for ( var j = 0; j < scriptContent.length; j++) {
				var newScript = scriptContent[j];
				try {
					scriptExists = false;
					for ( var i = 0; i < numberExistingScripts && !scriptExists; i++) {
						var existingScript = currentScripts[i];
						if (((newScript.type && existingScript.type && newScript.type == existingScript.type)
								|| (newScript.lang && existingScript.lang && newScript.lang == existingScript.lang) 
								|| (newScript.language && existingScript.language && newScript.language == existingScript.language))
							&& ((newScript.src && existingScript.src && newScript.src == existingScript.src) 
								|| (newScript.innerHTML	&& existingScript.innerHTML && newScript.innerHTML == existingScript.innerHTML))) {
							scriptExists = true;
							
							// Even though we won't add this script go ahead and run it.
							// This is necessary for frames when the frame reload script (fMgr) is included in the response.
							if (newScript.innerHTML) {
								eval(newScript.innerHTML);
							}
						}
					}

					if (!scriptExists) {
						debug("Adding script(" + j + ") : " + scriptToString(newScript));
						newScript = document.createElement('script');
						if (!WClient.isBrowserInternetExplorer() ){
							//this causes performance issue in IE8
							documentHead.appendChild(newScript);
						}
						
						if (scriptContent[j].type)
							newScript.type = scriptContent[j].type;
						if (scriptContent[j].lang)
							newScript.lang = scriptContent[j].lang;
						if (scriptContent[j].language)
							newScript.language = scriptContent[j].language;
						if (scriptContent[j].src)
							newScript.src = scriptContent[j].src;
						// IE doesn't allow the innerHTML to be set.
						// if (scriptContent[j].innerHTML) newScript.innerHTML =
						// scriptContent[j].innerHTML;
						if (scriptContent[j].innerHTML)
							newScript.text = scriptContent[j].innerHTML;
						// Unfortunately this doesn't work...
						// documentHead.appendChild(scriptContent[j]);
						if (WClient.isBrowserInternetExplorer()) {
						//eval scripts since we cannot append scripts to dochead in IE8
						//work around since correct document head is not retrieved 
						// run all the scripts in the head
						
							if (newScript.innerHTML) {
								eval(newScript.innerHTML);
							}
						}
					}
				} catch (scriptError) {
					debugErr("Error adding script("	+ j	+ ") : " + scriptToString(newScript));
					debugErr("Error name [" + scriptError.name + "] message [" + scriptError.message + "]");
				}
			}
		}
	}
}

function scriptToString(script){
	return "type ["	+ (script.type ? script.type	: "") + "] " 
			+ "lang ["	+ (script.lang ? script.lang : "") + "]"
			+ " language ["	+ (script.language ? script.language : "") + "] "
			+ "src [" + (script.src ? script.src : "") + "] "
			+ "html [" + (script.innerHTML ? script.innerHTML : "") + "]";
}

function addScriptsToDocument(sourceElement, targetElement) {
	addScriptsToDocument(sourceElement, targetElement, false);
}

function addScriptsToDocument(sourceElement, targetElement, onlyAjax) {
	var scriptContent = sourceElement.getElementsByTagName('script');
	if (scriptContent != null && scriptContent.length > 0) {
		var scriptsAdded = new Array();
		var skipped = 0;
		var newScript;
		var numberScripts = scriptContent.length;
		debug("addScriptsToDocument : New scripts [" + scriptContent.length
				+ "]");
		for ( var j = 0; j < numberScripts; j++) {
			if(onlyAjax && scriptContent[j].getAttribute("runOnAjax") == null){
				continue;
			}
			try {
				// If the script is the setupTableAjax script save it for later
				// so it won't flash the page.
				if ((!WClient.isBrowserInternetExplorer())
						|| (!scriptContent[j].innerHTML)
						|| (scriptContent[j].innerHTML
								.indexOf("setupTableAjax") == -1)) {
					var scriptKey = scriptContent[j].src ? scriptContent[j].src
							: scriptContent[j].innerHTML ? scriptContent[j].innerHTML
									: null;
					if (!scriptsAdded[scriptKey]) {
						scriptsAdded[scriptKey] = "true";
						debug("addScriptsToDocument : Adding script("
								+ j
								+ ") : type ["
								+ (scriptContent[j].type ? scriptContent[j].type
										: "")
								+ "] lang ["
								+ (scriptContent[j].lang ? scriptContent[j].lang
										: "")
								+ "] language ["
								+ (scriptContent[j].language ? scriptContent[j].language
										: "")
								+ "] src ["
								+ (scriptContent[j].src ? scriptContent[j].src
										: "")
								+ "] html ["
								+ (scriptContent[j].innerHTML ? scriptContent[j].innerHTML
										: "") + "]");
						newScript = document.createElement('script');
						if (scriptContent[j].type)
							newScript.type = scriptContent[j].type;
						if (scriptContent[j].lang)
							newScript.lang = scriptContent[j].lang;
						if (scriptContent[j].language)
							newScript.language = scriptContent[j].language;
						if (scriptContent[j].src)
							newScript.src = scriptContent[j].src;
						// IE doesn't allow the innerHTML to be set.
						// if (scriptContent[j].innerHTML) newScript.innerHTML =
						// scriptContent[j].innerHTML;
						if (scriptContent[j].innerHTML)
							newScript.text = scriptContent[j].innerHTML;
						// Unfortunately this doesn't work...
						// documentHead.appendChild(scriptContent[j]);
						if (scriptContent[j].innerHTML
								.indexOf("contextMenuShow") == -1) {
							targetElement.appendChild(newScript);
						}
					} else {
						debug("addScriptsToDocument : Skipping script ["
								+ scriptKey + "]");
						skipped++;
					}
				} else {
					debug("addScriptsToDocument : Will add script later ["
							+ scriptContent[j].innerHTML + "]");
					ajaxTables[ajaxTables.length] = scriptContent[j].innerHTML;
				}
				previousScript = scriptContent[j].innerHTML;
			} catch (scriptError) {
				debugErr("Error adding script("
						+ j
						+ ") : type ["
						+ (scriptContent[j].type ? scriptContent[j].type : "")
						+ "] lang ["
						+ (scriptContent[j].lang ? scriptContent[j].lang : "")
						+ "] language ["
						+ (scriptContent[j].language ? scriptContent[j].language
								: "")
						+ "] src ["
						+ (scriptContent[j].src ? scriptContent[j].src : "")
						+ "] html ["
						+ (scriptContent[j].innerHTML ? scriptContent[j].innerHTML
								: "") + "]");
				debugErr("Error name [" + scriptError.name + "] message ["
						+ scriptError.message + "]");
			}
		}
		if (skipped > 0) {
			debug("addScriptsToDocument : skipped [" + skipped + "]");
		}
	}
}

function addSetupTableAjaxScripts() {
	if (WClient.isBrowserInternetExplorer()) {
		debug("addSetupTableAjaxScripts : num scripts [" + ajaxTables.length
				+ "]");
		var extraScriptContainer = document
				.getElementById('WCL_AJAX_TABLE_SCRIPT_CONTAINER');
		if (!extraScriptContainer) {
			// Create a container for the scripts.
			extraScriptContainer = document.createElement('DIV');
			document.body.appendChild(extraScriptContainer);
			extraScriptContainer.setAttribute("id",
					"WCL_AJAX_TABLE_SCRIPT_CONTAINER");
		}
		var addSetupTableAjax = true;
		var existingScripts = extraScriptContainer
				.getElementsByTagName('SCRIPT');
		// Add the current scripts to the container.
		for ( var index = 0; index < ajaxTables.length; ++index) {
			// See if we already have this script.
			if ((existingScripts != null) && (existingScripts.length > 0)) {
				for ( var existingIndex = 0; existingIndex < existingScripts.length; existingIndex++) {
					if (existingScripts[existingIndex].innerHTML == ajaxTables[index]) {
						addSetupTableAjax = false;
						break;
					}
				}
			}

			if (addSetupTableAjax) {
				var newScript = document.createElement('script');
				newScript.type = "text/javascript";
				newScript.text = ajaxTables[index];
				debug("addSetupTableAjaxScripts : Adding [" + ajaxTables[index]
						+ "]");
				extraScriptContainer.appendChild(newScript);
			}
		}
	}
}

function updateAjaxDivs(tempContent, updateForm, updateParams, responseText) {
	var anyDivs = null;
	var doAgain = true;
	var addExtra = true;
	var result = true;

	// If the response indicates the portlet threw an exception, disregard this
	// ajax
	// update and rerender the entire page
	if (tempContent != null
			&& tempContent.innerHTML.length > 0
			&& (tempContent.innerHTML.indexOf("This portlet is unavailable") != -1)) {
		doAgain = false;
		addExtra = false;
		result = false;
		debug("Detected a problem displaying portlet, so redisplaying page without ajax");
		startRefreshRequest(updateForm ,updateParams, 'NO');
	} else if (tempContent != null && tempContent.innerHTML.length > 0
			&& tempContent.innerHTML.indexOf("AJAX_CONTAINER") == -1) {
			
			
		// The response does not contain an ajax container but has size
		// a 302 redirect might have occurred or the user's session has expired
		// just update and render the page returned
		doAgain = false;
		addExtra = false;
		result = true;

		if (!handleLoginPortlet(responseText)) {
			// Update the document with what we got in the response.
			document.body.innerHTML = responseText;

			// Now add any scripts that were in the response because
			// IE removes them when we do innerHTML = responseText.
			addScriptsToDocument(document.body, document.body);

			if (WClient.isBrowserInternetExplorer()) {
				// Since this is a new page let's scroll to the top.
				window.scroll(0, 0);
			}
		}
	}
	while (doAgain == true) {
		anyDivs = tempContent.getElementsByTagName("DIV");
		doAgain = false;
		for ( var i = 0; i < anyDivs.length && doAgain == false; i++) {
			// If we find an AJAX container in the response
			if (anyDivs[i].getAttribute("id") && (anyDivs[i].getAttribute("id").indexOf("AJAX_CONTAINER")!=-1)) {
				// Replace its old contents in the DOM with the new contents
				var newContent = anyDivs[i].firstChild;
				if (newContent != null) {
					var newId = newContent.getAttribute("id");
					debug("Found a container [" + newId + "]");
					var oldContent = document.getElementById(newId);
					if (newId.substring(0, 3) == "CL_") {
						debug("Processing TD [" + newId + "]");
						var oldTd = oldContent.parentNode.parentNode;
						var oldTr = oldTd.parentNode;
						var newTd = newContent.parentNode.parentNode;
						
						//IE8 fix - rows disappears in editable table after changeAllSelected
						if((WClient.isBrowserInternetExplorer()) && (WClient.major == 8)){
							var fragment = document.createDocumentFragment();
							fragment.appendChild(newTd);							
							oldTr.replaceChild(fragment.cloneNode(true), oldTd);
						}else{
						    oldTr.replaceChild(newTd, oldTd);
						}						
						doAgain = true;
					} else if (oldContent != null
							&& newContent.innerHTML != oldContent.innerHTML) {
						debug("Processing container [" + newId + "]");
						var oldContainer = oldContent.parentNode;

						
						// Arg, update the forms here for Firefox so you can't
						// see the updates happen.
						if (WClient.isBrowserMozilla()) {
							inputData.updateInputs(oldContent, newContent);
						}
						
						
						//IE8 - Ajax update doesn't work - fix - STARTS HERE
						
						if((WClient.isBrowserInternetExplorer()) && (WClient.major == 8)){
						
							try {
								while(oldContainer.childNodes.length > 0) {
									oldContainer
											.removeChild(oldContainer.lastChild);
								 }
							} catch (removeError) {
								debugErr("Got an error removing old content ["
										+ removeError.name + "] ["
										+ removeError.message + "]");
							}
							
							debug("Adding child");
							try {
								var fragment = document.createDocumentFragment();
								fragment.appendChild(newContent);
								oldContainer.appendChild(fragment.cloneNode(true));
								// bind forms/anchors with ISC 7.5
								 if( (typeof PortletLink != 'undefined') && (typeof PortletLink.hookAnchors != 'undefined') ) {
									PortletLink.hookAnchors(newContent);
									PortletLink.hookForms(newContent);
								 }
							} catch (addError) {
								debugErr("Got an error adding new content: "
										+ addError.toString());
							}
						}
						else {
								debug("Adding child");
							try {
								oldContainer.appendChild(newContent);
								// bind forms/anchors with ISC 7.5
								 if( (typeof PortletLink != 'undefined') && (typeof PortletLink.hookAnchors != 'undefined') ) {
									PortletLink.hookAnchors(newContent);
									PortletLink.hookForms(newContent);
								 }
							} catch (addError) {
								debugErr("Got an error adding new content: "
										+ addError.toString());
							}
	
							debug("Removing child");
							try {
								// Remove the old content and any scripts we added.
								while (oldContainer.childNodes.length > 1) {
									oldContainer
											.removeChild(oldContainer.childNodes[0]);
								}
							} catch (removeError) {
								debugErr("Got an error removing old content ["
										+ removeError.name + "] ["
										+ removeError.message + "]");
							}
							
						
						}
						//IE8 - Ajax update doesn't work - fix - ENDS HERE
						
						// Arg, update the forms here for IE so that the
							// checkbox update will work.
							// The checkboxes need to be in the document so that we
							// can set checked.
							if (WClient.isBrowserInternetExplorer()) {
								inputData.updateInputs(oldContent, newContent);
							}
	
						
						// mark scripts as runOnAjax, so we'll know they're new and only them need to be executed
						markScriptsFromAjax(newContent);

						// Now add any scripts that were in the response because
						// IE removes them when we do innerHTML = responseText.
						if (WClient.isBrowserInternetExplorer()) {						
						addScriptsToDocument(newContent, oldContainer);
						}

						// Redo this processing as we could have nested AJAX
						// content
						doAgain = true;
					} else if ((oldContent == null)
							&& (newId.substring(0, 3) == "PG_")) {
						// The response does contain an ajax container but is
						// not the same
						// container the request as originated from. The request
						// might have
						// generated a new page or a 302 redirect might have
						// occurred or the
						// user's session has expired just update and render the
						// page returned
						debug("Response contains new content so display the new page");
						doAgain = false;
						addExtra = false;
						
						//[#98178] Problem trapping Enter Key fix, changed result to false, since running scripts when new page is loaded is causing 
						//script errors
						result = false;

						// Update the document with what we got in the response.
						//[#98178] Problem trapping Enter Key fix, commented, since directly setting response to document when new page is loaded
						//causes ISC error adding some junk task bar code at the bottom of the page.. 
						//need to follow up with ISC team....
						//since page and form is reloaded doesn't require ajax updates ....
						
						//document.body.innerHTML = responseText;

						// Now add any scripts that were in the response because
						// IE removes them when we do innerHTML = response.
						addScriptsToDocument(document.body, document.body);

						if (WClient.isBrowserInternetExplorer()) {
							// Since this is a new page let's scroll to the top.
							window.scroll(0, 0);
						}

						break;
					}
				}
			}
		}
		//replace formtags present in the document to remove isc_form_bound attribute and then invoke form binding
		//this is a work around till ISC fixes the defect TSM1141 
		//work around starts here
			var forms = tempContent.getElementsByTagName("FORM");
		
			for(var j=0;j<forms.length; j++){
				
				var formAjax = forms[j];
				
				if( formAjax.getAttribute("AJAX_ACTION") ){
					var oldFormElem = document.getElementById(formAjax.id);
					replaceFormTags(oldFormElem,formAjax);
					
					try {
						
						// bind forms/anchors with ISC 7.5
						 if( (typeof PortletLink != 'undefined') && (typeof PortletLink.hookAnchors != 'undefined') ) {
							PortletLink.hookAnchors(tempContent.innerHTML);
							PortletLink.hookForms(tempContent.innerHTML);
						 }
						} catch (addError) {
							debugErr("Got an error adding new content: "
										+ addError.toString());
						}
				}
			}
		
		
		
		//replace formtags present in the document to remove isc_form_bound attribute and then invoke form binding
		//this is a work around till ISC fixes the defect TSM1141 
		//work around ends here
	}
	if (addExtra) {
		// Add any scripts that were outside of any AJAX containers.
		var extraScripts = tempContent.getElementsByTagName('script');
		if (extraScripts != null && extraScripts.length > 0) {
			debug("Adding extra scripts that were not in an AJAX container");
			// Remove the container that holds the scripts so we can start over.
			var extraScriptContainer = document
					.getElementById('WCL_AJAX_SCRIPT_CONTAINER');
			if (extraScriptContainer) {
				extraScriptContainer.parentNode
						.removeChild(extraScriptContainer);
			}
			// Create the container to hold the scripts.
			extraScriptContainer = document.createElement('div');
			document.body.appendChild(extraScriptContainer);
			extraScriptContainer
					.setAttribute("id", "WCL_AJAX_SCRIPT_CONTAINER");
			// Now add the scripts to this container (in FF add only with runOnAjax attributes).
			addScriptsToDocument(tempContent, extraScriptContainer, true);
		}
	}
	return result;
}

//replace formtags present in the document to remove isc_form_bound attribute and then invoke form binding
		//this is a work around till ISC fixes the defect TSM1141 
function replaceFormTags(oldElement, newElement){
		
		if(oldElement.getAttribute("AJAX_ACTION") && newElement.getAttribute("AJAX_ACTION")){
			//replace formtag if it has an attribute AJAX_ACTION
			if(oldElement.id && newElement.id){
				oldElement.id = newElement.id;
			}
			
			if(newElement.getAttribute("class") ){
				oldElement.setAttribute("class",newElement.getAttribute("class") );
			}
			
			if(oldElement.action  && newElement.action){
				oldElement.action  = newElement.action ;
			}
			
			if(oldElement.method  && newElement.method ){
				oldElement.method  = newElement.method ;
			}
			
			if(oldElement.name  && newElement.name ){
				oldElement.name  = newElement.name ;
			}
			
			if(newElement.getAttribute("style")  ){
				oldElement.setAttribute("style", newElement.getAttribute("style") ); ;
			}
			
			
			// remove/replace any other attributes 
			if(newElement.getAttribute("dir") ){
				oldElement.setAttribute("dir",newElement.getAttribute("dir"))  ;
			}
			
			if(newElement.getAttribute("submitflag") ){
				oldElement.setAttribute("submitflag",newElement.getAttribute("submitflag"))  ;
			}
			
			if(newElement.getAttribute("ajax_action") ){
				oldElement.setAttribute("ajax_action",newElement.getAttribute("ajax_action"))  ;
			}
			
			if(oldElement.getAttribute("isc_form_bound")){
				oldElement.removeAttribute("isc_form_bound")  ;
			}
			
			
			//remove onsubmit for form tag which ISC adds to support satate maintained functionality before invoking form bind again
			//since whole form is not reloaded old value set by ISC will be present so set this to null...
			
			if(oldElement.onsubmit){
				//console.debug("has onsubmit remove it");
				oldElement.onsubmit = null;
			}
			
		}
	
	}

function markScriptsFromAjax(sourceElement){
	scripts = sourceElement.getElementsByTagName('script');
	for(var i=0; i< scripts.length; i++){
		scripts[i].setAttribute("runOnAjax", "TRUE");
	}
}

function handleRequestErrorDojo(response, ioArgs) {
	var reterr = document.getElementById('RETRIEVAL_ERR');
	if (!WClient.isBrowserMozilla()) {
		if (reterr) {
			reterr.style.visibility = 'visible';
			reterr.style.height = document.body.scrollHeight > document.body.clientHeight ? document.body.scrollHeight : document.body.clientHeight;	
			reterr.style.width = document.body.scrollWidth > document.body.clientWidth ? document.body.scrollWidth : document.body.clientWidth;	
			reterr.style.left = "0px";
			reterr.style.zoom = 1;
		}
   } else {
   		if (reterr) {
			reterr.style.visibility = 'visible';
			reterr.style.height = document.body.scrollHeight;	
			reterr.style.width = document.body.scrollWidth;	
			reterr.style.left = "0px";
   		}
   }
	document.getElementById('RETRIEVAL_ERR_IMG').style.visibility = 'visible';
	window.document.body.style.cursor = "auto";
	debug("WCL/DoJo Request Error - HTTP status code: ", ioArgs.xhr.status);
	isAJAXOutstanding=false;
	return response;
}

var END_OF_INPUT = -1;

var base64Chars = new Array(
    'A','B','C','D','E','F','G','H',
    'I','J','K','L','M','N','O','P',
    'Q','R','S','T','U','V','W','X',
    'Y','Z','a','b','c','d','e','f',
    'g','h','i','j','k','l','m','n',
    'o','p','q','r','s','t','u','v',
    'w','x','y','z','0','1','2','3',
    '4','5','6','7','8','9','+','/'
);
//***************************************************************
var reverseBase64Chars = new Array();
for (var i=0; i < base64Chars.length; i++){
    reverseBase64Chars[base64Chars[i]] = i;
}
var base64Str;
var base64Count;

function setBase64Str(str){
    base64Str = str;
    base64Count = 0;
}

function readReverseBase64(){   
    if (!base64Str) return END_OF_INPUT;
    while (true){      
        if (base64Count >= base64Str.length) return END_OF_INPUT;
        var nextCharacter = base64Str.charAt(base64Count);
        base64Count++;
        if (reverseBase64Chars[nextCharacter]){
            return reverseBase64Chars[nextCharacter];
        }
        if (nextCharacter == 'A') return 0;
    }
    return END_OF_INPUT;
}

function ntos(n){
    n=n.toString(16);
    if (n.length == 1) n="0"+n;
    n="%"+n;
    return unescape(n);
}

function decodeBase64(str){
    setBase64Str(str);
    var result = "";
    var inBuffer = new Array(4);
    var done = false;
    while (!done && (inBuffer[0] = readReverseBase64()) != END_OF_INPUT
        && (inBuffer[1] = readReverseBase64()) != END_OF_INPUT){
        inBuffer[2] = readReverseBase64();
        inBuffer[3] = readReverseBase64();
        result += ntos((((inBuffer[0] << 2) & 0xff)| inBuffer[1] >> 4));
        if (inBuffer[2] != END_OF_INPUT){
            result +=  ntos((((inBuffer[1] << 4) & 0xff)| inBuffer[2] >> 2));
            if (inBuffer[3] != END_OF_INPUT){
                result +=  ntos((((inBuffer[2] << 6)  & 0xff) | inBuffer[3]));
            } else {
                done = true;
            }
        } else {
            done = true;
        }
    }
    return result;
}
//***************************************************************************

function webBrowserLookUp(data) {
	//navigator.appName == "Netscape"
	if(navigator.appName.indexOf("Netscape") == -1) {
		writeFileIE(data);	
	}else {
		writeFileNS(data);
		
		//writeFileNSTest();
	}
}

function handleExportData(response, ioArgs) {
	
	var exportedData = getExportedData(response);
	exportedData = decodeBase64(exportedData);	
		
	webBrowserLookUp(exportedData);
	
	return response;
}

function getExportedData(response) {
	
	var tempContent = document.createElement("div");
        tempContent.setAttribute("id","ServerDataResponse");
        debug("Reading in response");
        tempContent.innerHTML = response;
		
	var divs = tempContent.getElementsByTagName('div');
	var doAgain = true;
    var div = null;
    for (var i = 0; i < divs.length && doAgain == true; i++) {
       if (divs[i].getAttribute("id") == "EXPORTED_DATA") {
       		div = divs[i];
       		doAgain = false;
       	} 
    }
        
    return div.innerHTML;
}

function writeFileIE(str) {
	SaveFrame.document.write( str );
	SaveFrame.document.execCommand('SaveAs',null,'test.csv');
}

function writeFileNS(str) {

	var priv1 = "UniversalXPConnect";
	var priv2 = "UniversalFileRead";
	var privilegeGranted = true;
	var runtimeError = '';

	try {
		netscape.security.PrivilegeManager.enablePrivilege (priv1);
		netscape.security.PrivilegeManager.enablePrivilege (priv2);
	}
	catch(e) {
		alert(e);
		privilegeGranted = false;
		runtimeError = "Extended privileges are not granted by user";
	}
	finally {

	}

	if (privilegeGranted) {
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes['@mozilla.org/filepicker;1'].createInstance(nsIFilePicker);
		fp.init(window, 'Save File As...', nsIFilePicker.modeSave);
		fp.defaultString = "test.csv";
		fp.appendFilters(fp.filterAll); 


		var res = fp.show();
		if ( res == nsIFilePicker.returnOK )
	  	{
    		var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
        	                .createInstance(Components.interfaces.nsIFileOutputStream);
			    outputStream.init( fp.file, 0x04 | 0x08,777, 0 );
    		var result = outputStream.write( str, str.length );
    			outputStream.close();
	  	} 
	}
}

function handleStateChange(response, ioArgs) {
	try {
		var startTime = new Date();

		// Reset the ajax tables list.
		ajaxTables = new Array();

		// Save the refresh form.
		var previousForm = refreshForm;
		var previousParams = refreshParams;

		// window.status = "";
		var tempContent = document.createElement("div");
		tempContent.setAttribute("id", "ServerResponse");

		// Get references to WCL scripts from response
		var responseScriptReferences = getScriptReferences(response);
		addScriptsToHead(responseScriptReferences);
		
		
		debug("Reading in response");
		tempContent.innerHTML = response;
		
		// debugHtml(tempContent.innerHTML);
		debug("Done reading in response");

		// Mark any input components as ok to update.
		inputData.markInputs(tempContent);
		
		// Now let's look in the response from the server
		if (updateAjaxDivs(tempContent, previousForm, previousParams, response)) {
			addSetupTableAjaxScripts();
			callRunScripts();
			removeAnchorsForNB();
		}
		// add scripts to head after whole doc ajax update is complete since dojo tries to invoke addOnload before doc update is complete..
		
		var responseHead = getResponseHeadElement(response);
		addScriptsToHead(responseHead);
			
		isAJAXOutstanding = false;
		debug("handleStateChange : time to process AJAX request ["
				+ (new Date().getTime() - startTime.getTime()) + "]");
	} catch (err) {
		debug("Got an error [" + err.name + "] [" + err.message + "]");
		debug(err.toString());
	}
	addAnchorsForNB();
	window.document.body.style.cursor = "auto";
	return response;
}

function handleRefreshStateChange(response, ioArgs) {
			try {

				debug("handleRefreshStateChange");
				// window.status = "";

				// Reset the ajax tables list.
				ajaxTables = new Array();

				// debugHtml(response);

				// Get scripts from the response HEAD and put them in the doc
				// HEAD.
				var responseHead = getResponseHeadElement(response);
				addScriptsToHead(responseHead);

				if (!handleLoginPortlet(response)) {
					// Update the document with what we got in the response.
					document.body.innerHTML = response;

					// Now add any scripts that were in the response because
					// IE removes them when we do innerHTML = response.
					addScriptsToDocument(document.body, document.body);

					addSetupTableAjaxScripts();
					callRunScripts();
					removeAnchorsForNB();

					if (WClient.isBrowserInternetExplorer()) {
						// Since this is a new page let's scroll to the top.
						window.scroll(0, 0);
					}
				}

				isAJAXOutstanding = false;
			} catch (err) {
				debugErr("Got an error refreshing [" + err.name + "] ["
						+ err.message + "]");
			}
			addAnchorsForNB();
			window.document.body.style.cursor = "auto";
}

function handleLoginPortlet(responseString) {
	var result = false;
	// The portlet login JSP spits out invalid HTML. Firefox won't display
	// invalid HTML when you set document.body.innerHTML. Let's see if this
	// is the login portlet and if it is then let's minimize and then maximize
	// it so FF will redraw it correctly.
	if (WClient.isBrowserMozilla()) {
		var indexJsp = responseString.indexOf("LoginView.jsp");
		var indexForm = responseString.indexOf("name=\"LoginForm\"");
		var indexUser = responseString
				.indexOf("id=\"userID\" name=\"wps.portlets.userid\"");
		if ((indexJsp != -1) && (indexForm != -1) && (indexUser != -1)) {
			result = true;
			try {
				debug("handleLoginPortlet : refreshing login portlet...");
				// Minimize the login portlet.
				var minimize = responseString
						.substring(0, indexForm)
						.lastIndexOf(
								"src='/wps/themes/html/title_alt_minimize.gif'");
				var hrefStart = responseString.substring(0, minimize)
						.lastIndexOf("href='")
						+ "href='".length;
				var hrefEnd = responseString.substring(hrefStart).indexOf("'")
						+ hrefStart;
				var minHref = responseString.substring(hrefStart, hrefEnd);
				var wcldojo = WUtilities.getDojoNamespace();
					wcldojo.xhrPost( {
						// The following URL must match that used to test the server.
						url : minHref,
						handleAs :"text",
						timeout : requestTimeout, // Time in milliseconds
					
						// The LOAD function will be called on a successful response.
						load :restoreLoginPortlet,
					
						// The ERROR function will be called in an error case.
						error :handleRequestErrorDojo
					});	
			} catch (err) {
				debugErr("Got an error refreshing login portlet [" + err.name
						+ "] [" + err.message + "]");
				window.location = null;
			}
		}
	}
	return result;
}

function restoreLoginPortlet(response, ioArgs) {
			try {
				debug("handleLoginRestore");
				// debugHtml(response);
				var restore = response.indexOf("title_alt_restore.gif");
				var hrefStart = response.substring(0,
						restore).lastIndexOf("href='")
						+ "href='".length;
				var hrefEnd = response.substring(hrefStart)
						.indexOf("'")
						+ hrefStart;
				var restoreHref = response.substring(
						hrefStart, hrefEnd);
				debug("restoreLoginPortlet : restore href [" + restoreHref
						+ "]");
				window.location = restoreHref;
			} catch (err) {
				debugErr("Got an error restoring login portlet [" + err.name
						+ "] [" + err.message + "]");
				window.location = null;
			}
}

function callRunScripts() {
	// Javascript files that get added to the document do not get loaded
	// in IE until the page is loaded. This means that during the
	// addScriptsToDocument function if a js file is added and then a
	// function is called from that file it will not run (popup menus
	// call contextMenuSetIcons in context_ie.js). Let's add an image to
	// the end of the document so that when it's finished loading we can
	// run all the scripts again so that they are run successfully.
	if (document.images.length > 0) {
	    //#145460-WPopapMenu component with AJAX ON problem in FF3.6
	    //check if buildMenu function is undefined, add some delay
		var addTimeout = 0;
		var anyScripts = document.getElementsByTagName('script');		
		if (anyScripts.length > 0) {	
			for ( var j = 0; j < anyScripts.length; j++) {		    
					if ((anyScripts[j].innerHTML)
							&& (anyScripts[j].getAttribute("runOnAjax") == "TRUE")
							&& (anyScripts[j].innerHTML.indexOf("function buildMenu") == -1)) {
							if (anyScripts[j].innerHTML.indexOf("//buildMenu_") != -1) {														
								var index = anyScripts[j].innerHTML.indexOf("(");
								var funcName = anyScripts[j].innerHTML.substring(2, index);								
								if (eval('typeof ' + funcName) == 'undefined') {								    
								    addTimeout = 300;
								}
							}	
					}		
			}	
		}		
		setTimeout("addImage()", addTimeout);
	} else {
		setTimeout("runScripts()", 3000);
	}
}

function addImage(){
   var refreshImage = document.createElement('img');
		refreshImage.onload = runScripts;
		refreshImage.src = document.images[document.images.length - 1].src;
		refreshImage.width = '0';
		refreshImage.height = '0';
		document.body.appendChild(refreshImage);
}

function runScripts() {
	// Ok - if any scripts are included in the response run them.
	if (!document)
		return;
	var anyScripts = document.getElementsByTagName('script');
	debug("runScripts : scripts [" + anyScripts.length + "]");
	var previousScript = null;
	var skipped = 0;
	var startTime = new Date();
	if (anyScripts.length > 0) {
		for ( var j = 0; j < anyScripts.length; j++) {
			try {
				// We don't need to eval the context menu buildMenu functions.
				// The setupTableAjax scripts are run during updateAjaxDivs.
				if ((anyScripts[j].innerHTML)
						&& (anyScripts[j].getAttribute("runOnAjax") == "TRUE")
						&& (anyScripts[j].innerHTML
								.indexOf("function buildMenu") == -1)) {
					if (previousScript == null
							|| anyScripts[j].innerHTML != previousScript) {
						debugHtml(anyScripts[j].innerHTML);
						if (anyScripts[j].innerHTML.indexOf("//buildMenu_") != -1) {
							anyScripts[j].innerHTML = anyScripts[j].innerHTML
									.substring(2,
											anyScripts[j].innerHTML.length);
							var index = anyScripts[j].innerHTML.indexOf("(");
							var funcName = anyScripts[j].innerHTML.substring(0, index);					
							if (eval('typeof ' + funcName) != 'undefined') {							   
							    eval(anyScripts[j].innerHTML);
							}
						} else {
							eval(anyScripts[j].innerHTML);
						}
					} else {
						skipped++;
					}
					anyScripts[j].removeAttribute("runOnAjax");
					previousScript = anyScripts[j].innerHTML;
				}
				// if it was script showing popup clear script
				if (anyScripts[j].innerHTML.indexOf("contextMenuShow") != -1) {
					anyScripts[j].text = "";
				}
			} catch (runError) {
				debugErr("Got an error running script [" + runError.name
						+ "] [" + runError.message + "]");
			}
		}
		if (skipped > 0) {
			debug("runScripts : skipped [" + skipped + "]");
		}
	}
	debug("runScripts : time to run scripts ["
			+ (new Date().getTime() - startTime.getTime()) + "]");
	setTimeout("runOnloads();", 0);
}

function runOnloads() {
	// Run any images onloads that did not get run.
	var images = document.getElementsByTagName('img');
	var numImages = images.length;
	debug("runOnloads : images [" + numImages + "]");
	var current = null;
	var onloadString = null;
	for ( var x = 0; x < numImages; ++x) {
		if (images[x].onload) {
			onloadString = null;
			current = images[x].onload.toString();
			if (WClient.isBrowserMozilla()) {
				if (current.indexOf('function onload(event)') == 0) {
					onloadString = current.substring(24, (current.length - 2));
				}
			} else {
				if (current.indexOf('function anonymous()') == 0) {
					onloadString = current.substring(23, (current.length - 2));
				}
			}
			debug("runOnloads : onload [" + onloadString + "]");

			// if ((onloadString != null) &&
			// ((onloadString.indexOf('WOverview.') != -1) ||
			// (onloadString.indexOf('WImageViewport.') != -1) ||
			// (onloadString.indexOf('WToggleButton.') != -1))) {
			debug("runOnloads : rerunning onload [" + onloadString + "]");
			eval(onloadString);
			// }
		}
	}
}

function FormsData() {
	var formsData = new Array();
	var inputList = new Array();
	var changeList = new Array();
	var typeList = new Array();

	this.initialize = initialize;
	this.markInputs = markInputs;
	this.updateInputs = updateInputs;
	this.addField = addField;
	this.getField = getField;
	this.reset = reset;
	this.markInput = markInput;

	function initialize() {
		this.reset();

		var fieldList = document.getElementsByTagName("input");
		for ( var i = 0; i < fieldList.length; i++) {
			this.addField(fieldList.item(i), "input");
		}
		var textAreaList = document.getElementsByTagName("textarea");
		for ( var i = 0; i < textAreaList.length; i++) {
			this.addField(textAreaList.item(i), "textarea");
		}
		var selectList = document.getElementsByTagName("select");
		for ( var i = 0; i < selectList.length; i++) {
			this.addField(selectList.item(i), "select");
		}
	}

	function addField(input, type) {
		if ((input != null) && (input.id != null) && (input.id != "")
				&& (input.name != null) && (input.name != "")
				&& ((type != "input") || (input.type != "hidden"))) {
			// See if we already have this input.
			var newInput = this.getField(input);
			if (newInput == null) {
				newInput = new FormField();
				formsData[formsData.length] = newInput;
			}
			newInput.update(input, type);
		}
	}

	function markInputs(docElement) {
		var changeType = 0;
		var fieldList = docElement.getElementsByTagName("input");
		for ( var i = 0; i < fieldList.length; i++) {
			this.markInput(fieldList, i, fieldList.item(i).type);
		}
		var textAreaList = docElement.getElementsByTagName("textarea");
		for ( var i = 0; i < textAreaList.length; i++) {
			this.markInput(textAreaList, i, "textarea");
		}
		var selectList = docElement.getElementsByTagName("select");
		for ( var i = 0; i < selectList.length; i++) {
			this.markInput(selectList, i, "select");
		}
	}

	function markInput(fields, index, type) {
		// 0: ID was not found in saved data.
		// 1: Input was found and was the same.
		// 2: Server value was different from saved.
		var changed = 0;
		var input = fields.item(index);
		// Get the original input of this name.
		var num = formsData.length;
		for ( var i = 0; i < num; ++i) {
			if ((formsData[i].getName() == input.name)
					&& (formsData[i].getType() == type)) {
				if (type == "radio") {
					if (!formsData[i].tested) {
						// Need to check all the radios to see if the server
						// changed anything.
						var match = true;
						var numFields = fields.length;
						var numValues = formsData[i].values.length;
						// debug("markInput : testing radio buttons [" +
						// formsData[i].getName() + "]");
						for ( var x = 0; x < numFields && match; ++x) {
							if (fields[x].type == "radio"
									&& fields[x].name == formsData[i].getName()) {
								match = false;
								for (j = 0; j < numValues && !match; ++j) {
									if ((formsData[i].values[j] == fields[x].value)
											&& (formsData[i].checks[j] == fields[x].checked)
											&& (formsData[i].ids[j] == fields[x].id)) {
										match = true;
										formsData[i].matched[j] = match;
									}
								}
							}
						}
						if (match) {
							// debug("markInput : all radio buttons from
							// response are in original page");
							// See if all the original checks were marked to
							// tell if there were any original
							// that were left out of the server response.
							for (j = 0; j < numValues && match; ++j) {
								if (!formsData[i].matched[j]) {
									// debug("markInput : radio button was not
									// in server response [" +
									// formsData[i].values[j] + "]");
									// Found an entry that was not in the
									// response.
									match = false;
								}
							}
							// Save this info for later so we don't have to do
							// that junk again!
							formsData[i].passed = match;
						}
						formsData[i].tested = true;
					}
					changed = (formsData[i].passed ? 1 : 2);
					// debug("markInput : name [" + input.name + "] type [" +
					// type + "] changed [" + changed + "]");
				} else if ((type == "checkbox")
						&& (input.id == formsData[i].getId())) {
					changed = ((formsData[i].value == input.value && formsData[i].checked == input.checked) ? 1
							: 2);
					// debug("markInput : name [" + input.name + "] type [" +
					// type + "] changed [" + changed + "]");
				} else if ((type == "text" || type == "password" || type == "textarea")
						&& (input.id == formsData[i].getId())) {
					changed = ((formsData[i].value == input.value) ? 1 : 2);
					// debug("markInput : name [" + input.name + "] type [" +
					// type + "] changed [" + changed + "]");
				} else if ((type == "select")
						&& (input.id == formsData[i].getId())) {
					// Make sure all of the options are the same.
					var match = true;
					var numOptions = input.options.length;
					// debug("markInput : name [" + formsData[i].getId() + "]
					// selections [" + numOptions + "]");
					for ( var z = 0; z < numOptions && match; ++z) {
						if ((input.options[z].value != formsData[i].values[z])
								|| (input.options[z].text != formsData[i].selections[z])
								|| (input.options[z].selected != formsData[i].selected[z])) {
							match = false;
						}
					}
					changed = match ? 1 : 2;
					// debug("markInput : name [" + input.name + "] type [" +
					// type + "] changed [" + changed + "]");
				}
				// break;
			}
		}
		if (changed > 0) {
			// debug("markInput : field changed so saving name [" + input.name +
			// "] id [" + input.id + "] type [" + type + "] changed [" + changed
			// + "]");
			inputList[inputList.length] = input;
			changeList[changeList.length] = changed;
			typeList[typeList.length] = type;
		}
	}

	function updateInputs(oldContent, newContent) {
		var num = inputList.length;
		for ( var index = 0; index < num; ++index) {
			try {
				var oldInput = document.getElementById(inputList[index].id);
				// debug("updateInputs : processing input [" +
				// inputList[index].id + "]");
				if ((typeList[index] == "text" || typeList[index] == "password" || typeList[index] == "textarea")
						&& (oldInput.value != inputList[index].value)
						&& (changeList[index] == 1)) {
					// debug("updateInputs : updating [" + inputList[index].id +
					// "] [" + inputList[index].name + "] type [" +
					// typeList[index] + "] text [" + oldInput.value + "]");
					inputList[index].value = oldInput.value;
				} else if ((typeList[index] == "checkbox")
						&& (oldInput.checked != inputList[index].checked)
						&& (changeList[index] == 1)) {
					// debug("updateInputs : updating [" + inputList[index].id +
					// "] [" + inputList[index].name + "] type [" +
					// typeList[index] + "] checked [" + oldInput.checked +
					// "]");
					inputList[index].checked = oldInput.checked;
				} else if ((typeList[index] == "radio")
						&& (oldInput.checked != inputList[index].checked)
						&& (changeList[index] == 1)) {
					// debug("updateInputs : updating [" + inputList[index].id +
					// "] [" + inputList[index].name + "] type [" +
					// typeList[index] + "] checked [" + oldInput.checked +
					// "]");
					inputList[index].checked = oldInputs.checked;
				} else if (typeList[index] == "select") {
					if (changeList[index] == 1) {
						// debug("updateInputs : updating [" +
						// inputList[index].id + "] [" + inputList[index].name +
						// "] type [" + typeList[index] + "] selected [" +
						// oldInput.value + "]");
						for ( var i = 0; i < oldInput.length; ++i) {
							inputList[index].options[i].selected = oldInput.options[i].selected;
						}
					} else if (changeList[index] == 2) {
						// debug("updateInputs : resetting [" +
						// inputList[index].id + "] [" + inputList[index].name +
						// "] type [" + typeList[index] + "]");

//KR - commented code causes reseting selectionBox/comboBox and 
//this causes loss of visible information about changed selections 
//recieved from the server
//bug:46030
//						if ((inputList[index].type != null)
//								&& (inputList[index].type == "select-multiple")) {
//							inputList[index].selectedIndex = -1;
//						} else {
//							inputList[index].selectedIndex = 0;
//						}
					}
				}
			} catch (inputError) {
				debugErr("Error updating input " + inputList[index].id + " ["
						+ inputError.name + "] message [" + inputError.message
						+ "]");
			}
		}
	}

	function getField(input) {
		var result = null;
		var num = formsData.length;
		for ( var i = 0; i < num; ++i) {
			if (formsData[i].equals(input)) {
				result = formsData[i];
				break;
			}
		}
		return result;
	}

	function reset() {
		formsData = new Array();
		inputList = new Array();
		changeList = new Array();
		typeList = new Array();
	}
}

function FormField() {
	var id;
	var type;
	var name;

	this.getId = getId;
	this.getType = getType;
	this.getName = getName;

	this.update = update;
	this.equals = equals;

	function getId() {
		return id;
	}

	function getType() {
		return type;
	}

	function getName() {
		return name;
	}

	function update(input, type) {
		if (type == "input") {
			type = input.type;
		}
		if ((type == "text") || (type == "password") || (type == "textarea")) {
			setData(input.id, type, input.name);
			this.value = input.value;
		} else if (type == "checkbox") {
			setData(input.id, type, input.name);
			this.value = input.value;
			this.checked = input.checked;
		} else if (type == "radio") {
			setData(input.id, type, input.name);
			if (this.values == null) {
				this.values = new Array();
				this.checks = new Array();
				this.matched = new Array();
				this.ids = new Array();
			}
			var numValues = this.values.length;
			this.values[numValues] = input.value;
			this.checks[numValues] = input.checked;
			this.ids[numValues] = input.id;
			this.matched[numValues] = false;
			this.tested = false;
			this.passed = false;
		} else if (type == "select") {
			setData(input.id, type, input.name);
			this.values = new Array();
			this.selections = new Array();
			this.selected = new Array();
			var numSelections = input.options.length;
			for ( var i = 0; i < numSelections; ++i) {
				this.values[i] = input.options[i].value;
				this.selections[i] = input.options[i].text;
				this.selected[i] = input.options[i].selected;
			}
		}
	}

	function setData(fieldId, fieldType, fieldName) {
		id = fieldId;
		type = fieldType;
		name = fieldName;
	}

	function equals(field) {
		var result = false;
		if ((field.type != null) && (field.type == "radio")) {
			// Group radio buttons by name.
			result = (field.name == name);
		} else {
			result = ((field.id == id) && (field.name == name));
		}
		return result;
	}
}

/**
 * Debug functions and variables. 
 * Uses Dojo firebug debugging console.
 */

var debugOn = false;

function debug(msg) {
	if (debugOn == true) {
		console.debug(msg);
	}
}

function debugErr(msg) {
	if (debugOn == true) {
		console.error(msg);
	}
}

function debugInfo(msg) {
	if (debugOn == true) {
		console.info(msg);
	}
}

function debugHtml(msg) {
	if (debugOn == true) {
		console.log(msg);
	}
}

function debugWarn(msg){
	if (debugOn == true){
		console.warn(msg);
	}
}

function getActionString(form){
	var actionString;
	// TG: AJAX in Portlets
	if(form.getAttribute("AJAX_ACTION") != null){		
		actionString = form.getAttribute("AJAX_ACTION");
	}else{
		actionString = form.action;
	}
	return actionString;
}

// @auiml - begin - the following enhancement is need so that auiml can
// support WCL ajax
function addAuimlTransactionSupport(actionString, inputFields){
	var transactionIndex = actionString.indexOf("WnTransaction=");
	if (transactionIndex != -1) {
		debugInfo("found transaction in action");
		// There is a transaction in the action so get the real value from
		// parameters.
		var currentTransaction = null;
		var transIndex = inputFields.indexOf("WnTransaction=");
		if (transIndex != -1) {
			var endTransIndex = inputFields.substring(transIndex).indexOf("&");
			if (endTransIndex != -1) {
				currentTransaction = inputFields.substring(transIndex + 14,
						transIndex + endTransIndex);
			} else {
				currentTransaction = inputFields.substring(transIndex + 14);
			}
		}
		debugInfo("Current transaction [" + currentTransaction + "]");
		if (currentTransaction != null) {
			var endIndex = actionString.substring(transactionIndex)
					.indexOf("&");
			if (endIndex != -1) {
				var endAction = actionString.substring(transactionIndex
						+ endIndex);
				actionString = actionString.substring(0, transactionIndex)
						+ "WnTransaction=" + currentTransaction + endAction;
			} else {
				actionString = actionString.substring(0, transactionIndex)
						+ "WnTransaction=" + currentTransaction;
			}
		}
	} else {
		debugInfo("no transaction in action");
	}	
	return actionString;
}

function getAncestorByNodeName ( element, name ) {
	if( element == null ) {
		return( null );
	}
	else if( element.nodeName.toLowerCase() == name.toLowerCase() ) {
		return( element );
	}
	else {
		return(getAncestorByNodeName( element.parentNode, name ) );
	}
}

function findCorrectHead(tableContainerIdArr, response){
	var upperRes = response.toUpperCase();
	var headStartIndex = upperRes.indexOf("<HEAD>");
	var headEndIndex = upperRes.indexOf("</HEAD>");
	var tempResponse = response.substring(
						headStartIndex + "<HEAD>".length, headEndIndex)
	var upperTempResp = tempResponse.toUpperCase();
	if(headStartIndex != -1){
		var idPresent = false;
		for(var i=0; i<tableContainerIdArr.length;i++){
			if(tableContainerIdArr[i] === undefined ) continue;
			var  tableContainerId = tableContainerIdArr[i].toUpperCase();
			var id = tableContainerId.substring(3);
			//console.debug("tableContainerId: "+id );
			//console.debug("indexof: "+upperTempResp.indexOf(id) );
			if(upperTempResp.indexOf(id) != -1){
				idPresent = true;
				break;
			}
			
		}
		if(idPresent){
			if (headStartIndex != -1 && headEndIndex != -1) {
				var headElement = document.createElement('div');
				headElement.innerHTML = '<BODY>' + response.substring(
						headStartIndex + "<HEAD>".length, headEndIndex) + '</BODY>';
				result = headElement;
				
			}
			
			headStartIndex = upperTempResp.indexOf("<HEAD>", headEndIndex);
			while (headStartIndex != -1) {
				var styleStartIndex = upperTempResp.indexOf("<STYLE", headStartIndex);
				var cssStartIndex = upperTempResp.indexOf(">", styleStartIndex);
				var cssEndIndex = upperTempResp.indexOf("</STYLE>", cssStartIndex);
				if (cssStartIndex != -1 && cssEndIndex != -1) {
					var cssCode = response.substring(cssStartIndex+1, cssEndIndex);  //@wcl team -changed offset back to 1.
					addCss(cssCode);
				}
				
				
					headEndIndex = upperTempResp.indexOf("</HEAD>", headStartIndex);
					headStartIndex = upperTempResp.indexOf("<HEAD>", headEndIndex);
				
				
			}
		}else{
			result = null;
			response = response.substr(headEndIndex+ "<HEAD>".length);
			findCorrectHead(tableContainerIdArr,response);
		}
		
	   
	}
	
	//console.debug("result here: "+ result.innerHTML);
	return result;
}