/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Presentation Services
*
* (C) Copyright IBM Corp. 2007  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} ***
*******************************************************************************/

function ArrayList(){
   this.list = new Array(); //initialize with an empty array
}
/** 
* Returns the number of elements in this list.  
* @type int 
*/      
ArrayList.prototype.size = function(){
   return this.list.length;
}
/**
* Appends the specified element to the end of this list.
* @param {object} object element to be appended to this list.
*/        
ArrayList.prototype.add = function( object ){
   //Object are placed at the end of the array
   return this.list.push( object );
}
/**
* Appends the specified element to the end of this list.
* @param {int} index at which the specified element is to be inserted.
* @param {object} object element to be appended to this list.
*/        
ArrayList.prototype.addAt = function( index , object ){
   var count = this.list.length;
   if ( index > -1 && index <= count ) {
      switch(index)
      {
         case 0:
            this.list.unshift(object);
            break;
         case count:
            this.list.push(object);
            break;
         default:
            var head      = this.list.slice(0, index - 1);
            var tail      = this.list.slice(index);
            this.list    = this.list.concat(tail.unshift(object));
            break;
      }
   }
}

ArrayList.prototype.indexOf = function( object ){
   var count       = this.list.length;
   var ret = - 1;
   var i = 0;
   while( i < count ) {
         if ( this.list[i] == object ){
            ret = i;
            break;
         }
                    
         i++;
      }
            
   return ret;
}




ArrayList.prototype.get = function( index ) //Index must be a number
{
   if( index > -1 && index < this.list.length )
      return this.list[index];
   else
      return undefined; //Out of bound array, return undefined
}
        
ArrayList.prototype.clear = function()
{
   this.list = [];
}

ArrayList.prototype.removeFrom = function ( index ) // index must be a number
{
   var m_count = this.list.length;
            
   if ( m_count > 0 && index > -1 && index < this.list.length ) 
   {
      switch( index )
      {
         case 0:
            this.list.shift();
            break;
         case m_count - 1:
            this.list.pop();
            break;
         default:
            var head   = this.list.slice( 0, index );
            var tail   = this.list.slice( index + 1 );
            this.list = head.concat( tail );
            break;
      }
   }
}
    
ArrayList.prototype.lastIndexOf = function( object )
{
   var count       = this.list.length;
   var returnValue = - 1;
            
 
      var i = count - 1;
                
      while( i >= 0 )
      {
         if ( this.list[i] == object )
         {
            returnValue = i;
            break;
         }
                    
         i--;
      }
  
            
   return returnValue;
}

ArrayList.prototype.push = function(obj){

	this.list.push(obj);
}

ArrayList.prototype.pop = function(){
	return this.list.pop();
}

ArrayList.prototype.shift = function(){
	return this.list.shift();
}
ArrayList.prototype.length = function(){
	return this.list.length;
}

