/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Presentation Services
*
* (C) Copyright IBM Corp. 2007, 2008  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} ***
*******************************************************************************/

// Represents all DragDrop objects on the page
var RegisteredDDs = {
	list : (RegisteredDDs == undefined ? new Array() : RegisteredDDs.list),
	
	getDragDrop : function getDragDrop(id){
		var dragdrop = null;
		for(var i=0; i<this.list.length; ++i){
			if(this.list[i] && this.list[i].divId==id){
				dragdrop = this.list[i];
				break;
			}
		}
		if(dragdrop){
			debugInfo("get DragDrop  " + dragdrop.divId);
		}else{
			debugInfo("no such a DragDrop object");
		}
		return dragdrop;
	},
 
	registerDragDrop : function(obj){
		var dragdrop = this.getDragDrop(obj.divId);
		if(dragdrop){
			var i = indexOfImpl(this.list, dragdrop);
			this.list.splice(i,1,obj);
		}else{
			this.list.push(obj);
		}
		debugInfo("DragDrop registered " + obj.divId);
	}
	
}

// current DragDrop object
var currDragDrop;

DragDrop = function(form ,h1bId, h2bId, dbId, divId, rowsPerView) {
	this.dragObject = null;
    this.dataClone = null;   
    this.columnIds = null; 
    this.headerId = null;
    this.dataId = null;
    this.divId = null;
    this.formName = null;
    this.isChange = null;
    this.rowsPerView = 0;
    this.init(form ,h1bId, h2bId, dbId, divId, rowsPerView);
    
    return this;
}

DragDrop.prototype = {

   init : function(form ,h1bId, h2bId, dbId, divId, rowsPerView)
   {
      // Initialize the columns for this table.
      this.formName = form;
      var headerElement = document.getElementById(h1bId);
      this.headerId = h1bId;
      this.header2Id = h2bId;
      var tableDataBody = document.getElementById(dbId);
      this.dataId = dbId;
      this.divId = divId;
      this.rowsPerView = rowsPerView;
      var columnId = null;
      var numCols = 0;
      this.columnIds = new Array();
      while (headerElement.rows[0].childNodes[numCols].id)
      {
         columnId = headerElement.rows[0].childNodes[numCols].id;       
         this.columnIds[this.columnIds.length] = columnId;
         var head2Id = columnId + "_hidden";
         var h2 = document.getElementById(head2Id);
          if(h2 && WClient.isBrowserMozilla()){       	
          	headerElement.rows[0].childNodes[numCols].style.width = h2.clientWidth;
          }
         headerElement.rows[0].childNodes[numCols].moved = 0;
         this.initColumns(document.getElementById(columnId + "_handle"), headerElement.rows[0].childNodes[numCols], dbId);
         numCols++;
      }
      RegisteredDDs.registerDragDrop(this);
   },
   
   initColumns : function(o, oRoot, dbId)
   {
      o.onmousedown = this.start;

      o.root = oRoot && oRoot != null ? oRoot : o;
      
      if (isNaN(parseInt(o.root.style.left))) o.root.style.left = "0px";
      
      o.root.moved = o.root.offsetLeft;
            
   },
   
   storeCellsSize : function(tbody){
   		if(tbody){
   		for (var i=0;i<tbody.rows.length;++i) {
       		var row = tbody.rows[i];
       		for(var j=0;j<row.cells.length;++j){
       			var cell = row.cells[j];
       			cell.mwidth = cell.clientWidth;
       		}
   		}
   		}
   }, 
   restoreCellsSize : function(tbody){
   		if(tbody){
   		for (var i=0;i<tbody.rows.length;++i) {
       		var row = tbody.rows[i];
       		for(var j=0;j<row.cells.length;++j){
       			var cell = row.cells[j];
       			cell.style.width = cell.mwidth;
       		}
   		}
   		}
   },
   
   fillInputs : function(tbody){
   		if(tbody){
   			var ths = tbody.getElementsByTagName("TH");
   			for(var i=0; i < ths.length; i++){
   				var header = ths[i];
   				if(header.mwidth && header.id) {
   					var input = header.firstChild.rows[0].lastChild.lastChild;
					input.value = header.mwidth;
   				}
   			}
   		}
   },
   
   storeSize : function(){
   		 var headerElement = document.getElementById(this.headerId);
   		 this.storeCellsSize(headerElement);
   		
   		 //var hiddenElement = document.getElementById()
   		 var tableDataBody = document.getElementById(this.dataId);
   		 this.storeCellsSize(tableDataBody);
   }, 
   
   restoreSize : function(){
   		 var headerElement = document.getElementById(this.headerId);
   		 this.restoreCellsSize(headerElement);  
   		 this.fillInputs(headerElement);		 
   		 //var hiddenElement = document.getElementById()
   		 var tableDataBody = document.getElementById(this.dataId);
   		 this.restoreCellsSize(tableDataBody);
   },
   
   start : function(e)
   {
   	  var id = this.root.parentNode.parentNode.parentNode.nextSibling.id;
   	  currDragDrop = RegisteredDDs.getDragDrop(id);
   	  if (currDragDrop.isChange) {
	   	 var form = document.forms[currDragDrop.formName];
	     if(form != null){
	      	startRequest(form, null);
	     }
	     currDragDrop.isChange = false;
	     return;
   	  }
      var o = currDragDrop.dragObject = this;
      currDragDrop.storeSize();
      o.root.moved = o.root.offsetLeft;
      // clone column and move it to the front
      var c = currDragDrop.dataClone = cloneColumn(currDragDrop, o.root,currDragDrop.dataId);

      e = currDragDrop.fixEvent(e);
      
      var x = parseInt(o.root.style.left);
      //o.root.onDragStart(x, y);         

      o.lastMouseX = e.clientX;
      
      // save document's mouse handlers
      document._onselectstart = document.onselectstart;
      document._onmousemove = document.onmousemove;
      document._onmouseup = document.onmouseup;
      // temporarily override document's mouse handlers
      document.onselectstart = new Function("event", "return false;");
          

      document.onmousemove = currDragDrop.drag;
      document.onmouseup   = currDragDrop.end;
 
      return false;
   },

   drag : function(e)
   {     
      e = currDragDrop.fixEvent(e);
      var o = currDragDrop.dragObject;
      var c = currDragDrop.dataClone;

      var mouseX = e.clientX;    
      
      var diffX = mouseX - o.lastMouseX;
      
      var newX = parseInt(c.style.left) + diffX;
         
      var currentOrder = o.root.getAttribute('order'); 
      if (diffX < 0)
      {
         // See if we can move the column to the left.
         if ((currentOrder > 0) || (o.root.moved < newX))
         {
            // Get the left column.
            var leftColumn = document.getElementById(currDragDrop.columnIds[currentOrder - 1]);
            if (leftColumn && ((o.root.moved - newX) > (leftColumn.offsetWidth / 2)))
            {
               // Update the left column attributes.
               var tempOrder = parseInt(leftColumn.getAttribute('order'));
               leftColumn.setAttribute('order',tempOrder+1);
			   //swap columns	
               swapColumns(currDragDrop.headerId, currentOrder, eval(currentOrder)-1);
               //swapColumns(currDragDrop.hiddenId, currentOrder, eval(currentOrder)-1);
               swapColumns(currDragDrop.dataId, currentOrder, eval(currentOrder)-1);
               resizeDivAjax(currDragDrop.divId, o.root);

               // Update the current column.
               tempOrder = parseInt(o.root.getAttribute('order'));
               o.root.setAttribute('order',tempOrder-1);
               //o.root.order--;
               o.root.moved -= leftColumn.offsetWidth;
               // Swap the column IDs in the list.
               currDragDrop.columnIds[currentOrder - 1] = o.root.id;
               currDragDrop.columnIds[currentOrder] = leftColumn.id;
               
            }
         }
         else
         {
            // Don't let the column run off the left side of the table.
            newX = parseInt(c.style.left);
            diffX = 0;        
         }
      }
      else if (diffX > 0)
      {
         // See if we can move the column to the right.
         if ((currentOrder < (currDragDrop.columnIds.length - 1)) || (newX < o.root.moved))
         {        
            // Get the right column.
            var rightColumn = document.getElementById(currDragDrop.columnIds[eval(currentOrder) + 1]);
            if (rightColumn && ((newX - o.root.moved) > (rightColumn.offsetWidth / 2)))
            {           
               // Update the right column attributes.
               //rightColumn.order--;
               var tempOrder = parseInt(rightColumn.getAttribute('order'));
               rightColumn.setAttribute('order',tempOrder-1);
               
                          
               swapColumns(currDragDrop.headerId, currentOrder, eval(currentOrder)+1);
               //swapColumns(currDragDrop.hiddenId, currentOrder, eval(currentOrder)+1);
               swapColumns(currDragDrop.dataId, currentOrder, eval(currentOrder)+1);
               //swapColumns(document.getElementById(dataId), currentOrder, eval(currentOrder)-1);
			   resizeDivAjax(currDragDrop.divId, o.root);	
              
               // Update the current column.
               tempOrder = parseInt(o.root.getAttribute('order'));
               o.root.setAttribute('order',tempOrder+1);
              //o.root.order++;
               o.root.moved += rightColumn.offsetWidth;
               // Swap the column IDs in the list.
               currDragDrop.columnIds[eval(currentOrder) + 1] = o.root.id;
               currDragDrop.columnIds[currentOrder] = rightColumn.id;
                              
            }
         }
         else
         {     
            // Don't let the column run off the right side of the table.
            newX = parseInt(c.style.left);
            diffX = 0;        
         }                       
      }
     // move column clone       
     currDragDrop.dataClone.style.left = newX + "px";
     currDragDrop.dragObject.lastMouseX   = mouseX;

      //DragDrop.dragObject.root.onDrag(newX, newY);
 
      return false;
   }, 
   


   end : function(e)
   {  
     // restore document's mouse handlers
      document.onselectstart = document._onselectstart;
      document.onmousemove = document._onmousemove;
      document.onmouseup = document._onmouseup;
     
	  currDragDrop.dragObject.root.moved = 0;     
    
      currDragDrop.dataClone.parentNode.removeChild(currDragDrop.dataClone);
      currDragDrop.dataClone = null;
      currDragDrop.restoreSize();
      setupTableAjax(currDragDrop.dataId);
      currDragDrop.dragObject = null;
      
      var form = document.forms[currDragDrop.formName];
      if(form != null){
      	startRequest(form, null);
      }
      currDragDrop = null;
      return true;
   },

   fixEvent : function(e)
   {
      if (typeof e == 'undefined') e = window.event;
      if (typeof e.layerX == 'undefined') e.layerX = e.offsetX;
      //if (typeof e.layerY == 'undefined') e.layerY = e.offsetY;
      return e;
   }
};

function swapColumns (tableId, colIndex1, colIndex2) {
  var table = document.getElementById(tableId); 
  if (table && table.rows && table.insertBefore && colIndex1 != colIndex2) {
    colIndex1 = Number(colIndex1);
    colIndex2 = Number(colIndex2);
    if (colIndex1 == colIndex2 - 1 || colIndex1 == colIndex2 + 1) {
      if (colIndex1 > colIndex2) {
        var tempIndex = colIndex1;
        colIndex1 = colIndex2;
        colIndex2 = tempIndex;
      }
      for (var i = 0; i < table.rows.length; i++) {
        var row = table.rows[i];
        row.insertBefore(row.cells[colIndex2], row.cells[colIndex1]);
      }
    }
    else {
      for (var i = 0; i < table.rows.length; i++) {
        var row = table.rows[i];
        var cell1 = row.cells[colIndex1];
        var cell2 = row.cells[colIndex2];
        var siblingCell1 = row.cells[colIndex1 + 1];
        if (typeof siblingCell1 == 'undefined') {
          siblingCell1 = null;
        }
        row.insertBefore(cell1, cell2);
        row.insertBefore(cell2, siblingCell1);
      }
    }
  }
}

function cloneColumn(dragdrop, column, tableId){
	var currentOrder = column.getAttribute('order'); 
	var tableNode =  null;
	var tbodyNode = null;
	if(tableId){
	
	tbodyNode = document.getElementById(tableId); 	
	
	}
	if(tbodyNode == null && column != null){  
    	tbodyNode = column.parentNode.parentNode;
    }
    
    tableNode =  tbodyNode.parentNode; 
    // clone the two nodes TABLE and TBODY into the variables named "cloned*"
    var clonedTableNode = tableNode.cloneNode(false);
    var clonedTbodyNode = tbodyNode.cloneNode(false);
    clonedTableNode.id = clonedTbodyNode.id +"_tclone";
    
    clonedTbodyNode.id = clonedTbodyNode.id +"_clone";
    // append the cloned TBODY to the cloned TABLE
    clonedTableNode.appendChild(clonedTbodyNode);
    if(WClient.isBrowserInternetExplorer()){
    	var newTr = column.parentNode.cloneNode(false);
    	newTr.id = newTr.id +"_clone";
        var oldCell = column;
        var newCell = oldCell.cloneNode(true);
        newCell.style.height = oldCell.offsetHeight;
        newCell.id = newCell.id + "_clone";
        newTr.appendChild(newCell);
        clonedTbodyNode.appendChild(newTr);
    }
    // copy all the TRs and a cell for each, and finally append them to the TBODY
    for (var i=0;i<tableNode.rows.length && i<=dragdrop.rowsPerView;++i) {
        var newTr = tableNode.rows[i].cloneNode(false);
        newTr.id = newTr.id +"_clone";
        var oldCell = tableNode.rows[i].cells[currentOrder];
        var newCell = oldCell.cloneNode(true);
        newCell.style.height = oldCell.offsetHeight;
        newCell.id = newCell.id + "_clone";
        newTr.appendChild(newCell);
        clonedTbodyNode.appendChild(newTr);
    }
    //set attributes
    clonedTableNode.style.zIndex = 1000;
    
    clonedTableNode.style.position = "absolute";
    if (WClient.isBrowserInternetExplorer() && tableNode.rows.length-1 > dragdrop.rowsPerView)
	    clonedTableNode.style.top = -column.offsetHeight + "px";
	else
	    clonedTableNode.style.top = column.offsetTop + "px";
    clonedTableNode.style.left = column.offsetLeft + "px";
    clonedTableNode.style.width = column.offsetWidth + "px";

   //clonedTableNode.style.opacity = "0.7";

    // append the cloned table with the one column to the parentNode

    tableNode.parentNode.appendChild(clonedTableNode);
    return clonedTableNode;
}
