/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Presentation Services
*
* (C) Copyright IBM Corp. 2006, 2008  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} ***
*******************************************************************************/

/*******************************************************************************
* This file contains all of the javascript functions used by the WCL renderers
* when AJAX is being used.  The functions defined here must be stateless -- that
* is, no member variables can be defined, so all state information must be
* passed into the function as parameters.
*******************************************************************************/
/** AWInputComponent **
 * action - the name of the action. do not encode because it is used as the
 *          value of a hidden input field.
 * formName - this encoded name of the form
 * wclhidden - the encoded name of the hidden field
 */
function frmActAjax(action, formName, wclhidden) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];      
      if (form != null) {
         eval( "form." + wclhidden + ".value = '" + action + "'" );
         startRequest(form,null);
         // Reset the form values.
         eval("form." + wclhidden + ".value = ''");
      }
   }
}
/*
*checkBox action instead of form.submit()
*/
function checkBoxActAjax(action, formName) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
    	  startRequest(form,null);
      }
   }
}

/*
*textEntry action instead of form.submit()
*/
function textEntryActAjax(action, formName, wclhidden) {
   if (document != null && document.forms != null && formName != null) {
	      var form = document.forms[formName];
	      if (form != null) {
	    	 if (action != null) {
	             eval( "form." + wclhidden + ".value = '" + action + "'" );
	         }
	         if(action != null && ((action.indexOf("bottomPage") != -1) || (action.indexOf("topPage") != -1)) ){
	         	//table text entry action start request will cause handle state change -  5.8 fix
	         	
	         	//data requests happen which are sufficient for updating table data
	         }else{
	         	startRequest(form,null);
	         }
	    	 
	         // Reset the form values.
	         eval("form." + wclhidden + ".value = ''");
		 }
	  }
}

/*
*comboBox action instead of form.submit()
*/
function comboBoxActAjax(action, formName) {
   if (document != null && document.forms != null && formName != null) {
	      var form = document.forms[formName];
	      if (form != null) {
	    	  startRequest(form,null);
	      }
   }
}


function popupActAjax(action, formName, wclhidden) {
   if (document != null && document.forms != null && formName != null) {
	      var form = document.forms[formName];
	      if (form != null) {
	         eval( "form." + wclhidden + ".value = '" + action + "'" );
	         startRequestSingleUpdate(form, null, action);
	         // Reset the form values.
	         eval("form." + wclhidden + ".value = ''");
	      }
   }
}

/* @auiml: zMA1193 11-18-08 added */
function doSetValueAjax(elem, value)
{
	var dd = document.getElementsByName(elem);
    if (dd[0])
    {
    	dd[0].value = value;
    }
}

/** WPopupMenu **
 * formName - the encoded name of the form
 * actionName - the unique name of the action being performed
 * actionValue - the name of the component performing the action
 * actionNameEnc - the encoded name of the action being performed
 * menuID - the name of the unique id of the popup menu
 * menuCmd - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 */

function doPopAjax(formName, actionName, actionValue, actionNameEnc, menuID, menuCmd, wclhidden)
{
	   if (document != null && document.forms != null && formName != null) {
	      var form = document.forms[formName];
	       if (form != null) {
	           if (actionName != null && actionNameEnc != null && wclhidden != null) {
	           	 doSetValueAjax(actionNameEnc,actionValue); //@auiml
	             eval("form." + wclhidden + ".value = '" + actionName + "'");
	           }
	           // We have to store the command name as a hidden field so that it gets passed
	           // along when the form is submitted.
	           if (menuID != null) {
	           	 doSetValueAjax(menuID,menuCmd); //@auiml
	           }
	           //form.submit();
	           startRequest(form, actionName);
	           doSetValueAjax(actionNameEnc,''); //@auiml
	           eval("form." + wclhidden + ".value = ''");
	           if (menuID != null) {
	           	 doSetValueAjax(menuID,''); //@auiml
	           }
	       }
	   }
	   return false;
}

/** WMessageBox **
 * name - the name of the close hyperlink
 * ids - the ids associated with the close hyperlink
 * formName - the encoded name of the form
 * wclhidden - the encoded name of the hidden field for the close hyperlink name
 * wclMessageClosed - the encodedName of the hidden field for the ids
 */
function msgActAjax(mname, ids, formName, wclhidden, wclMessageClosed) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
         eval( "form." + wclhidden + ".value = '" + mname + "'" );
         eval( "form." + wclMessageClosed + ".value = '" + ids + "'" );
         startRequest(form, null);
         eval( "form." + wclhidden + ".value = ''" );
         eval( "form." + wclMessageClosed + ".value = ''" );
      }
   }
   return false;
}


/**
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doWizButtonAjax(formName, actionName, actionValue, actionNameEnc, wclhidden) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
         eval("form." + wclhidden + ".value = '" + wclhidden + "'");
         startRequest(form, actionName);
         // Reset the form values.
         eval("form." + wclhidden + ".value = ''");
      }
   }
   return false;
}

/** WNotebook **
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doNbAjax(formName, actionName, actionValue, actionNameEnc, wclhidden, wclanchor) {
   return doSubmitAjax(formName, actionName, actionValue, null, actionNameEnc, wclhidden, wclanchor);
}

/** WWizard **
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doWizAjax(formName, actionName, actionValue, actionNameEnc, wclhidden, wclanchor) {
   return doSubmitAjax(formName, actionName, actionValue, null, actionNameEnc, wclhidden, wclanchor);
}

/** WTree (for the expand/collapse events) **
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 * idName - the encoded name of the hidden field that specifies which tree in the form is performing the action
 */
function doTreeAjax(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor, idName){
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
         if(idName != null){
             eval("form." + idName + ".value = '" + idName + "'");
         }
      }
   }
   return doSubmitAjax(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor);
}

/**
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doSubmitAjax(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
         if (actionName != null) {
            eval("form." + actionNameEnc + ".value = '" + actionValue + "'");
            eval("form." + wclhidden + ".value = '" + actionName + "'");
         }
         startRequest(form, null);
         // Reset the form values.
         eval("form." + actionNameEnc + ".value = ''");
         eval("form." + wclhidden + ".value = ''");
      }
   }
   return false;
}

/**
 * Just like doSubmitAjax, but it posts value of submit item as well.
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doSubmitActionAjax(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
      	 var originalValue = '';
         if (actionName != null) {
         	eval("originalValue = form." + actionNameEnc + ".value" );
            eval("form." + actionNameEnc + ".value = '" + actionValue + "'");
            eval("form." + wclhidden + ".value = '" + actionName + "'");
         }
         startRequest(form, actionName);
         // Reset the form values.
         eval("form." + actionNameEnc + ".value = originalValue");
         eval("form." + wclhidden + ".value = ''");
      }
   }
   return false;
}


/**
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doFormSubmitAjax(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
         if (actionName != null) {
            eval("form." + actionNameEnc + ".value = '" + actionValue + "'");
            eval("form." + wclhidden + ".value = '" + actionName + "'");
         }
         
         // @auiml - begin
         // We have to store the anchor as a hidden field so that it gets passed
         // along when the form's method is GET.  (When the method is GET, the
         // parameters on the form's action are ignored!)  The date ensures we'll
         // have a unique URL so that a URL can be invoked twice consecutively.
         if (anchorName != null) {
            var aDate = new Date();
            eval("form." + wclanchor + ".value = '" + anchorName + '_' + aDate.getTime() + "'");
            var idx = form.action.indexOf('#');
            if (idx > -1) {
                // strip off the anchor that's already on the url
                form.action = form.action.substring(0, idx);
            }
            form.action += '#' + anchorName;
         }
         // @auiml - end
         
         form.submit();
      }
   }
   return false;
}

/** WTable **
 * formName - the encoded name of the form
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 * userActions - the userActions id to be used if the GO button is missing
 */
function doUserActionAjax(formName, actionValue, anchorName, wclhidden, wclanchor, userActions) {
   debug("-->doUserActionAjax");
   
   var result = false;
   var dropDownId = "userActions" + actionValue.substring(10);
   var dropDown = document.getElementById(dropDownId);
   debug("dropDownId [" + dropDownId + "]");
   var ajax = false;
   var skip = false;
   if (dropDown) {
      debug("got dropDown [" + dropDown.id + "]");
      // See if we can skip this action (the --- Select Action --- is selected).
      if (dropDown.selectedIndex == 0) {
         debug("skip");
         skip = true;
      }
      // See if this is a table action (not a user one).
      else { //if (dropDown.options[dropDown.selectedIndex].value.indexOf("user(") == -1) {
         debug("ajax");
         ajax = true;
      }
      
      var option = dropDown.options[dropDown.selectedIndex];
      // check if this should be executed as AJAX or not
      if(option.getAttribute("USE_AJAX") == null){
		return doAnchor(formName, anchorName, wclanchor, dropDownId);
      }
      
      if(option){
      	if (WClient.isBrowserInternetExplorer()){  
	      	if(option.message!=null){
	      		var message = option.getAttribute("message");
    	  		skip = !(confirm(message)); 
	      	}
	     } else {
	      	if(option.hasAttribute("message")){
	      		var message = option.getAttribute("message");
    	  		skip = !(confirm(message)); 
			}	     	
	     }
      }
   }
   if (!skip) {
      var actionName = "action_";
      actionName = actionName.concat(actionValue.substring(actionValue.indexOf("_") + 1));
      if (ajax) {
         //result = doAnchorAjax(formName, actionValue, anchorName, wclhidden, wclanchor, userActions);
		 if(dropDown.value.indexOf("/ExportData?exportId") != -1) {
		 	window.open(dropDown.value,'_self');
		 } 
		 else if(dropDown.value.indexOf('changeSelected') == 0) {
	         changeAllSelectedAjax(formName, actionName, actionName, wclhidden);
         }
         else {
           	 doTblAjax(formName, actionName, dropDown.value, anchorName, actionName, wclhidden, wclanchor);		
         }  
      }
      else {
        // result = doAnchor(formName, anchorName, wclanchor);
		 doTbl(formName, actionName, dropDown.value, anchorName, actionName, wclhidden, wclanchor);
         if (userActions) {
            var form = document.forms[formName];
            form.submit();
         }
      }
   }
   dropDown.selectedIndex = 0;
   debug("-->doUserActionAjax : " + result);
   return result;
}

/** WTable **
 * formName - the encoded name of the form
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 * userActions - the optional userActions ID, will be used as hidden
 */
function doAnchorAjax(formName, actionValue, anchorName, wclhidden, wclanchor, userActions) {
   debug("-->doAnchorAjax");
   var form = document.forms[formName];
   if (form != null && anchorName != null && wclanchor != null) {
      var aDate = new Date().getTime();
      eval("form." + wclanchor + ".value = '" + aDate + "'");
      if (actionValue != null && actionValue.length > 0) {
         if (userActions) {
            eval("form." + wclhidden + ".value = '" + userActions + "'");
         } else if (actionValue.indexOf("cancel") != -1 || actionValue.indexOf("okay") != -1) {
            eval("form." + wclhidden + ".value = '" + actionValue + "'");
         } else {
            eval("form." + wclhidden + ".value = '" + wclhidden + "'");
         }
      }

      var inputName = "wclAnchorHash";
      var input  = document.getElementById( inputName );
      if ( !input )
      {
          input = document.createElement( "INPUT" );
          with ( input )
          {
              type  = "hidden";
              id    = inputName;
              name  = inputName;
          }
          form.appendChild( input );
      }
      input.value = anchorName;

      if (actionValue != null && actionValue.length > 0) {
         debug("doAnchorAjax calling startRequest...");
         startRequest(form, actionValue);
         // Reset the form values.
         eval("form." + wclanchor + ".value = ''");
         eval("form." + wclhidden + ".value = ''");
         return false;
      }
   }
   debug("<--doAnchorAjax");
   return true;
}

/** WTable **
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doTblAjax(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
         if (actionName != null) {
            eval("form." + actionNameEnc + ".value = '" + actionValue + "'");
            eval("form." + wclhidden + ".value = '" + actionName + "'");
         }

         debug("actionNameEnc = " + actionNameEnc);
         debug("actionValue = " + actionValue);

         debug("AJAX request with action = " + form.action);
         
         startRequest(form, null);
         // Reset the form values.
         eval("form." + actionNameEnc + ".value = ''");
         eval("form." + wclhidden + ".value = ''");
      }
      return false;
   }
}
/** WTable **
 * used for submiting input from selected rows only
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 */
function changeAllSelectedAjax(formName, actionName, actionNameEnc, wclhidden) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];

      if (form != null) {
      	var fieldArray = new Array();
      	fieldArray = getSelectedRowsInput(form);
      	var actionValue;
      	if(fieldArray['#selectedRows'] !== undefined){
		    actionValue = 'changeSelected(' + fieldArray['#selectedRows'].join(',') + ')';
		    delete fieldArray['#selectedRows'];
      	}else{
      		actionValue = 'changeSelected()';
      	}
		putInputValueIntoArray(fieldArray, 'IsAjaxInvoked', 'YES');
		putInputValueIntoArray(fieldArray, actionNameEnc, actionValue);
		putInputValueIntoArray(fieldArray, 'AjaxForms', getFormsList());
		putInputValueIntoArray(fieldArray, wclhidden, actionName);
		
		var actionString = getActionString(form);
		
		//ChangeAllSelected doesn't work on portlet with AJAX On 
		actionString = form.action;	
		
		debug("action [" + actionString + "]");
		var wcldojo = WUtilities.getDojoNamespace();	
      	wcldojo.xhrPost( {
			// The following URL must match that used to test the server.
			url : actionString,
			handleAs :"text",
//			form :form,
			timeout : requestTimeout, // Time in milliseconds
			content : fieldArray, // additional request parameters
	
			// The LOAD function will be called on a successful response.
			load :handleStateChange,
	
			// The ERROR function will be called in an error case.
			error :handleRequestErrorDojo
		});
      }
      return false;
   }
}

/** WTable **
 * used for invoking actions via ajax without submitting form fields
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doTblAjaxNoSubmit(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      
      if (form != null) {
      	var fieldArray = new Array();
		putInputValueIntoArray(fieldArray, 'IsAjaxInvoked', 'YES');
		putInputValueIntoArray(fieldArray, actionNameEnc, actionValue);
		putInputValueIntoArray(fieldArray, 'AjaxForms', getFormsList());
		putInputValueIntoArray(fieldArray, wclhidden, actionName);
	    // ajax in portlets
	    putAjaxInPortletsParams(fieldArray, form);

		if (!isAJAXOutstanding) {
      		isAJAXOutstanding = true;		
		var actionString = getActionString(form);
		var wcldojo = WUtilities.getDojoNamespace();
	      	wcldojo.xhrPost( {
				// The following URL must match that used to test the server.
				url : actionString,
				handleAs :"text",
	//			form :form,
				timeout : requestTimeout, // Time in milliseconds
				content : fieldArray, // additional request parameters
		
				// The LOAD function will be called on a successful response.
				load :handleStateChange,
		
				// The ERROR function will be called in an error case.
				error :handleRequestErrorDojo
			});
      	}
      }
      return false;
   }

}

/** WTable **
 * refreshes the portlet by adding a 1px column onto the end.
 */
function refreshAjaxContainer(dataBodyEnc)
{
   debug("refreshAjaxContainer");
   var ajaxComponent = document.getElementById(dataBodyEnc);
   var ajaxContainer = null;
   if(ajaxComponent != null){
	  ajaxContainer = ajaxComponent.parentNode;
   }
   // Search up the DOM until we find the AJAX page.
   while (ajaxContainer != null || ajaxContainer != undefined)
   {
      if (ajaxContainer.id)
      {
         //debug("refreshAjaxContainer : parent [" + ajaxContainer.id + "]");
        //[#108688]-Accessibility - duplicated ids
         if ((ajaxContainer.id.substring(0, 14) == "AJAX_CONTAINER") && (ajaxComponent.id.substring(0, 3) == "PG_"))
         {
            debug("refreshAjaxContainer : found AJAX page [" + ajaxComponent.id + "]");
            // Now look for the TD that has the class wpsPortletBorder.
            var addIt = false;
            var portlet = false;
            var parent = ajaxContainer.parentNode;
            while (parent != null)
            {
               if (parent.tagName && (parent.tagName == "TD") && parent.className && (parent.className == "wpsPortletBorder"))
               {
                  debug("refreshAjaxContainer : found wpsPortletBorder");
                  portlet = true;
               }
               parent = parent.parentNode;
               if (portlet && parent.tagName && (parent.tagName == "TR"))
               {
                  debug("refreshAjaxContainer : found TR containing portlet");
                  addIt = true;
                  break;
               }
            }
            if (addIt)
            {
               // Make sure we haven't already added the column.
               var componentId = ajaxComponent.id + "_AjaxRefresh";
               if (document.getElementById(componentId) == null)
               {
                  debug("refreshAjaxContainer : adding extra column");
                  var td = document.createElement('TD');
                  parent.appendChild(td);
                  td.id = componentId;
                  td.width = '1px';
                  setTimeout("finishRefreshAjaxContainer('" + componentId + "')", 0);
               }
            }
            break;
         }
      }
      // Keep searching up the DOM.
      ajaxComponent = ajaxContainer;
      ajaxContainer = ajaxContainer.parentNode;
   }
}

/** WTable **
 * removes the added column from to finish the refresh.
 */
function finishRefreshAjaxContainer(componentId)
{
   debug("finishRefreshAjaxContainer(" + componentId + ")");
   var component = document.getElementById(componentId);
   component.parentNode.removeChild(component);
}

/** WTable (scrolling)**
 * setup table for scrolling
 */
function setupTableAjax(dataBodyEnc)
{
   debug("Running setupTableAjax [" + dataBodyEnc + "]");
   var dataBody = document.getElementById(dataBodyEnc);

   if (dataBody != null) {

	  if (dataBody.rows.length != 0) {
	      // Unhide any rows that we hide to keep Firefox from jiggling.
	      var lowerRows = dataBody.parentNode.childNodes[dataBody.parentNode.childNodes.length -1];
	      if (dataBody.childNodes[dataBody.childNodes.length - 1].style.display == 'none'
	          || lowerRows.childNodes[lowerRows.childNodes.length - 1].style.display == 'none') {
	         for (var i = 0; i < dataBody.childNodes.length; ++i) {
	            dataBody.childNodes[i].style.display = '';
	         }
		      // the same for rows after Action Bar:
		      // (they are put automagically into brand new tbody)
		     if(lowerRows.tagName.toLowerCase() == 'tbody' && !lowerRows.id){
		         for (var i = 0; i < lowerRows.childNodes.length; ++i) {
		         	if(lowerRows.childNodes[i].tagName.toLowerCase() == 'tr' && lowerRows.childNodes[i].style.display == 'none'){
		 	            lowerRows.childNodes[i].style.display = '';
		         	}
		         }
		     }
	      }
	  }

      if (dataBody.offsetHeight > 0 || dataBody.parentNode.offsetHeight > 0) {
         var scrollPaneEnc = dataBody.getAttribute('SPID');
         var scrollPane = document.getElementById(scrollPaneEnc);
         var actionBarEnc = dataBody.getAttribute('ABID');
         var actionBar = document.getElementById(actionBarEnc);
         var inlineBody = actionBar ? (actionBar.nextSibling ? actionBar.nextSibling : null) : null;
         var offset = actionBar ? actionBar.offsetHeight : 0;
         var viewRows = dataBody.getAttribute('RPV');
         var numRows = dataBody.getAttribute('DR');
         var numInlineRows = inlineBody ? inlineBody.getAttribute('DR') : "0";

		 if (dataBody.rows.length != 0) {
		 	scrollPane.style.height = offset + ((dataBody.offsetHeight / dataBody.rows.length) 
		 										 * Math.min(Number(numRows) + Number(numInlineRows), viewRows)) 
		 										 + (WClient.isBrowserMozilla() ? 3 : 0);
		 } else {
		 	var minRowsDisp = dataBody.getAttribute('MRD');
            var rowsPerPage = dataBody.getAttribute('RPP');
            minRowsDisp = Number(minRowsDisp) == 0 ? 4 : Number(minRowsDisp);
		    var min = Math.min(minRowsDisp, Number(viewRows));
		    var defaultOffsetHeight = dataBody.getAttribute('DOH');
		 	scrollPane.style.height = offset + ((dataBody.offsetHeight > 0 ? dataBody.offsetHeight : defaultOffsetHeight) * min)
	         									    + (WClient.isBrowserMozilla() ? 3 : 0)
	         									    + (WClient.isBrowserMozilla() ? min*6 : min);
		 }

         if (scrollPane.getAttribute('H1BID')) {
           resizeDivAjax(scrollPaneEnc);
         }

         // Get where we should scroll to.
         var scrollTo = scrollPane.firstChild.value;
         debug("scrolling to " + scrollTo);
         scrollPane.scrollTop = scrollTo;

         // Firefox won't shrink portlets after an embedded table dialog
         // closes so let's make it redraw the portlet.
         if (WClient.isBrowserMozilla()) {
            setTimeout("refreshAjaxContainer('" + dataBodyEnc + "')", 0);
         }
      }
      else {
         debugErr("Setting table timer");
         setTimeout("setupTableAjax('" + dataBodyEnc + "')", 10);
      }
   }
   else
      debugErr("setupTableAjax: databody is null");
}

/** WTable (scrolling)**
 * handles resize of div
 */
function resizeDivAjax(divID, column)
{
   debug("Running resizeDivAjax: " + divID);
   var div = document.getElementById(divID);
   if (div != null) {
      var headBody1 = document.getElementById(div.getAttribute('H1BID'));
      var headBody2 = document.getElementById(div.getAttribute('H2BID'));
      var tableStyle = headBody2.parentNode.style;
      var cellCount = headBody2.rows[0].cells.length-1;
      var widths = new Array(cellCount);

      // Parent TABLE
      tableStyle.tableLayout = 'auto';
      tableStyle.width = "auto";
      var sum = 0;
      if (window[divID + "_firstTime"] == undefined) {
      	window[divID + "_firstTime"] = true;
      }
      for (var c = 0; c < cellCount; c++) {
          // THs
         var head1 = headBody1.rows[0].cells[c];
         var head2 = headBody2.rows[0].cells[c];

         head2.firstChild.style.tableLayout = 'auto';
		 if (head1.minWidth == undefined) {
		    var cells = head1.firstChild.rows[0].cells;
            var minWidth = cells[0].firstChild.offsetWidth + 3;

            for (var i=1; i < cells.length; i++)
               minWidth += parseInt(cells[i].offsetWidth);
            head1.minWidth = minWidth;
		}
		widths[c] = (column && column.id == head1.id) ? column.width : head1.width != '' ? head1.width : head2.offsetWidth;
         
        if (widths[c] < head1.minWidth) {
		   widths[c] = head1.minWidth;
        }
        if (window[divID + "_firstTime"]) {
	        sum += parseInt(widths[c]);
	        if (c == cellCount-1 && sum < div.clientWidth) {
	        	temp = parseInt(widths[c]) + (div.clientWidth - sum);
	        	widths[c] = temp.toString(10);
	        }
        }
      }

      tableStyle.display = 'none';
      var temp = headBody2.rows[0].cells[0].offsetWidth;	//LC magic - this is needed for properly setting the display = 'none' style - only for Firefox 
	  // [#94601] Table does not resize when new column items or larger size are added to it - Changed tableStyle.tableLayout = 'fixed' to tableStyle.tableLayout = 'auto'; for Firefox since it does not support elipsis;
	  //In WCL 5.8, Reverting the change for the above defect fix by having the tableLayout as "fixed" for both the browsers. The table row content will be chopped off if it exceed the initial column width as in the modern tables(Dojo Grid).
      /*if(WClient.isBrowserMozilla())
      	tableStyle.tableLayout = 'auto';
      else*/
      	tableStyle.tableLayout = 'fixed';
      tableStyle.display = '';

      for (var c = 0; c < cellCount; c++) {		
         var head1 = headBody1.rows[0].cells[c];
         var head2 = headBody2.rows[0].cells[c];
		  
         head1.width = widths[c];
         head1.style.width = widths[c];
         //@auiml -problems zMA1197 and zMA1205 are almost identical except for the former handles empty table and the latter handles populated table
         //Enclosing the follwing couple lines in the if clause handles the empty table case. PS-Web bug #99889 is opened for zMA1205 which should also
         //takes care of the empty table scenario.  Once a fix is delivered for 99889, this if clause should be removed.
         //the above defect has been fixed in PS - so commenting if clause since there was problems with width in case of empty table
         //if(headBody2.parentNode.rows.length > 1) //@zMA1197A if not empty table (the 1 is for the header row)
        // {
             head2.width = widths[c];
             head2.style.width = widths[c];
         //}
          
         // Send all column widths up to the server so the returned table
         // isn't completely different than the formatted one because that
         // causes the table to jiggle in Firefox. It also allows us to
         // keep the DOM table in synch with what the server generates so
         // that in portal we can tell if the table really changed.
         try {
            head1.firstChild.rows[0].lastChild.lastChild.value = widths[c];
         }
         catch (widthError) {
            debug("Error setting table column width: [" + widthError.name + "] [" + widthError.message + "]");
         }
      }
      tableStyle.width = "";	// fixes last column resizing problem
   }
   else
      debugErr("resiseDivAjax: div is null");

   //@auiml - begin - needed for scrollable tree tables
   if(div != null){
	   var children = div.childNodes[1].childNodes; //@auiml - ordering of table div child nodes is reversed in ajax
	   var dataBody = null;
	   for (var i=0; i<children.length; i++)
	   {
	      if (children[i].getAttribute('SPID') != null) 
	      {
	         dataBody = children[i];
	         break;
	      }
	   }
   }
   
   if (dataBody != null && dataBody.offsetHeight > 0) 
   {															
      var actionBarEnc = dataBody.getAttribute('ABID');
      var actionBar = document.getElementById(actionBarEnc);
      var inlineBody = actionBar ? (actionBar.nextSibling ? actionBar.nextSibling : null) : null;
      var offset = actionBar ? actionBar.offsetHeight : 0;
      var viewRows = dataBody.getAttribute('RPV');
      var numRows = dataBody.getAttribute('DR');
      var numInlineRows = inlineBody ? inlineBody.getAttribute('DR') : "0";

      var minRows = 1;
      if(numRows < minRows)
         numRows = minRows;

      //@auiml - scrollable treetable anchoring
      var hght = offset + ((dataBody.offsetHeight / dataBody.rows.length) * Math.min(Number(numRows) + Number(numInlineRows), viewRows));
   	  var selRow =-1;
   	  div.style.height = hght;
   	  //@auiml -needed for virtual scrolling tables
      var headerRowId = div.previousSibling.id;
      var tableName = headerRowId.substring(0,headerRowId.indexOf("_headerRow"));
      var tableContainer = null;
      if (document.getElementById(tableName+"_tableContainer")) 
      {
         tableContainer = document.getElementById(tableName+"_tableContainer");
		 tableContainer.setAttribute("TOTALHEIGHT", hght);
   	  }

      if (dataBody.firstChild.textContent != "None") 
      {
         var rows = dataBody.childNodes;
         for (var i=0; i<rows.length; i++) 
         {   	  
            var images = rows[i].getElementsByTagName("IMG");
            if (images != null) 
            {
               for (var j=0;j<images.length;j++) 
               {
                  var img = images[j];
                  if (img.src.indexOf("tbl3.gif") > 0)  
                  {
                     selRow=i;
                     break;		   	  	 		
                  }
               }
            }
         }
         if (selRow < 0 ) 	//no selection
            div.scrollTop = 0;   	     	  
         else 				//selection
            //don't scroll is selection is in current view
            if (selRow < viewRows -1)
               div.scrollTop = 0;
            else
               div.scrollTop = dataBody.offsetHeight/rows.length*selRow;
      //@auiml - end  
      }   	  
   }
   window[divID + "_firstTime"] = false;
}

/** WTable (scrolling)**
 * handles scroll of table
 */
function setScrollPositionAjax(scroller)
{
   var scrollDiv = document.getElementById(scroller);
   if (scrollDiv != null) {
      var scrollPos = scrollDiv.scrollTop;
      scrollDiv.firstChild.value = scrollPos;
   }
}

/** WTableColumn (drag-n-drop)**
 * handles resize of table columns
 */
function tcDNDAjax(event, evtCode, columnId, divID)
{
   if (!isAJAXOutstanding) {
      debug("inside tcDNDAjax");
      var wevent = new WEvent(event);
      var column = document.getElementById(columnId);

      switch (evtCode) {
      case 1: // mouseDown (grab)
         if (!column.isDragging)
         {
            var cells = column.firstChild.rows[0].cells;
            column.isDragging = true;
            column.startPosition = column.currentPosition = wevent.getPagePosition();
            column.startWidth = WUtilities.getWidth(column);
            // save document's mouse handlers
            document._onselectstart = document.onselectstart;
            document._onmousemove = document.onmousemove;
            document._onmouseup = document.onmouseup;
            document.body._cursor = document.body.style.cursor;
            // temporarily override document's mouse handlers
            document.onselectstart = new Function("event", "return false;");
            document.onmousemove = new Function("event", "return tcDNDAjax(event, 2, '" + columnId + "', '" + divID + "');");
            document.onmouseup = new Function("event", "return tcDNDAjax(event, 3, '" + columnId + "', '');");
            document.body.style.cursor = "e-resize";

            return false;
         }
         break;
      case 2: // mouseMove (drag)
         if (column.isDragging)
         {
            var mousePosition = wevent.getPagePosition();
            var difference = mousePosition.getX() - column.startPosition.getX();
            var div = document.getElementById(divID);
            if(div != null){
              var bidi = div.getAttribute("BIDI");

              if (bidi)
                difference = -difference;
            }

            column.width = Math.max(column.startWidth + difference, column.minWidth) + "px";
            column.currentPosition = mousePosition;

            if(div != null){
              resizeDivAjax(divID, column);
            }

            return false;
         }
         break;
      case 3: // mouseUp (drop)
         if (column.isDragging)
         {
            column.isDragging = false;
            // restore document's mouse handlers
            document.onselectstart = document._onselectstart;
            document.onmousemove = document._onmousemove;
            document.onmouseup = document._onmouseup;
            document.body.style.cursor = document.body._cursor;
            // save width
            var input = column.firstChild.rows[0].lastChild.lastChild;

            input.value = column.width ? column.width : "-1";

            return false;
         }
         break;
      }
   }
   return true;
}

function enableSubmitFlagOnAjax(formName){
	
	if (document != null && document.forms != null && formName != null) {
      	var form = document.forms[formName];
      	
      	if(form!=null && form.getAttribute("submitFlag") == "true"){
      		//submit flag is set to true due to ajax submit action
      		//enable it again to be accessible again for user
      		//console.debug("form name"+formName );
      		form.setAttribute("submitFlag", "false");
      	}      
	}

}


function showSecWindow(secWindow){
		//console.debug(secWindow.id);
		var wcldijit = WUtilities.getDijitNamespace();
		//console.debug(wcldijit);
		wcldijit.byId(secWindow.id).show();
	}

/** WTable **
 * formName - the encoded name of the form
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 * userActions - the user action clicked
 * exportDataServletPath - the path for export data servlet to open
 * message - a confirmation message for an user action
 * ajax - ajax enabled user action or not
 */
function dojoUserActionsAjax(formName, actionValue, anchorName, wclhidden, wclanchor, userActions, exportDataServletPath, message, ajax) {
	var result = false;
	var skip = false;
    if (WClient.isBrowserInternetExplorer()){  
		if(message!== null && message !== undefined){
			skip = !(confirm(message)); 
		}
	} else {
		if(message !== null && message !== undefined){
			skip = !(confirm(message));
		}
	}
	if (!skip){	
		var actionName = "action_";
		actionName = actionName.concat(actionValue.substring(actionValue.indexOf("_") + 1));
		if (userActions == exportDataServletPath) {
			window.open(exportDataServletPath, '_self');
		} else {
			if (ajax) {
				if (userActions == 'changeSelected()') {
					changeAllSelectedAjax(formName, actionName, actionName, wclhidden);
				} else {
					doTblAjax(formName, actionName, userActions, anchorName, actionName, wclhidden, wclanchor);	
				}
			} else {
				doTbl(formName, actionName, userActions, anchorName, actionName, wclhidden, wclanchor);
			}
		}
	}
    return result;
}

function removeAnchorsForNB(){
	for(i=0; document.getElementById("linkName_turnPage(" + i + ")") != null; i++){
		var linkOb = document.getElementById("linkName_turnPage(" + i + ")");
		linkOb.removeAttribute("href");
	}
}

function addAnchorsForNB(){
	for(i=0; document.getElementById("linkName_turnPage(" + i + ")") != null; i++){
		var linkOb = document.getElementById("linkName_turnPage(" + i + ")");
		linkOb.setAttribute("href","#");
	}
}