/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Presentation Services
*
* (C) Copyright IBM Corp. 2002, 2008  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} ***
*******************************************************************************/

/*******************************************************************************
* This file contains all of the javascript functions used by the WCL renderers
* during traditional execution when AJAX is not being used. The functions
* defined here must be stateless -- that is, no member variables can be defined,
* so all state information must be passed into the function as parameters.
*******************************************************************************/

/** AWInputComponent **
 * action - the name of the action. do not encode because it is used as the
 *          value of a hidden input field.
 * formName - this encoded name of the form
 * wclhidden - the encoded name of the hidden field
 */
function frmAct(action, formName, wclhidden) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
         eval( "form." + wclhidden + ".value = '" + action + "'" );
      }
   }
}

function frmActSecWindow(action, formName, wclhidden) {
	if (document != null && document.forms != null && formName != null) {
		//console.debug("form present");
      var form = document.forms[formName];
      if (form != null) {
         eval( "form." + wclhidden + ".value = '" + action + "'" );
      }
	 // console.debug("before invoking submit...");
	  form.submit();
   }

}

/** WNotebook **
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doNb(formName, actionName, actionValue, actionNameEnc, wclhidden, wclanchor) {
   return doSubmit(formName, actionName, actionValue, null, actionNameEnc, wclhidden, wclanchor);
}

/** WWizard **
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doWiz(formName, actionName, actionValue, actionNameEnc, wclhidden, wclanchor) {
   return doSubmit(formName, actionName, actionValue, null, actionNameEnc, wclhidden, wclanchor);
}

/** WTree (for the expand/collapse events) **
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 * idName - the encoded name of the hidden field that specifies which tree in the form is performing the action
 */
function doTree(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor, idName){
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
         if(idName != null){
             eval("form." + idName + ".value = '" + idName + "'");
         }
      }
   }
   return doSubmit(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor);
}

/**
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doSubmit(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
         if (actionName != null) {
            eval("form." + actionNameEnc + ".value = '" + actionValue + "'");
            eval("form." + wclhidden + ".value = '" + actionName + "'");
         }

         // We have to store the anchor as a hidden field so that it gets passed
         // along when the form's method is GET.  (When the method is GET, the
         // parameters on the form's action are ignored!)  The date ensures we'll
         // have a unique URL so that a URL can be invoked twice consecutively.
         if (anchorName != null) {
            var aDate = new Date();
            eval("form." + wclanchor + ".value = '" + anchorName + '_' + aDate.getTime() + "'");
            var idx = form.action.indexOf('#');
            if (idx > -1) {
                // strip off the anchor that's already on the url
                form.action = form.action.substring(0, idx);
            }
            form.action += '#' + anchorName;
         }

         form.submit();
      }
   }
   return false;
}

/**
 * FR #106713 - Multiple submit prevention in WCL
 * Property 'submitFlag' is Set after one Submit of a form
 * formName - the encoded name of the form
 */
function oneSubmit(formName) {
	var form = document.forms[formName];
	if (document != null && document.forms != null && formName != null & form != null) {
		if(form.getAttribute("submitFlag") == "true"){
	   		return false;
	   	} else {
	   		form.setAttribute("submitFlag", "true");
	   		return true;
		}	     
   }
}

/**
 * CSBUG[#126482] - Add multi submit prevention to WNotebook component
 * Property 'submitFlag' is Set after one Submit of a form
 * formName - the encoded name of the form
 */
function oneNBSubmit(formName) {
	var form = document.forms[formName];
	if (document != null && document.forms != null && formName != null & form != null) {
		if(form.submitflag.value == "true"){
	   		return false;
	   	} else {
	   		//eval("form." + submitflag + ".value = 'true'");
	   		form.submitflag.value = "true";
	   		return true;
		}	     
   }
}


/**
 * FR# Processing Icon to be displayed for wizard buttons @TSIEM
 * formName - the encoded name of the form
 * wclhidden - the encoded name of the hidden field
 * divID - the encoded name of the div HTML element
 */
 
form_submit = false;
function doWizButton(formName, wclhidden, divId) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
         eval("form." + wclhidden + ".value = '" + wclhidden + "'");
         var p;
	   	 p = document.getElementById(divId);
	   	 p.style.visibility='visible';
	     p.style.display='inline';
		 if (form_submit)
		 {
			return false;
		 }
		 else
		 {
			form_submit = true;
			return true;
		 } 	 	
         // Reset the form values.
         eval("form." + wclhidden + ".value = ''");
      }
   }
   return false;
}


/** WTable **
 * formName - the encoded name of the form
 * anchorName - the name of the anchor used when the page is refreshed
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doAnchor(formName, anchorName, wclanchor, dropDownId) {
   var dropDown = document.getElementById(dropDownId);
   var skip = false;
   if (dropDown) { // message box must be shown
        // See if we can skip this action (the --- Select Action --- is selected).
        
		if(dropDown.value.indexOf("/ExportData?exportId") != -1) {
			window.open(dropDown.value,'_self');
			dropDown.selectedIndex = 0;
			skip = true;
		}else if (dropDown.selectedIndex != 0) {
	        var option = dropDown.options[dropDown.selectedIndex];
	        if (option){
		      	if (WClient.isBrowserInternetExplorer()) {  
			      	if (option.message!=null) {
			      		var message = option.getAttribute("message");
		    	  		skip = !(confirm(message)); 
			      	}
			    } else {
			      	if (option.hasAttribute("message")) {
			      		var message = option.getAttribute("message");
		    	  		skip = !(confirm(message)); 
					}	     	
			    }
	    	}
        }else{
			skip = true;        	
        }
   }

	if (!skip) {
	   var form = document.forms[formName];
	   if (form != null && anchorName != null && wclanchor != null) {
	      var aDate = new Date().getTime();
	      eval("form." + wclanchor + ".value = '" + aDate + "'");
	
	      // remove existing anchorName
	      var index = form.action.indexOf( "#" );
	      if ( index != -1 )
	      {
	          form.action = form.action.substring( 0, index );
	      }
	      form.action += '#' + anchorName;
	
	      var inputName = "wclAnchorHash";
	      var input  = document.getElementById( inputName );
	      if ( !input )
	      {
	          input = document.createElement( "INPUT" );
	          with ( input )
	          {
	              type  = "hidden";
	              id    = inputName;
	              name  = inputName;
	          }
	          form.appendChild( input );
	      }
	      input.value = anchorName;
	   }
   }
   return !skip;
}

/** WTable **
 * formName - the encoded name of the form
 * actionName - the name of the action being performed
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * actionNameEnc - the encoded name of the action being performed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 */
function doTbl(formName, actionName, actionValue, anchorName, actionNameEnc, wclhidden, wclanchor) {
   if (document != null && document.forms != null && formName != null) {
      var form = document.forms[formName];
      if (form != null) {
         if (actionName != null) {
            eval("form." + actionNameEnc + ".value = '" + actionValue + "'");
            eval("form." + wclhidden + ".value = '" + actionName + "'");
         }

         doAnchor(formName, anchorName, wclanchor);

         form.submit();
      }
      return false;
   }
}

/** WTable (scrolling)**
 * setup table for scrolling
 */
function setupTable(dataBodyEnc)
{
   var dataBody = document.getElementById(dataBodyEnc);

   if (dataBody.offsetHeight > 0 || dataBody.parentNode.parentNode.offsetHeight > 0) {
      var scrollPaneEnc = dataBody.getAttribute('SPID');
      var scrollPane = document.getElementById(scrollPaneEnc);
      var actionBarEnc = dataBody.getAttribute('ABID');
      var actionBar = document.getElementById(actionBarEnc);
      var offset = actionBar ? actionBar.offsetHeight : 0;
      var viewRows = dataBody.getAttribute('RPV');
      var numRows = dataBody.getAttribute('DR');

	  if (dataBody.rows.length != 0) {
	      scrollPane.style.height = offset + ((dataBody.offsetHeight / dataBody.rows.length) * Math.min(numRows, viewRows));
	  } else {
	  	  var minRowsDisp = dataBody.getAttribute('MRD');
          var rowsPerPage = dataBody.getAttribute('RPP');
          minRowsDisp = Number(minRowsDisp) == 0 ? 4 : Number(minRowsDisp);
		  var min = Math.min(minRowsDisp, Number(viewRows));
		  var defaultOffsetHeight = dataBody.getAttribute('DOH');
		  scrollPane.style.height = offset + ((dataBody.offsetHeight > 0 ? dataBody.offsetHeight : defaultOffsetHeight) * min)
	         									    + (WClient.isBrowserMozilla() ? 3 : 0)
	         									    + (WClient.isBrowserMozilla() ? min*6 : min)
	         									    - min*5;
	  }

      if (scrollPane.getAttribute('H1BID'))
        resizeDiv(scrollPaneEnc);
   }
   else
      setTimeout("setupTable('" + dataBodyEnc + "')", 10);

}

/** WTable (scrolling)**
 * handles resize of div
 */
function resizeDiv(divID)
{	
   var div = document.getElementById(divID);
   var headBody1 = document.getElementById(div.getAttribute('H1BID'));
   var headBody2 = document.getElementById(div.getAttribute('H2BID'));
   var tableStyle = headBody2.parentNode.style;
   var cellCount = headBody2.rows[0].cells.length-1;
   var widths = new Array(cellCount);

   tableStyle.tableLayout = 'auto';
   tableStyle.width = "auto";
   var sum = 0;
   if (window[divID + "_firstTime"] == undefined) {
      	window[divID + "_firstTime"] = true;
      }
   for (var c = 0; c < cellCount; c++) {
       var head1 = headBody1.rows[0].cells[c];
       var head2 = headBody2.rows[0].cells[c];

    	head2.firstChild.style.tableLayout = 'auto';
    	if (head1.minWidth == undefined) {
		 	var cells = head1.firstChild.rows[0].cells;
            var minWidth = cells[0].firstChild.offsetWidth + 3;
            for (var i=1; i < cells.length; i++)
               minWidth += parseInt(cells[i].offsetWidth);
            head1.minWidth = minWidth;
		}
        widths[c] = head1.width != '' ? head1.width : head2.offsetWidth;
		if (widths[c] < head1.minWidth) {
			widths[c] = head1.minWidth;
		}
		if (window[divID + "_firstTime"]) {
			sum += parseInt(widths[c]);
			if (c == cellCount-1 && sum < div.clientWidth) {
	        	//widths[c] += div.clientWidth - sum;
	        	temp = parseInt(widths[c]) + (div.clientWidth - sum);
				widths[c] = temp.toString(10);
	        }
		}
   }
   tableStyle.display = 'none';
   var temp = headBody2.rows[0].cells[0].offsetWidth;	//LC magic - this is needed for properly setting the display = 'none' style - only for Firefox 
  // [#94601] Table does not resize when new column items or larger size are added to it - Changed tableStyle.tableLayout = 'fixed' to tableStyle.tableLayout = 'auto' for Firefox since it does not support elipsis;
   //In WCL 5.8, Reverting the change for the above defect fix by having the tableLayout as "fixed" for both the browsers. The table row content will be chopped off if it exceed the initial column width as in the modern tables(Dojo Grid).
      /*if(WClient.isBrowserMozilla())
      	tableStyle.tableLayout = 'auto';
      else*/
      	tableStyle.tableLayout = 'fixed';
   tableStyle.display = '';

   for (var c = 0; c < cellCount; c++) {		   
       var head1 = headBody1.rows[0].cells[c];
       var head2 = headBody2.rows[0].cells[c];

       head1.width = widths[c];
       head1.style.width = widths[c];
       //@auiml -problems zMA1197 and zMA1205 are almost identical except for the former handles empty table and the latter handles populated table
       //Enclosing the follwing couple lines in the if clause handles the empty table case. PS-Web bug #99889 is opened for zMA1205 which should also
       //takes care of the empty table scenario.  Once a fix is delivered for 99889, this if clause should be removed.
       if(headBody2.parentNode.rows.length > 1) //@zMA1197A if not empty table (the 1 is for the header row)
       {
           head2.width = widths[c];
           head2.style.width = widths[c];
       }
   }
   tableStyle.width = "";	// fixes last column resizing problem
   
   //@auiml - begin - needed for scrollable tree tables
   if(div != null){
	   var children = div.childNodes[0].childNodes; //@auiml - ordering of table div child nodes is reversed in ajax //@auiml - changed index back to 0
	   var dataBody = null;
	   for (var i=0; i<children.length; i++)
	   {
	   		if (children[i].getAttribute('SPID') != null)
	   		{
	   			dataBody = children[i];
	   			break;
	   		}
	   }
   }
   
   if (dataBody != null && dataBody.offsetHeight > 0)
   {															
   		var actionBarEnc = dataBody.getAttribute('ABID');
   		var actionBar = document.getElementById(actionBarEnc);
   		var offset = actionBar ? actionBar.offsetHeight : 0;
   		var viewRows = dataBody.getAttribute('RPV');
   		var numRows = dataBody.getAttribute('DR');

         var minRows = 1;
         if(numRows < minRows)
            numRows = minRows;

     //@auiml - scrollable treetable anchoring
      var hght = offset + ((dataBody.offsetHeight / dataBody.rows.length) * Math.min(numRows, viewRows));
   	  var selRow = -1;
   	  div.style.height = hght;
   	  var headerRowId = div.previousSibling.id;
      var tableName = headerRowId.substring(0,headerRowId.indexOf("_headerRow"));
      var tableContainer = null;
      if (document.getElementById(tableName+"_tableContainer"))
      {
	     tableContainer = document.getElementById(tableName+"_tableContainer");
		 tableContainer.setAttribute("TOTALHEIGHT", hght);
   	  }

	  var rows = dataBody.childNodes;
	  for (var i=0; i<rows.length; i++)  							
   	  {   	  
   	  	 var images = rows[i].getElementsByTagName("IMG");
   	  	 if (images != null)
   	  	 {
	   	  	 for (var j=0;j<images.length;j++)
	   	  	 {
	   	  	 	var img = images[j];
	   	  	 	if (img.src.indexOf("tbl3.gif") > 0)
	   	  	 	{
	   	  	 		selRow=i;
	   	  	 		break;		   	  	 		
	   	  	 	}
	   	  	 }
	   	  }
   	  }
   	  if (selRow < 0 ) 	//no selection
	   	 div.scrollTop = 0;   	     	  
	  else 				//selection
	  	 //don't scroll is selection is in current view
	  	 if (selRow < viewRows -1)
	  	 	div.scrollTop = 0;
	  	 else
            div.scrollTop = dataBody.offsetHeight/rows.length*selRow;
	  //@auiml - end     	  	  
   }
   window[divID + "_firstTime"] = false;
}

/** WTableColumn (drag-n-drop)**
 * handles resize of table columns
 */
function tcDND(event, evtCode, columnId, divID)
{
   var wevent = new WEvent(event);
   var column = document.getElementById(columnId);

   switch (evtCode) {
   case 1: // mouseDown (grab)
      if (!column.isDragging)
      {
         var cells = column.firstChild.rows[0].cells;
         column.isDragging = true;
         column.startPosition = column.currentPosition = wevent.getPagePosition();
         column.startWidth = WUtilities.getWidth(column);
         // save document's mouse handlers
         document._onselectstart = document.onselectstart;
         document._onmousemove = document.onmousemove;
         document._onmouseup = document.onmouseup;
         document.body._cursor = document.body.style.cursor;
         // temporarily override document's mouse handlers
         document.onselectstart = new Function("event", "return false;");
         document.onmousemove = new Function("event", "return tcDND(event, 2, '" + columnId + "', '" + divID + "');");
         document.onmouseup = new Function("event", "return tcDND(event, 3, '" + columnId + "', '');");
         document.body.style.cursor = "e-resize";

         return false;
      }
      break;
   case 2: // mouseMove (drag)
      if (column.isDragging)
      {
         var mousePosition = wevent.getPagePosition();
         var difference = mousePosition.getX() - column.startPosition.getX();
         var div = document.getElementById(divID);
         if(div != null){          
           var bidi = div.getAttribute("BIDI");

           if (bidi)
             difference = -difference;
         }

         column.width = Math.max(column.startWidth + difference, column.minWidth) + "px";
         column.currentPosition = mousePosition;

         if(div != null){ 
           resizeDiv(divID);
         }
         
         return false;
      }
      break;
   case 3: // mouseUp (drop)
      if (column.isDragging)
      {
         column.isDragging = false;
         // restore document's mouse handlers
         document.onselectstart = document._onselectstart;
         document.onmousemove = document._onmousemove;
         document.onmouseup = document._onmouseup;
         document.body.style.cursor = document.body._cursor;
         // save width
         var input = column.firstChild.rows[0].lastChild.lastChild;

         input.value = column.width ? column.width : "-1";

         return false;
      }
      break;
   }
   return true;
}

/** WTable **
 * formName - the encoded name of the form
 * actionValue - the name of the component performing the action
 * anchorName - the name of the anchor used when the page is refreshed
 * wclhidden - the encoded name of the hidden field
 * wclanchor - the encoded name of the hidden field for the anchor
 * userActions - the user action clicked
 * exportDataServletPath - the path for export data servlet to open
 * message - a confirmation message for an user action
 */
function dojoUserActions(formName, actionValue, anchorName, wclhidden, wclanchor, userActions, exportDataServletPath, message) {
	var result = false;
	var skip = false;
    if (WClient.isBrowserInternetExplorer()){  
		if(message!== null && message !== undefined){
			skip = !(confirm(message)); 
		}
	} else {
		if(message !== null && message !== undefined){
			skip = !(confirm(message));
		}
	}
	if (!skip){	
		var actionName = "action_";
		actionName = actionName.concat(actionValue.substring(actionValue.indexOf("_") + 1));
		if (userActions == exportDataServletPath) {
			window.open(exportDataServletPath, '_self');
		} else {
			doTbl(formName, actionName, userActions, anchorName, actionName, wclhidden, wclanchor);			
		}
	}
    return result;
}
